import { isEmpty } from '../../../utils/misc/json.js';
import { renameKey } from './_helpers.js';
export default function (customData) {
    if (!customData) {
        return {};
    }
    const cd = { ...customData };
    if (isEmpty(cd)) {
        return {};
    }
    renameKey(cd, 'color', '_color');
    renameKey(cd, 'coordinates', '_position');
    renameKey(cd, 'disableNoteGravity', '_disableNoteGravity');
    renameKey(cd, 'disableNoteLook', '_disableNoteLook');
    renameKey(cd, 'flip', '_flip');
    renameKey(cd, 'localRotation', '_localRotation');
    renameKey(cd, 'noteJumpMovementSpeed', '_noteJumpMovementSpeed');
    renameKey(cd, 'noteJumpStartBeatOffset', '_noteJumpStartBeatOffset');
    renameKey(cd, 'size', '_scale');
    renameKey(cd, 'track', '_track');
    renameKey(cd, 'worldRotation', '_rotation');
    // special case
    cd._disableSpawnEffect ??= typeof cd.spawnEffect === 'boolean' ? !cd.spawnEffect : undefined;
    delete cd.spawnEffect;
    cd._interactable ??= typeof cd.uninteractable === 'boolean' ? !cd.uninteractable : undefined;
    delete cd.uninteractable;
    if (cd.animation) {
        cd._animation ??= {
            _color: cd.animation.color,
            _definitePosition: cd.animation.definitePosition,
            _dissolve: cd.animation.dissolve,
            _dissolveArrow: cd.animation.dissolveArrow,
            _interactable: cd.animation.interactable,
            _localRotation: cd.animation.localRotation,
            _position: cd.animation.offsetPosition,
            _rotation: cd.animation.offsetWorldRotation,
            _scale: cd.animation.scale,
            _time: cd.animation.time,
        };
    }
    delete cd.animation;
    return cd;
}
