import { logger } from '../../../logger.js';
function tag(name) {
    return ['convert', 'toV4Audio', name];
}
/**
 * Convert to beatmap v4.
 * ```ts
 * const converted = toV4Audio(data);
 * ```
 *
 * **WARNING:** Custom data may be lost on conversion, as well as other incompatible attributes.
 */
export function toV4AudioData(data, fromVersion = data.version) {
    logger.tWarn(tag('main'), 'Converting to beatmap v4 may lose certain data!');
    switch (fromVersion) {
        case 1:
        case 2:
        case 3:
        case 4:
            data.version = 4;
            break;
        default:
            logger.tWarn(tag('main'), 'Unknown version: version not supported; misinput? Returning original data.');
    }
    return data;
}
