import { BaseItem } from './baseItem.js';
/**
 * Basic building block of beatmap object.
 *
 * Object may exist in a beatmap as a physical object or as an event.
 *
 * @abstract
 */
export class BaseObject extends BaseItem {
    constructor() {
        super(...arguments);
        Object.defineProperty(this, "time", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 0
        });
    }
    setTime(value) {
        this.time = value;
        return this;
    }
}
