import type { GetPositionFn, MirrorFn } from '../../../types/beatmap/shared/functions.js';
import type { IWrapBaseSlider } from '../../../types/beatmap/wrapper/baseSlider.js';
import type { Vector2 } from '../../../types/vector.js';
import { BaseNote } from './baseNote.js';
/**
 * Base slider beatmap object.
 *
 * @abstract
 */
export declare abstract class BaseSlider extends BaseNote implements IWrapBaseSlider {
    tailTime: IWrapBaseSlider['tailTime'];
    tailPosX: IWrapBaseSlider['tailPosX'];
    tailPosY: IWrapBaseSlider['tailPosY'];
    tailLaneRotation: IWrapBaseSlider['tailLaneRotation'];
    setTailTime(value: this['tailTime']): this;
    setTailPosX(value: this['tailPosX']): this;
    setTailPosY(value: this['tailPosY']): this;
    setTailLaneRotation(value: this['tailLaneRotation']): this;
    mirror(flipColor?: boolean, fn?: MirrorFn<this>): this;
    getTailPosition(fn?: GetPositionFn<this>): Vector2;
    isInverse(): boolean;
}
//# sourceMappingURL=baseSlider.d.ts.map