import { BaseObject } from './baseObject.js';
/**
 * Base event box group beatmap object.
 *
 * @abstract
 */
export class EventBoxGroup extends BaseObject {
    constructor() {
        super(...arguments);
        Object.defineProperty(this, "id", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 0
        });
    }
    isValid(fn, override) {
        return override
            ? super.isValid(fn, override)
            : super.isValid(fn, override) && this.id >= 0 && this.boxes.every((e) => e.isValid());
    }
}
