import type { GenericAudioDataFilename } from '../../types/beatmap/shared/filename.js';
import type { IWrapAudioData, IWrapAudioDataBPM, IWrapAudioDataLUFS } from '../../types/beatmap/wrapper/audioData.js';
import type { IWrapBPMEvent } from '../../types/beatmap/wrapper/bpmEvent.js';
import type { DeepPartial, LooseAutocomplete } from '../../types/utils.js';
import { BaseItem } from './abstract/baseItem.js';
export declare function createAudioData(data?: DeepPartial<IWrapAudioData>): IWrapAudioData;
/**
 * Core beatmap audio data.
 *
 * This object is writable into file.
 */
export declare class AudioData extends BaseItem implements IWrapAudioData {
    static defaultValue: IWrapAudioData;
    static createOne(data?: DeepPartial<IWrapAudioData>): AudioData;
    static create(...data: DeepPartial<IWrapAudioData>[]): AudioData[];
    constructor(data?: DeepPartial<IWrapAudioData>);
    isValid(fn?: (object: this) => boolean, override?: boolean): boolean;
    version: number;
    filename: string;
    audioChecksum: string;
    sampleCount: number;
    frequency: number;
    bpmData: IWrapAudioDataBPM[];
    lufsData: IWrapAudioDataLUFS[];
    setFilename(filename: LooseAutocomplete<GenericAudioDataFilename>): this;
    setVersion(version: number): this;
    setSampleCount(value: number): this;
    setFrequency(value: number): this;
    fromBpmEvents(data: IWrapBPMEvent[], frequency?: number, sampleCount?: number): this;
    getBpmEvents(): IWrapBPMEvent[];
    sort(): this;
}
//# sourceMappingURL=audioData.d.ts.map