import { deepCopy } from '../../utils/misc/json.js';
import { BaseObject } from './abstract/baseObject.js';
export function createColorBoostEvent(data = {}) {
    return {
        time: data.time ?? 0,
        toggle: data.toggle ?? false,
        customData: deepCopy({ ...data.customData }),
    };
}
/**
 * Core beatmap color boost event.
 */
export class ColorBoostEvent extends BaseObject {
    static createOne(data = {}) {
        return new this(data);
    }
    static create(...data) {
        return data.length ? data.map((obj) => new this(obj)) : [new this()];
    }
    constructor(data = {}) {
        super();
        Object.defineProperty(this, "toggle", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.time = data.time ?? ColorBoostEvent.defaultValue.time;
        this.toggle = data.toggle ?? ColorBoostEvent.defaultValue.toggle;
        this.customData = deepCopy(data.customData ?? ColorBoostEvent.defaultValue.customData);
    }
    setToggle(value) {
        this.toggle = value;
        return this;
    }
}
Object.defineProperty(ColorBoostEvent, "defaultValue", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: createColorBoostEvent()
});
