import type { GetAngleFn, MirrorFn } from '../../types/beatmap/shared/functions.js';
import type { IWrapColorNote } from '../../types/beatmap/wrapper/colorNote.js';
import type { ICustomDataNote } from '../../types/beatmap/wrapper/custom/note.js';
import type { DeepPartial } from '../../types/utils.js';
import { BaseNote } from './abstract/baseNote.js';
export declare function createColorNote(data?: DeepPartial<IWrapColorNote>): IWrapColorNote;
/**
 * Core beatmap color note.
 */
export declare class ColorNote extends BaseNote implements IWrapColorNote {
    static defaultValue: IWrapColorNote;
    static createOne(data?: Partial<IWrapColorNote>): ColorNote;
    static create(...data: Partial<IWrapColorNote>[]): ColorNote[];
    constructor(data?: Partial<IWrapColorNote>);
    isValid(fn?: (object: this) => boolean, override?: boolean): boolean;
    angleOffset: IWrapColorNote['angleOffset'];
    customData: ICustomDataNote;
    setAngleOffset(value: this['angleOffset']): this;
    mirror(flipColor?: boolean, fn?: MirrorFn<this>): this;
    getAngle(fn?: GetAngleFn<this>): number;
}
//# sourceMappingURL=colorNote.d.ts.map