import type { IWrapArc } from '../../types/beatmap/wrapper/arc.js';
import type { IWrapBombNote } from '../../types/beatmap/wrapper/bombNote.js';
import type { IWrapBPMEvent } from '../../types/beatmap/wrapper/bpmEvent.js';
import type { IWrapChain } from '../../types/beatmap/wrapper/chain.js';
import type { IWrapColorNote } from '../../types/beatmap/wrapper/colorNote.js';
import type { IWrapDifficulty } from '../../types/beatmap/wrapper/difficulty.js';
import type { IWrapNJSEvent } from '../../types/beatmap/wrapper/njsEvent.js';
import type { IWrapObstacle } from '../../types/beatmap/wrapper/obstacle.js';
import type { IWrapRotationEvent } from '../../types/beatmap/wrapper/rotationEvent.js';
import type { DeepPartial } from '../../types/utils.js';
import { BaseItem } from './abstract/baseItem.js';
import type { BaseObject } from './abstract/baseObject.js';
import { Arc } from './arc.js';
import { BombNote } from './bombNote.js';
import { BPMEvent } from './bpmEvent.js';
import { Chain } from './chain.js';
import { ColorNote } from './colorNote.js';
import { NJSEvent } from './njsEvent.js';
import { Obstacle } from './obstacle.js';
import { RotationEvent } from './rotationEvent.js';
export declare function createDifficulty(data?: DeepPartial<IWrapDifficulty>): IWrapDifficulty;
/**
 * Core beatmap difficulty.
 */
export declare class Difficulty extends BaseItem implements IWrapDifficulty {
    static defaultValue: IWrapDifficulty;
    bpmEvents: BPMEvent[];
    rotationEvents: RotationEvent[];
    colorNotes: ColorNote[];
    bombNotes: BombNote[];
    obstacles: Obstacle[];
    arcs: Arc[];
    chains: Chain[];
    njsEvents: NJSEvent[];
    customData: IWrapDifficulty['customData'];
    static createOne(data?: DeepPartial<IWrapDifficulty>): Difficulty;
    static create(...data: DeepPartial<IWrapDifficulty>[]): Difficulty[];
    constructor(data?: DeepPartial<IWrapDifficulty>);
    reconcile(): this;
    isValid(fn?: (object: this) => boolean, override?: boolean): boolean;
    sort(): this;
    allObjects(): BaseObject[];
    addBpmEvents(...data: DeepPartial<IWrapBPMEvent>[]): this;
    addRotationEvents(...data: DeepPartial<IWrapRotationEvent>[]): this;
    addColorNotes(...data: DeepPartial<IWrapColorNote>[]): this;
    addBombNotes(...data: DeepPartial<IWrapBombNote>[]): this;
    addObstacles(...data: DeepPartial<IWrapObstacle>[]): this;
    addArcs(...data: DeepPartial<IWrapArc>[]): this;
    addChains(...data: DeepPartial<IWrapChain>[]): this;
    addNjsEvents(...data: Partial<IWrapNJSEvent>[]): this;
}
//# sourceMappingURL=difficulty.d.ts.map