import type { IWrapIndexFilter } from '../../types/beatmap/wrapper/indexFilter.js';
import type { DeepPartial } from '../../types/utils.js';
import { BaseItem } from './abstract/baseItem.js';
export declare function createIndexFilter(data?: DeepPartial<IWrapIndexFilter>): IWrapIndexFilter;
/**
 * Core beatmap index filter.
 */
export declare class IndexFilter extends BaseItem implements IWrapIndexFilter {
    static defaultValue: IWrapIndexFilter;
    static createOne(data?: Partial<IWrapIndexFilter>): IndexFilter;
    static create(...data: Partial<IWrapIndexFilter>[]): IndexFilter[];
    constructor(data?: Partial<IWrapIndexFilter>);
    type: IWrapIndexFilter['type'];
    p0: IWrapIndexFilter['p0'];
    p1: IWrapIndexFilter['p1'];
    reverse: IWrapIndexFilter['reverse'];
    chunks: IWrapIndexFilter['chunks'];
    limit: IWrapIndexFilter['limit'];
    limitAffectsType: IWrapIndexFilter['limitAffectsType'];
    random: IWrapIndexFilter['random'];
    seed: IWrapIndexFilter['seed'];
    setType(value: this['type']): this;
    setP0(value: this['p0']): this;
    setP1(value: this['p1']): this;
    setReverse(value: this['reverse']): this;
    setChunks(value: this['chunks']): this;
    setRandom(value: this['random']): this;
    setSeed(value: this['seed']): this;
    setLimit(value: this['limit']): this;
    setLimitAffectsType(value: this['limitAffectsType']): this;
    isValid(fn?: (object: this) => boolean, override?: boolean): boolean;
}
//# sourceMappingURL=indexFilter.d.ts.map