import type { IWrapLightRotationEvent } from '../../types/beatmap/wrapper/lightRotationEvent.js';
import type { DeepPartial } from '../../types/utils.js';
import { BaseObject } from './abstract/baseObject.js';
export declare function createLightRotationEvent(data?: DeepPartial<IWrapLightRotationEvent>): IWrapLightRotationEvent;
/**
 * Core beatmap light rotation event.
 */
export declare class LightRotationEvent extends BaseObject implements IWrapLightRotationEvent {
    static defaultValue: IWrapLightRotationEvent;
    static createOne(data?: Partial<IWrapLightRotationEvent>): LightRotationEvent;
    static create(...data: Partial<IWrapLightRotationEvent>[]): LightRotationEvent[];
    constructor(data?: Partial<IWrapLightRotationEvent>);
    previous: IWrapLightRotationEvent['previous'];
    easing: IWrapLightRotationEvent['easing'];
    loop: IWrapLightRotationEvent['loop'];
    rotation: IWrapLightRotationEvent['rotation'];
    direction: IWrapLightRotationEvent['direction'];
    setPrevious(value: this['previous']): this;
    setEasing(value: this['easing']): this;
    setLoop(value: this['loop']): this;
    setRotation(value: this['rotation']): this;
    setDirection(value: this['direction']): this;
    isValid(fn?: (object: this) => boolean, override?: boolean): boolean;
}
//# sourceMappingURL=lightRotationEvent.d.ts.map