import type { IWrapLightRotationEventBox } from '../../types/beatmap/wrapper/lightRotationEventBox.js';
import type { DeepPartial } from '../../types/utils.js';
import { EventBox } from './abstract/eventBox.js';
import { LightRotationEvent } from './lightRotationEvent.js';
export declare function createLightRotationEventBox(data?: DeepPartial<IWrapLightRotationEventBox>): IWrapLightRotationEventBox;
/**
 * Core beatmap light rotation event box.
 */
export declare class LightRotationEventBox extends EventBox implements IWrapLightRotationEventBox {
    static defaultValue: IWrapLightRotationEventBox;
    static createOne(data?: DeepPartial<IWrapLightRotationEventBox>): LightRotationEventBox;
    static create(...data: DeepPartial<IWrapLightRotationEventBox>[]): LightRotationEventBox[];
    constructor(data?: DeepPartial<IWrapLightRotationEventBox>);
    reconcile(): this;
    rotationDistribution: IWrapLightRotationEventBox['rotationDistribution'];
    rotationDistributionType: IWrapLightRotationEventBox['rotationDistributionType'];
    axis: IWrapLightRotationEventBox['axis'];
    flip: IWrapLightRotationEventBox['flip'];
    events: LightRotationEvent[];
    setRotationDistribution(value: this['rotationDistribution']): this;
    setRotationDistributionType(value: this['rotationDistributionType']): this;
    setAxis(value: this['axis']): this;
    setFlip(value: this['flip']): this;
    setEvents(value: this['events']): this;
    isValid(fn?: (object: this) => boolean, override?: boolean): boolean;
}
//# sourceMappingURL=lightRotationEventBox.d.ts.map