import type { IWrapLightTranslationEvent } from '../../types/beatmap/wrapper/lightTranslationEvent.js';
import { BaseObject } from './abstract/baseObject.js';
export declare function createLightTranslationEvent(data?: Partial<IWrapLightTranslationEvent>): IWrapLightTranslationEvent;
/**
 * Core beatmap light translation event.
 */
export declare class LightTranslationEvent extends BaseObject implements IWrapLightTranslationEvent {
    static defaultValue: IWrapLightTranslationEvent;
    static createOne(data?: Partial<IWrapLightTranslationEvent>): LightTranslationEvent;
    static create(...data: Partial<IWrapLightTranslationEvent>[]): LightTranslationEvent[];
    constructor(data?: Partial<IWrapLightTranslationEvent>);
    previous: IWrapLightTranslationEvent['previous'];
    easing: IWrapLightTranslationEvent['easing'];
    translation: IWrapLightTranslationEvent['translation'];
    setPrevious(value: this['previous']): this;
    setEasing(value: this['easing']): this;
    setTranslation(value: this['translation']): this;
    isValid(fn?: (object: this) => boolean, override?: boolean): boolean;
}
//# sourceMappingURL=lightTranslationEvent.d.ts.map