import type { IWrapBasicEvent } from '../../types/beatmap/wrapper/basicEvent.js';
import type { IWrapColorBoostEvent } from '../../types/beatmap/wrapper/colorBoostEvent.js';
import type { IWrapFxEventBoxGroup } from '../../types/beatmap/wrapper/fxEventBoxGroup.js';
import type { IWrapLightColorEventBoxGroup } from '../../types/beatmap/wrapper/lightColorEventBoxGroup.js';
import type { IWrapLightRotationEventBoxGroup } from '../../types/beatmap/wrapper/lightRotationEventBoxGroup.js';
import type { IWrapLightshow } from '../../types/beatmap/wrapper/lightshow.js';
import type { IWrapLightTranslationEventBoxGroup } from '../../types/beatmap/wrapper/lightTranslationEventBoxGroup.js';
import type { IWrapWaypoint } from '../../types/beatmap/wrapper/waypoint.js';
import type { DeepPartial } from '../../types/utils.js';
import { BaseItem } from './abstract/baseItem.js';
import type { BaseObject } from './abstract/baseObject.js';
import { BasicEvent } from './basicEvent.js';
import { BasicEventTypesForKeywords } from './basicEventTypesForKeywords.js';
import { ColorBoostEvent } from './colorBoostEvent.js';
import { FxEventBoxGroup } from './fxEventBoxGroup.js';
import { LightColorEventBoxGroup } from './lightColorEventBoxGroup.js';
import { LightRotationEventBoxGroup } from './lightRotationEventBoxGroup.js';
import { LightTranslationEventBoxGroup } from './lightTranslationEventBoxGroup.js';
import { Waypoint } from './waypoint.js';
export declare function createLightshow(data?: DeepPartial<IWrapLightshow>): IWrapLightshow;
/**
 * Core beatmap lightshow.
 */
export declare class Lightshow extends BaseItem implements IWrapLightshow {
    static defaultValue: IWrapLightshow;
    waypoints: Waypoint[];
    basicEvents: BasicEvent[];
    colorBoostEvents: ColorBoostEvent[];
    lightColorEventBoxGroups: LightColorEventBoxGroup[];
    lightRotationEventBoxGroups: LightRotationEventBoxGroup[];
    lightTranslationEventBoxGroups: LightTranslationEventBoxGroup[];
    fxEventBoxGroups: FxEventBoxGroup[];
    basicEventTypesWithKeywords: {
        list: BasicEventTypesForKeywords[];
    };
    useNormalEventsAsCompatibleEvents: boolean;
    static createOne(data?: DeepPartial<IWrapLightshow>): Lightshow;
    static create(...data: DeepPartial<IWrapLightshow>[]): Lightshow[];
    constructor(data?: DeepPartial<IWrapLightshow>);
    reconcile(): this;
    isValid(fn?: (object: this) => boolean, override?: boolean): boolean;
    sort(): this;
    allObjects(): BaseObject[];
    addWaypoints(...data: DeepPartial<IWrapWaypoint>[]): this;
    addBasicEvents(...data: DeepPartial<IWrapBasicEvent>[]): this;
    addColorBoostEvents(...data: DeepPartial<IWrapColorBoostEvent>[]): this;
    addLightColorEventBoxGroups(...data: DeepPartial<IWrapLightColorEventBoxGroup>[]): this;
    addLightRotationEventBoxGroups(...data: DeepPartial<IWrapLightRotationEventBoxGroup>[]): this;
    addLightTranslationEventBoxGroups(...data: DeepPartial<IWrapLightTranslationEventBoxGroup>[]): this;
    addFxEventBoxGroups(...data: DeepPartial<IWrapFxEventBoxGroup>[]): this;
}
//# sourceMappingURL=lightshow.d.ts.map