import { deepCopy } from '../../utils/misc/json.js';
import { BaseObject } from './abstract/baseObject.js';
export function createNJSEvent(data = {}) {
    return {
        time: data.time ?? 0,
        value: data.value ?? 0,
        previous: data.previous ?? 0,
        easing: data.easing ?? 0,
        customData: deepCopy({ ...data.customData }),
    };
}
/**
 * Core beatmap NJS event.
 */
export class NJSEvent extends BaseObject {
    static createOne(data = {}) {
        return new this(data);
    }
    static create(...data) {
        return data.length ? data.map((obj) => new this(obj)) : [new this()];
    }
    constructor(data = {}) {
        super();
        Object.defineProperty(this, "value", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "previous", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "easing", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.time = data.time ?? NJSEvent.defaultValue.time;
        this.value = data.value ?? NJSEvent.defaultValue.value;
        this.previous = data.previous ?? NJSEvent.defaultValue.previous;
        this.easing = data.easing ?? NJSEvent.defaultValue.easing;
        this.customData = deepCopy(data.customData ?? NJSEvent.defaultValue.customData);
    }
    setValue(value) {
        this.value = value;
        return this;
    }
    setPrevious(value) {
        this.previous = value;
        return this;
    }
    setEasing(value) {
        this.easing = value;
        return this;
    }
}
Object.defineProperty(NJSEvent, "defaultValue", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: createNJSEvent()
});
