import type { MirrorFn } from '../../types/beatmap/shared/functions.js';
import type { IWrapWaypoint } from '../../types/beatmap/wrapper/waypoint.js';
import type { DeepPartial } from '../../types/utils.js';
import { GridObject } from './abstract/gridObject.js';
export declare function createWaypoint(data?: DeepPartial<IWrapWaypoint>): IWrapWaypoint;
/**
 * Core beatmap waypoint.
 */
export declare class Waypoint extends GridObject implements IWrapWaypoint {
    static defaultValue: IWrapWaypoint;
    static createOne(data?: Partial<IWrapWaypoint>): Waypoint;
    static create(...data: Partial<IWrapWaypoint>[]): Waypoint[];
    constructor(data?: Partial<IWrapWaypoint>);
    direction: IWrapWaypoint['direction'];
    setDirection(value: this['direction']): this;
    mirror(_flipAlt?: boolean, fn?: MirrorFn<this>): this;
    isValid(fn?: (object: this) => boolean, override?: boolean): boolean;
}
//# sourceMappingURL=waypoint.d.ts.map