import { nearEqual } from '../../../utils/math/helpers.js';
import { shortRotDistance } from '../../../utils/math/trigonometry.js';
import { cycle } from '../../../utils/misc/iterator.js';
import { NoteDirection, SliderMidAnchorMode } from '../../shared/constants.js';
import { resolveNoteAngle } from './baseNote.js';
/** Mirror note color. */
export function mirrorArcMidAnchor(midAnchor) {
    return cycle([SliderMidAnchorMode.CLOCKWISE, SliderMidAnchorMode.COUNTER_CLOCKWISE], midAnchor);
}
export function midAnchorCondition(arc) {
    return (arc.midAnchor !== SliderMidAnchorMode.STRAIGHT &&
        arc.direction !== NoteDirection.ANY &&
        arc.posX === arc.posX &&
        nearEqual(shortRotDistance(resolveNoteAngle(arc.direction), resolveNoteAngle(arc.tailDirection), 360), 180));
}
