import type { EnvironmentAllName } from '../../../types/beatmap/shared/environment.js';
/** Check if event type is valid. */
export declare function isValidEventType(type: number): boolean;
/** Check if event type is a light event. */
export declare function isLightEventType(type: number, _environment?: EnvironmentAllName): boolean;
/** Check if event type is a color boost event. */
export declare function isColorBoostEventType(type: number): boolean;
/** Check if event type is a ring event. */
export declare function isRingEventType(type: number, _environment?: EnvironmentAllName): boolean;
/** Check if event type is a laser rotation event. */
export declare function isLaserRotationEventType(type: number, _environment?: EnvironmentAllName): boolean;
/** Check if event type is a lane rotation event. */
export declare function isLaneRotationEventType(type: number): boolean;
/** Check if event type is an extra event. */
export declare function isExtraEventType(type: number, _environment?: EnvironmentAllName): boolean;
/** Check if event type is a special event. */
export declare function isSpecialEventType(type: number, _environment?: EnvironmentAllName): boolean;
/** Check if event type is a BPM change. */
export declare function isBpmChangeEventType(type: number): boolean;
/** Check if event type is an NJS change. */
export declare function isNjsChangeEventType(type: number): boolean;
/** Not to be confused with isLightEvent, this checks for event that affects the environment/lighting. */
export declare function isLightingEventType(type: number): boolean;
/** Check if light event is an off event. */
export declare function isOffEventValue(value: number): boolean;
/** Check if light event is an on event. */
export declare function isOnEventValue(value: number): boolean;
/** Check if light event is a flash event. */
export declare function isFlashEventValue(value: number): boolean;
/** Check if light event is a fade event. */
export declare function isFadeEventValue(value: number): boolean;
/** Check if light event is a transition event. */
export declare function isTransitionEventValue(value: number): boolean;
/** Check if light event is a blue light. */
export declare function isBlueEventValue(value: number): boolean;
/** Check if light event is a red light. */
export declare function isRedEventValue(value: number): boolean;
/** Check if light event is a white light. */
export declare function isWhiteEventValue(value: number): boolean;
/** Check if event has old Chroma properties. */
export declare function isOldChromaEventValue(value: number): boolean;
//# sourceMappingURL=basicEvent.d.ts.map