import type { IWrapGridObject } from '../../../types/beatmap/wrapper/gridObject.js';
import type { GetPositionFn } from '../../../types/mod.js';
import type { Vector2 } from '../../../types/vector.js';
/** Get standardized grid position. */
export declare function resolveGridPosition<T extends Pick<IWrapGridObject, 'posX' | 'posY'>>(object: T): Vector2;
/** Get standardized grid distance. */
export declare function resolveGridDistance<T extends Pick<IWrapGridObject, 'posX' | 'posY'>>(o1: T, o2: T, fn?: GetPositionFn<T>): number;
/** Check if two objects are in horizontal alignment. */
export declare function isHorizontal<T extends Pick<IWrapGridObject, 'posX' | 'posY'>>(o1: T, o2: T, epsilon?: number, fn?: GetPositionFn<T>): boolean;
/** Check if two objects are in vertical alignment. */
export declare function isVertical<T extends Pick<IWrapGridObject, 'posX' | 'posY'>>(o1: T, o2: T, epsilon?: number, fn?: GetPositionFn<T>): boolean;
/** Check if two objects are in diagonal alignment. */
export declare function isDiagonal<T extends Pick<IWrapGridObject, 'posX' | 'posY'>>(o1: T, o2: T, epsilon?: number, fn?: GetPositionFn<T>): boolean;
/** Check if two objects are inline. */
export declare function isInline<T extends Pick<IWrapGridObject, 'posX' | 'posY'>>(o1: T, o2: T, lapping?: number, fn?: GetPositionFn<T>): boolean;
/** Check if two objects are adjacent. */
export declare function isAdjacent<T extends Pick<IWrapGridObject, 'posX' | 'posY'>>(o1: T, o2: T, epsilon?: number, fn?: GetPositionFn<T>): boolean;
/** Check if two objects form a "window". */
export declare function isWindow<T extends Pick<IWrapGridObject, 'posX' | 'posY'>>(o1: T, o2: T, distance?: number, fn?: GetPositionFn<T>): boolean;
/** Check if two objects form a "slanted window". */
export declare function isSlantedWindow<T extends Pick<IWrapGridObject, 'posX' | 'posY'>>(o1: T, o2: T, fn?: GetPositionFn<T>): boolean;
export declare function mirrorCoordinate(x: number, axis: number): number;
//# sourceMappingURL=gridObject.d.ts.map