import type { ICustomDataNote } from '../../../types/beatmap/wrapper/custom/note.js';
import type { ICustomDataSlider } from '../../../types/beatmap/wrapper/custom/slider.js';
import type { Vector2 } from '../../../types/vector.js';
/**
 * Get position of Noodle Extensions in beatmap v2.
 */
export declare function getNoodleExtensionsPositionV2<T extends {
    customData: Pick<ICustomDataNote, '_position'>;
}>(data: T): Vector2 | null;
/**
 * Get position of Noodle Extensions in beatmap v3.
 */
export declare function getNoodleExtensionsPositionV3<T extends {
    customData: Pick<ICustomDataNote, 'coordinates'>;
}>(data: T): Vector2 | null;
/**
 * Get tail position of Noodle Extensions in beatmap v3.
 */
export declare function getNoodleExtensionsTailPositionV3<T extends {
    customData: Pick<ICustomDataSlider, 'tailCoordinates'>;
}>(data: T): Vector2 | null;
//# sourceMappingURL=position.d.ts.map