import type { ILoadOptions } from '../../types/beatmap/options/loader.js';
import type { InferBeatmap, InferBeatmapSerial, InferBeatmapVersion } from '../../types/beatmap/shared/infer.js';
/**
 * Load beatmap info.
 * ```ts
 * const data = loadInfo(json, 4);
 * console.log(data);
 * ```
 *
 * Mismatched beatmap version will be automatically converted, unspecified will leave the version as is but not known.
 */
export declare function loadInfo<TVersion extends InferBeatmapVersion<'info'>, TWrapper extends Record<string, any> = InferBeatmap<'info'>, TSerial extends Record<string, any> = InferBeatmapSerial<'info', TVersion>>(json: TSerial, version?: TVersion | null, options?: ILoadOptions<'info', TVersion, TWrapper, TSerial>): TWrapper;
export declare function loadInfo<TVersion extends InferBeatmapVersion<'info'>, TWrapper extends Record<string, any> = InferBeatmap<'info'>, TSerial extends Record<string, any> = InferBeatmapSerial<'info', TVersion>>(json: TSerial, options?: ILoadOptions<'info', TVersion, TWrapper, TSerial>): TWrapper;
//# sourceMappingURL=info.d.ts.map