import { compatDifficulty as compatV1Difficulty } from '../schema/v1/compat/difficulty.js';
import { compatInfo as compatV1Info } from '../schema/v1/compat/info.js';
import { compatAudioData as compatV2AudioData } from '../schema/v2/compat/audioData.js';
import { compatDifficulty as compatV2Difficulty } from '../schema/v2/compat/difficulty.js';
import { compatInfo as compatV2Info } from '../schema/v2/compat/info.js';
import { compatDifficulty as compatV3Difficulty } from '../schema/v3/compat/difficulty.js';
import { compatLightshow as compatV3Lightshow } from '../schema/v3/compat/lightshow.js';
import { compatAudioData as compatV4AudioData } from '../schema/v4/compat/audioData.js';
import { compatDifficulty as compatV4Difficulty } from '../schema/v4/compat/difficulty.js';
import { compatInfo as compatV4Info } from '../schema/v4/compat/info.js';
import { compatLightshow as compatV4Lightshow } from '../schema/v4/compat/lightshow.js';
/** Compatibility function version map for beatmap info. */
export const infoCompatibilityMap = {
    1: compatV1Info,
    2: compatV2Info,
    4: compatV4Info,
};
/** Compatibility function version map for beatmap audio data. */
export const audioDataCompatibilityMap = {
    2: compatV2AudioData,
    4: compatV4AudioData,
};
/** Compatibility function version map for beatmap difficulty. */
export const difficultyCompatibilityMap = {
    1: compatV1Difficulty,
    2: compatV2Difficulty,
    3: compatV3Difficulty,
    4: compatV4Difficulty,
};
/** Compatibility function version map for beatmap lightshow. */
export const lightshowCompatibilityMap = {
    3: compatV3Lightshow,
    4: compatV4Lightshow,
};
