import type { InferBeatmap, InferBeatmapSerial, InferBeatmapVersion } from '../../types/beatmap/shared/infer.js';
import type { BeatmapFileType, ISchemaContainer } from '../../types/beatmap/shared/schema.js';
type SchemaMap<T extends BeatmapFileType> = {
    [key in InferBeatmapVersion<T>]: ISchemaContainer<InferBeatmap<T>, InferBeatmapSerial<T, key>>;
};
/** Schema version map for beatmap info. */
export declare const infoSchemaMap: SchemaMap<'info'>;
/** Schema version map for beatmap audio data. */
export declare const audioDataSchemaMap: SchemaMap<'audioData'>;
/** Schema version map for beatmap difficulty. */
export declare const difficultySchemaMap: SchemaMap<'difficulty'>;
/** Schema version map for beatmap lightshow. */
export declare const lightshowSchemaMap: SchemaMap<'lightshow'>;
export declare function serializeBeatmap<TFileType extends BeatmapFileType, TVersion extends InferBeatmapVersion<TFileType>, TWrapper extends InferBeatmap<TFileType>, TSerial extends InferBeatmapSerial<TFileType, TVersion>>(type: TFileType, ver: TVersion, data: TWrapper): TSerial;
export declare function deserializeBeatmap<TFileType extends BeatmapFileType, TVersion extends InferBeatmapVersion<TFileType>, TSerial extends InferBeatmapSerial<TFileType, TVersion>, TWrapper extends InferBeatmap<TFileType>>(type: TFileType, ver: TVersion, data: TSerial): TWrapper;
export {};
//# sourceMappingURL=schema.d.ts.map