import type { ISaveOptions } from '../../types/beatmap/options/saver.js';
import type { InferBeatmap, InferBeatmapSerial, InferBeatmapVersion } from '../../types/beatmap/shared/infer.js';
/**
 * Save beatmap difficulty.
 * ```ts
 * const json = saveDifficulty(data, 4);
 * console.log(json);
 * ```
 *
 * Mismatched beatmap version will be automatically converted, unspecified will leave the version as is but not known.
 */
export declare function saveDifficulty<TVersion extends InferBeatmapVersion<'difficulty'>, TWrapper extends Record<string, any> = InferBeatmap<'difficulty'>, TSerial extends Record<string, any> = InferBeatmapSerial<'difficulty', TVersion>>(data: TWrapper, version?: TVersion | null, options?: ISaveOptions<'difficulty', TVersion, TWrapper, TSerial>): TSerial;
export declare function saveDifficulty<TVersion extends InferBeatmapVersion<'difficulty'>, TWrapper extends Record<string, any> = InferBeatmap<'difficulty'>, TSerial extends Record<string, any> = InferBeatmapSerial<'difficulty', TVersion>>(data: TWrapper, options?: ISaveOptions<'difficulty', TVersion, TWrapper, TSerial>): TSerial;
//# sourceMappingURL=difficulty.d.ts.map