import type { ISaveOptions } from '../../types/beatmap/options/saver.js';
import type { InferBeatmap, InferBeatmapSerial, InferBeatmapVersion } from '../../types/beatmap/shared/infer.js';
/**
 * Save beatmap info.
 * ```ts
 * const json = saveInfo(data, 4);
 * console.log(json);
 * ```
 *
 * Mismatched beatmap version will be automatically converted, unspecified will leave the version as is but not known.
 */
export declare function saveInfo<TVersion extends InferBeatmapVersion<'info'>, TWrapper extends Record<string, any> = InferBeatmap<'info'>, TSerial extends Record<string, any> = InferBeatmapSerial<'info', TVersion>>(data: TWrapper, version?: TVersion | null, options?: ISaveOptions<'info', TVersion, TWrapper, TSerial>): TSerial;
export declare function saveInfo<TVersion extends InferBeatmapVersion<'info'>, TWrapper extends Record<string, any> = InferBeatmap<'info'>, TSerial extends Record<string, any> = InferBeatmapSerial<'info', TVersion>>(data: TWrapper, options?: ISaveOptions<'info', TVersion, TWrapper, TSerial>): TSerial;
//# sourceMappingURL=info.d.ts.map