import { v } from '../../../../_deps.js';
import { entity, field } from '../../helpers.js';
import { CharacteristicNameSchema, DifficultyNameSchema } from '../../shared/declaration/mod.js';
/** Schema declaration for official editor `Bookmark Element`  */
export const BookmarkElementSchema = v.object({
    beat: field(v.number(), {
        version: '1.0.0',
    }),
    label: field(v.string(), {
        version: '1.0.0',
    }),
    text: field(v.string(), {
        version: '1.0.0',
    }),
});
/** Schema declaration for official editor `Bookmark Set`  */
export const BookmarkSetSchema = entity(() => '1.0.0', {
    name: field(v.string(), {
        version: '1.0.0',
    }),
    characteristic: field(v.union([CharacteristicNameSchema, v.literal('')]), {
        version: '1.0.0',
    }),
    difficulty: field(v.union([DifficultyNameSchema, v.literal('')]), {
        version: '1.0.0',
    }),
    color: field(v.string(), {
        version: '1.0.0',
    }),
    bookmarks: field(v.array(BookmarkElementSchema), {
        version: '1.0.0',
    }),
});
