import { v } from '../../../../_deps.js';
import { Axis, CharacteristicName, DifficultyName, DifficultyRank, DistributionType, EaseType, Environment360Name, EnvironmentAllName, EnvironmentName, EnvironmentV3Name, EventBoxType, EventLightColor, EventType, ExecutionTime, FxType, IndexFilterType, LightRotationDirection, LimitAlsoAffectsType, NoteType, ObstacleType, RandomType, TransitionType, } from '../../../../types/beatmap/shared/mod.js';
import { EventLightValue, NoteColor, NoteDirection, OffsetDirection, PosX, PosY, SliderMidAnchorMode, } from '../../../shared/constants.js';
/** Schema declaration for semantic version. */
export const VersionSchema = v.pipe(v.string(), v.regex(/^(0|[1-9]\d*)\.(0|[1-9]\d*)\.(0|[1-9]\d*)$/));
/** Schema declaration for custom data. */
export const CustomDataSchema = v.record(v.string(), v.any());
/** Schema declaration for {@linkcode CharacteristicName} */
export const CharacteristicNameSchema = v.picklist(CharacteristicName);
/** Schema declaration for {@linkcode DifficultyName} */
export const DifficultyNameSchema = v.picklist(DifficultyName);
/** Schema declaration for {@linkcode DifficultyRank} */
export const DifficultyRankSchema = v.picklist(DifficultyRank);
/** Schema declaration for {@linkcode EnvironmentName} */
export const EnvironmentNameSchema = v.picklist(EnvironmentName);
/** Schema declaration for {@linkcode EnvironmentV3Name} */
export const EnvironmentV3NameSchema = v.picklist(EnvironmentV3Name);
/** Schema declaration for {@linkcode Environment360Name} */
export const Environment360NameSchema = v.picklist(Environment360Name);
/** Schema declaration for {@linkcode EnvironmentAllName} */
export const EnvironmentAllNameSchema = v.picklist(EnvironmentAllName);
/** Schema declaration for {@linkcode PosX} */
export const PosXSchema = v.enum_(PosX);
/** Schema declaration for {@linkcode PosY} */
export const PosYSchema = v.enum_(PosY);
/** Schema declaration for {@linkcode NoteColor} */
export const NoteColorSchema = v.enum_(NoteColor);
/** Schema declaration for {@linkcode NoteDirection} */
export const NoteDirectionSchema = v.enum_(NoteDirection);
/** Schema declaration for {@linkcode OffsetDirection} */
export const OffsetDirectionSchema = v.enum_(OffsetDirection);
/** Schema declaration for {@linkcode OffsetDirection} */
export const SliderMidAnchorModeSchema = v.enum_(SliderMidAnchorMode);
/** Schema declaration for {@linkcode EventLightValue} */
export const EventLightValueSchema = v.enum_(EventLightValue);
/** Schema declaration for {@linkcode EventType} */
export const EventTypeSchema = v.enum_(EventType);
/** Schema declaration for {@linkcode ExecutionTime} */
export const ExecutionTimeSchema = v.enum_(ExecutionTime);
/** Schema declaration for {@linkcode IndexFilterType} */
export const IndexFilterTypeSchema = v.enum_(IndexFilterType);
/** Schema declaration for {@linkcode LimitAlsoAffectsType} */
export const LimitAlsoAffectsTypeSchema = v.enum_(LimitAlsoAffectsType);
/** Schema declaration for {@linkcode RandomType} */
export const RandomTypeSchema = v.enum_(RandomType);
/** Schema declaration for {@linkcode DistributionType} */
export const DistributionTypeSchema = v.enum_(DistributionType);
/** Schema declaration for {@linkcode EaseType} */
export const EaseTypeSchema = v.enum_(EaseType);
/** Schema declaration for {@linkcode EventLightColor} */
export const EventLightColorSchema = v.enum_(EventLightColor);
/** Schema declaration for {@linkcode Axis} */
export const AxisSchema = v.enum_(Axis);
/** Schema declaration for {@linkcode LightRotationDirection} */
export const LightRotationDirectionSchema = v.enum_(LightRotationDirection);
/** Schema declaration for {@linkcode NoteType} */
export const NoteTypeSchema = v.enum_(NoteType);
/** Schema declaration for {@linkcode ObstacleType} */
export const ObstacleTypeSchema = v.enum_(ObstacleType);
/** Schema declaration for {@linkcode TransitionType} */
export const TransitionTypeSchema = v.enum_(TransitionType);
/** Schema declaration for {@linkcode FxType} */
export const FxTypeSchema = v.enum_(FxType);
/** Schema declaration for {@linkcode EventBoxType} */
export const EventBoxTypeSchema = v.enum_(EventBoxType);
