import { createColorNote } from '../../core/colorNote.js';
import { NoteColor } from '../../shared/constants.js';
/**
 * Schema serialization for v1 `Color Note`.
 */
export const colorNote = {
    serialize(data) {
        return {
            _time: data.time,
            _lineIndex: data.posX,
            _lineLayer: data.posY,
            _type: data.color,
            _cutDirection: data.direction,
        };
    },
    deserialize(data) {
        return createColorNote({
            time: data._time,
            posX: data._lineIndex,
            posY: data._lineLayer,
            color: [NoteColor.RED, NoteColor.BLUE][data._type ?? 0],
            direction: data._cutDirection,
        });
    },
};
