import { logger } from '../../../../logger.js';
import { tag } from './_common.js';
/**
 * Check if beatmap info is compatible with v1 `Info` schema.
 */
export function compatInfo(info, options) {
    const hasIncompat = info.audio.shufflePeriod !== 0.5 ||
        info.audio.shuffle !== 0 ||
        info.audio.audioOffset !== 0;
    if (hasIncompat) {
        if (options.throwOn.incompatibleObject) {
            throw new Error('Info is not compatible with v4');
        }
        else {
            logger.tWarn(tag('compatInfo'), 'Info is not compatible with v4, certain data may be lost!');
        }
    }
}
