import { createAudioData } from '../../core/audioData.js';
/**
 * Schema serialization for v2 `Audio Data`.
 */
export const audioData = {
    serialize(data) {
        return {
            _version: '2.0.0',
            _songSampleCount: data.sampleCount,
            _songFrequency: data.frequency,
            _regions: data.bpmData.map((bd) => ({
                _startBeat: bd.startBeat,
                _endBeat: bd.endBeat,
                _startSampleIndex: bd.startSampleIndex,
                _endSampleIndex: bd.endSampleIndex,
            })),
        };
    },
    deserialize(data, options) {
        return createAudioData({
            version: 2,
            filename: options?.filename,
            audioChecksum: options?.audioChecksum,
            sampleCount: data._songSampleCount,
            frequency: data._songFrequency,
            bpmData: data._regions?.map((bd) => ({
                startBeat: bd?._startBeat,
                endBeat: bd?._endBeat,
                startSampleIndex: bd?._startSampleIndex,
                endSampleIndex: bd?._endSampleIndex,
            })),
        });
    },
};
