import { deepCopy } from '../../../utils/misc/json.js';
import { createBasicEvent } from '../../core/basicEvent.js';
/**
 * Schema serialization for v2 `Basic Event`.
 */
export const basicEvent = {
    serialize(data) {
        return {
            _time: data.time,
            _type: data.type,
            _value: data.value,
            _floatValue: data.floatValue,
            _customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createBasicEvent({
            time: data._time,
            type: data._type,
            value: data._value,
            floatValue: data._floatValue,
            customData: data._customData,
        });
    },
};
