import { basicEventTypesForKeywords } from './basicEventTypesForKeywords.js';
/**
 * Schema serialization for v2 `Basic Event Types With Keywords`.
 */
export const basicEventTypesWithKeywords = {
    serialize(data) {
        return {
            _keywords: data.list.map((x) => {
                return basicEventTypesForKeywords.serialize(x);
            }),
        };
    },
    deserialize(data) {
        return {
            list: data._keywords?.map((x) => {
                return basicEventTypesForKeywords.deserialize(x);
            }) ?? [],
        };
    },
};
