import { deepCopy } from '../../../utils/misc/json.js';
import { createBombNote } from '../../core/bombNote.js';
/**
 * Schema serialization for v2 `Bomb Note`.
 */
export const bombNote = {
    serialize(data) {
        return {
            _time: data.time,
            _type: 3,
            _lineIndex: data.posX,
            _lineLayer: data.posY,
            _cutDirection: data.direction,
            _customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createBombNote({
            time: data._time,
            posX: data._lineIndex,
            posY: data._lineLayer,
            direction: data._cutDirection,
            customData: data._customData,
        });
    },
};
