import { deepCopy } from '../../../utils/misc/json.js';
import { createBPMEvent } from '../../core/bpmEvent.js';
/**
 * Schema serialization for v2 `BPM Event`.
 */
export const bpmEvent = {
    serialize(data) {
        return {
            _time: data.time,
            _type: 100,
            _value: 0,
            _floatValue: data.bpm,
            _customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createBPMEvent({
            time: data._time,
            bpm: data._floatValue ?? data._value,
            customData: data._customData,
        });
    },
};
