import { deepCopy } from '../../../utils/misc/json.js';
import { createColorBoostEvent } from '../../core/colorBoostEvent.js';
/**
 * Schema serialization for v2 `Color Boost Event`.
 */
export const colorBoostEvent = {
    serialize(data) {
        return {
            _time: data.time,
            _type: 5,
            _value: data.toggle ? 1 : 0,
            _floatValue: 0,
            _customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createColorBoostEvent({
            time: data._time,
            toggle: !!data._value,
            customData: data._customData,
        });
    },
};
