import { logger } from '../../../../logger.js';
import { tag } from './_common.js';
/**
 * Checks if beatmap audio data is compatible with v2 `AudioData` schema.
 */
export function compatAudioData(data, options) {
    const hasIncompat = !!data.lufsData.length;
    if (hasIncompat) {
        if (options.throwOn.incompatibleObject) {
            throw new Error('Audio data is not compatible with v2');
        }
        else {
            logger.tWarn(tag('compatAudioData'), 'Audio data is not compatible with v2, certain data may be lost!');
        }
    }
}
