import { v } from '../../../../_deps.js';
import { entity, field, mask } from '../../helpers.js';
import { VersionSchema } from '../../shared/declaration/mod.js';
/**
 * Schema declaration for v2 `BPMInfo Region`.
 */
export const BPMInfoRegionSchema = v.object({
    _startSampleIndex: field(v.pipe(v.number(), v.integer(), v.minValue(0)), {
        version: '2.0.0',
    }),
    _endSampleIndex: field(v.pipe(v.number(), v.integer(), v.minValue(0)), {
        version: '2.0.0',
    }),
    _startBeat: field(v.number(), {
        version: '2.0.0',
    }),
    _endBeat: field(v.number(), {
        version: '2.0.0',
    }),
});
/**
 * Schema declaration for v2 `BPMInfo`.
 */
export const BPMInfoSchema = entity((x) => x._version || '2.0.0', {
    _version: field(mask(VersionSchema), {
        version: '2.0.0',
    }),
    _songSampleCount: field(v.pipe(v.number(), v.integer(), v.minValue(0)), {
        version: '2.0.0',
    }),
    _songFrequency: field(v.pipe(v.number(), v.integer(), v.minValue(0)), {
        version: '2.0.0',
    }),
    _regions: field(v.array(BPMInfoRegionSchema), {
        version: '2.0.0',
    }),
});
