import { v } from '../../../../../_deps.js';
import { CustomContributorSchema } from '../../../shared/declaration/custom/contributor.js';
import { CustomColorSchemeSchema } from './colorScheme.js';
import { CustomEditorSchema } from './editor.js';
/** Schema declaration for v2 `Info` custom data. */
export const CustomDataInfoSchema = v.looseObject({
    _editors: v.optional(CustomEditorSchema),
    _contributors: v.optional(v.array(CustomContributorSchema)),
    _customEnvironment: v.optional(v.string()),
    _customEnvironmentHash: v.optional(v.string()),
});
/** Schema declaration for v2 `Info Set` custom data. */
export const CustomDataInfoSetSchema = v.looseObject({
    _characteristicLabel: v.optional(v.string()),
    _characteristicIconImageFilename: v.optional(v.string()),
});
/** Schema declaration for v2 `Info Set Difficulty` custom data. */
export const CustomDataInfoSetDifficultySchema = v.looseObject({
    ...CustomColorSchemeSchema.entries,
    _difficultyLabel: v.optional(v.string()),
    _editorOffset: v.optional(v.number()),
    _editorOldOffset: v.optional(v.number()),
    _warnings: v.optional(v.array(v.string())),
    _information: v.optional(v.array(v.string())),
    _suggestions: v.optional(v.array(v.string())),
    _requirements: v.optional(v.array(v.string())),
    _tags: v.optional(v.array(v.string())),
    _oneSaber: v.optional(v.boolean()),
    _showRotationNoteSpawnLines: v.optional(v.boolean()),
});
