import { deepCopy } from '../../../utils/misc/json.js';
import { createInfoBeatmap } from '../../core/infoBeatmap.js';
import { DifficultyRanking } from '../../shared/difficulty.js';
/**
 * Schema serialization for v2 `Info Beatmap`.
 */
export const infoBeatmap = {
    serialize(data) {
        return {
            _difficulty: data.difficulty,
            _difficultyRank: DifficultyRanking[data.difficulty],
            _beatmapFilename: data.filename,
            _noteJumpMovementSpeed: data.njs,
            _noteJumpStartBeatOffset: data.njsOffset,
            _beatmapColorSchemeIdx: data.colorSchemeId,
            _environmentNameIdx: data.environmentId,
            _customData: deepCopy(data.customData),
        };
    },
    deserialize(data, options) {
        return createInfoBeatmap({
            characteristic: options?.characteristic,
            difficulty: data._difficulty,
            authors: {
                mappers: options?.authors?.mappers,
                lighters: options?.authors?.lighters,
            },
            filename: data._beatmapFilename,
            lightshowFilename: options?.lightshowFilename,
            njs: data._noteJumpMovementSpeed,
            njsOffset: data._noteJumpStartBeatOffset,
            colorSchemeId: data._beatmapColorSchemeIdx,
            environmentId: data._environmentNameIdx,
            customData: data._customData,
        });
    },
};
