import { deepCopy } from '../../../utils/misc/json.js';
import { createWaypoint } from '../../core/waypoint.js';
/**
 * Schema serialization for v2 `Waypoint`.
 */
export const waypoint = {
    serialize(data) {
        return {
            _time: data.time,
            _lineIndex: data.posX,
            _lineLayer: data.posY,
            _offsetDirection: data.direction,
            _customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createWaypoint({
            time: data._time,
            posX: data._lineIndex,
            posY: data._lineLayer,
            direction: data._offsetDirection,
            customData: data._customData,
        });
    },
};
