import { deepCopy } from '../../../utils/misc/json.js';
import { createBasicEvent } from '../../core/basicEvent.js';
/**
 * Schema serialization for v3 `Basic Event`.
 */
export const basicEvent = {
    serialize(data) {
        return {
            b: data.time,
            et: data.type,
            i: data.value,
            f: data.floatValue,
            customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createBasicEvent({
            time: data.b,
            type: data.et,
            value: data.i,
            floatValue: data.f,
            customData: data.customData,
        });
    },
};
