import { createBasicEventTypesForKeywords } from '../../core/basicEventTypesForKeywords.js';
/**
 * Schema serialization for v3 `Basic Event Types For Keywords`.
 */
export const basicEventTypesForKeywords = {
    serialize(data) {
        return {
            k: data.keyword,
            e: data.events.map((e) => e),
        };
    },
    deserialize(data) {
        return createBasicEventTypesForKeywords({
            keyword: data.k,
            events: data.e?.map((e) => e),
        });
    },
};
