import { deepCopy } from '../../../utils/misc/json.js';
import { createBombNote } from '../../core/bombNote.js';
/**
 * Schema serialization for v3 `Bomb Note`.
 */
export const bombNote = {
    serialize(data) {
        return {
            b: data.time,
            x: data.posX,
            y: data.posY,
            customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createBombNote({
            time: data.b,
            posX: data.x,
            posY: data.y,
            customData: data.customData,
        });
    },
};
