import { deepCopy } from '../../../utils/misc/json.js';
import { createBPMEvent } from '../../core/bpmEvent.js';
/**
 * Schema serialization for v3 `BPM Event`.
 */
export const bpmEvent = {
    serialize(data) {
        return {
            b: data.time,
            m: data.bpm,
            customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createBPMEvent({
            time: data.b,
            bpm: data.m,
            customData: data.customData,
        });
    },
};
