import { deepCopy } from '../../../utils/misc/json.js';
import { createChain } from '../../core/chain.js';
/**
 * Schema serialization for v3 `Chain`.
 */
export const chain = {
    serialize(data) {
        return {
            b: data.time,
            c: data.color,
            x: data.posX,
            y: data.posY,
            d: data.direction,
            tb: data.tailTime,
            tx: data.tailPosX,
            ty: data.tailPosY,
            sc: data.sliceCount,
            s: data.squish,
            customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createChain({
            time: data.b,
            color: data.c,
            posX: data.x,
            posY: data.y,
            direction: data.d,
            tailTime: data.tb,
            tailPosX: data.tx,
            tailPosY: data.ty,
            sliceCount: data.sc,
            squish: data.s,
            customData: data.customData,
        });
    },
};
