import { deepCopy } from '../../../utils/misc/json.js';
import { createColorBoostEvent } from '../../core/colorBoostEvent.js';
/**
 * Schema serialization for v3 `Color Boost Event`.
 */
export const colorBoostEvent = {
    serialize(data) {
        return {
            b: data.time,
            o: data.toggle,
            customData: deepCopy(data.customData),
        };
    },
    deserialize(data = {}) {
        return createColorBoostEvent({
            time: data.b,
            toggle: !!data.o,
            customData: data.customData,
        });
    },
};
