import { deepCopy } from '../../../utils/misc/json.js';
import { createColorNote } from '../../core/colorNote.js';
/**
 * Schema serialization for v3 `Color Note`.
 */
export const colorNote = {
    serialize(data) {
        return {
            b: data.time,
            c: data.color,
            x: data.posX,
            y: data.posY,
            d: data.direction,
            a: data.angleOffset,
            customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createColorNote({
            time: data.b,
            posX: data.x,
            posY: data.y,
            color: data.c,
            direction: data.d,
            angleOffset: data.a,
            customData: data.customData,
        });
    },
};
