import { logger } from '../../../../logger.js';
import { hasMappingExtensionsArc, hasMappingExtensionsBombNote, hasMappingExtensionsChain, hasMappingExtensionsNote, hasMappingExtensionsObstacleV3, } from '../../../helpers/modded/has.js';
import { tag } from './_common.js';
/**
 * Checks if beatmap data is compatible with v3 `Difficulty` schema.
 */
export function compatDifficulty(bm, options) {
    const hasME = bm.difficulty.colorNotes.some(hasMappingExtensionsNote) ||
        bm.difficulty.bombNotes.some(hasMappingExtensionsBombNote) ||
        bm.difficulty.arcs.some(hasMappingExtensionsArc) ||
        bm.difficulty.chains.some(hasMappingExtensionsChain) ||
        bm.difficulty.obstacles.some(hasMappingExtensionsObstacleV3);
    if (hasME) {
        if (options.throwOn.mappingExtensions) {
            throw new Error('Beatmap contain Mapping Extensions value');
        }
        else {
            logger.tWarn(tag('compatDifficulty'), 'Beatmap contain Mapping Extensions value and require Mapping Extensions mod to function!');
        }
    }
}
