import { v } from '../../../../_deps.js';
import type { IArc, IBasicEvent, IBasicEventTypesForKeywords, IBasicEventTypesWithKeywords, IBombNote, IBPMEvent, IChain, IColorBoostEvent, IColorNote, IDifficulty, IFxEventBox, IFxEventBoxGroup, IFxEventFloat, IFxEventInt, IFxEventsCollection, IIndexFilter, ILightColorEvent, ILightColorEventBox, ILightColorEventBoxGroup, ILightRotationEvent, ILightRotationEventBox, ILightRotationEventBoxGroup, ILightTranslationEvent, ILightTranslationEventBox, ILightTranslationEventBoxGroup, IObstacle, IRotationEvent, IWaypoint } from '../../../../types/beatmap/v3/mod.js';
import { type InferObjectEntries } from '../../helpers.js';
/**
 * Schema declaration for v3 `Color Note`.
 */
export declare const ColorNoteSchema: v.ObjectSchema<InferObjectEntries<IColorNote>, undefined>;
/**
 * Schema declaration for v3 `Bomb Note`.
 */
export declare const BombNoteSchema: v.ObjectSchema<InferObjectEntries<IBombNote>, undefined>;
/**
 * Schema declaration for v3 `Arc`.
 */
export declare const ArcSchema: v.ObjectSchema<InferObjectEntries<IArc>, undefined>;
/**
 * Schema declaration for v3 `Chain`.
 */
export declare const ChainSchema: v.ObjectSchema<InferObjectEntries<IChain>, undefined>;
/**
 * Schema declaration for v3 `Obstacle`.
 */
export declare const ObstacleSchema: v.ObjectSchema<InferObjectEntries<IObstacle>, undefined>;
/**
 * Schema declaration for v3 `Waypoint`.
 */
export declare const WaypointSchema: v.ObjectSchema<InferObjectEntries<IWaypoint>, undefined>;
/**
 * Schema declaration for v3 `Basic Event`.
 */
export declare const BasicEventSchema: v.ObjectSchema<InferObjectEntries<IBasicEvent>, undefined>;
/**
 * Schema declaration for v3 `BPM Change Event`.
 */
export declare const BPMChangeEventSchema: v.ObjectSchema<InferObjectEntries<IBPMEvent>, undefined>;
/**
 * Schema declaration for v3 `Rotation Event`.
 */
export declare const RotationEventSchema: v.ObjectSchema<InferObjectEntries<IRotationEvent>, undefined>;
/**
 * Schema declaration for v3 `Color Boost Event`.
 */
export declare const ColorBoostEventSchema: v.ObjectSchema<InferObjectEntries<IColorBoostEvent>, undefined>;
/**
 * Schema declaration for v3 `Index Filter`.
 */
export declare const IndexFilterSchema: v.ObjectSchema<InferObjectEntries<IIndexFilter>, undefined>;
/**
 * Schema declaration for v3 `Light Color Event`.
 */
export declare const LightColorBaseSchema: v.ObjectSchema<InferObjectEntries<ILightColorEvent>, undefined>;
/**
 * Schema declaration for v3 `Light Color Event Box`.
 */
export declare const LightColorEventBoxSchema: v.ObjectSchema<InferObjectEntries<ILightColorEventBox>, undefined>;
/**
 * Schema declaration for v3 `Light Color Event Box Group`.
 */
export declare const LightColorEventBoxGroupSchema: v.ObjectSchema<InferObjectEntries<ILightColorEventBoxGroup>, undefined>;
/**
 * Schema declaration for v3 `Light Rotation Event`.
 */
export declare const LightRotationBaseSchema: v.ObjectSchema<InferObjectEntries<ILightRotationEvent>, undefined>;
/**
 * Schema declaration for v3 `Light Rotation Event Box`.
 */
export declare const LightRotationEventBoxSchema: v.ObjectSchema<InferObjectEntries<ILightRotationEventBox>, undefined>;
/**
 * Schema declaration for v3 `Light Rotation Event Box Group`.
 */
export declare const LightRotationEventBoxGroupSchema: v.ObjectSchema<InferObjectEntries<ILightRotationEventBoxGroup>, undefined>;
/**
 * Schema declaration for v3 `Light Translation Event`.
 */
export declare const LightTranslationBaseSchema: v.ObjectSchema<InferObjectEntries<ILightTranslationEvent>, undefined>;
/**
 * Schema declaration for v3 `Light Translation Event Box`.
 */
export declare const LightTranslationEventBoxSchema: v.ObjectSchema<InferObjectEntries<ILightTranslationEventBox>, undefined>;
/**
 * Schema declaration for v3 `Light Translation Event Box Group`.
 */
export declare const LightTranslationEventBoxGroupSchema: v.ObjectSchema<InferObjectEntries<ILightTranslationEventBoxGroup>, undefined>;
/**
 * Schema declaration for v3 `VFX Event Box`.
 */
export declare const VfxEventBoxSchema: v.ObjectSchema<InferObjectEntries<IFxEventBox>, undefined>;
/**
 * Schema declaration for v3 `VFX Event Box Group`.
 */
export declare const VfxEventBoxGroupSchema: v.ObjectSchema<InferObjectEntries<IFxEventBoxGroup>, undefined>;
/**
 * Schema declaration for v3 `Basic Event Types with Keywords`.
 */
export declare const BasicEventTypesForKeywordsSchema: v.ObjectSchema<InferObjectEntries<IBasicEventTypesForKeywords>, undefined>;
/**
 * Schema declaration for v3 `Basic Event Types with Keywords`.
 */
export declare const BasicEventTypesWithKeywordsSchema: v.ObjectSchema<InferObjectEntries<IBasicEventTypesWithKeywords>, undefined>;
/**
 * Schema declaration for v3 `FX Event Float`.
 */
export declare const FxEventFloatSchema: v.ObjectSchema<InferObjectEntries<IFxEventFloat>, undefined>;
/**
 * Schema declaration for v3 `FX Event Int`.
 */
export declare const FxEventIntSchema: v.ObjectSchema<InferObjectEntries<IFxEventInt>, undefined>;
/**
 * Schema declaration for v3 `FX Events Collection`.
 */
export declare const FxEventsCollectionSchema: v.ObjectSchema<InferObjectEntries<IFxEventsCollection>, undefined>;
/**
 * Schema declaration for v3 `Difficulty`.
 */
export declare const DifficultySchema: v.ObjectSchema<InferObjectEntries<IDifficulty>, undefined>;
//# sourceMappingURL=difficulty.d.ts.map