import { deepCopy } from '../../../utils/misc/json.js';
import { createFxEventFloat } from '../../core/fxEventFloat.js';
/**
 * Schema serialization for v3 `FX Event Float`.
 */
export const fxEventFloat = {
    serialize(data) {
        return {
            b: data.time,
            i: data.easing,
            p: data.previous,
            v: data.value,
            customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createFxEventFloat({
            time: data.b,
            easing: data.i,
            previous: data.p,
            value: data.v,
            customData: data.customData,
        });
    },
};
