import { deepCopy } from '../../../utils/misc/json.js';
import { createFxEventInt } from '../../core/fxEventInt.js';
/**
 * Schema serialization for v3 `FX Event Int`.
 */
export const fxEventInt = {
    serialize(data) {
        return {
            b: data.time,
            p: data.previous,
            v: data.value,
            customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createFxEventInt({
            time: data.b,
            previous: data.p,
            value: data.v,
            customData: data.customData,
        });
    },
};
