import { deepCopy } from '../../../utils/misc/json.js';
import { createLightColorEventBoxGroup } from '../../core/lightColorEventBoxGroup.js';
import { lightColorEventBox } from './lightColorEventBox.js';
/**
 * Schema serialization for v3 `Light Color Event Box Group`.
 */
export const lightColorEventBoxGroup = {
    serialize(data) {
        return {
            b: data.time,
            g: data.id,
            e: data.boxes.map((x) => {
                return lightColorEventBox.serialize(x);
            }),
            customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createLightColorEventBoxGroup({
            time: data.b,
            id: data.g,
            boxes: data.e?.map((x) => {
                return lightColorEventBox.deserialize(x);
            }),
            customData: data.customData,
        });
    },
};
