import { deepCopy } from '../../../utils/misc/json.js';
import { createLightRotationEvent } from '../../core/lightRotationEvent.js';
/**
 * Schema serialization for v3 `Light Rotation Event`.
 */
export const lightRotationEvent = {
    serialize(data) {
        return {
            b: data.time,
            e: data.easing,
            l: data.loop,
            o: data.direction,
            p: data.previous,
            r: data.rotation,
            customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createLightRotationEvent({
            time: data.b,
            easing: data.e,
            loop: data.l,
            direction: data.o,
            previous: data.p,
            rotation: data.r,
            customData: data.customData,
        });
    },
};
