import { deepCopy } from '../../../utils/misc/json.js';
import { createLightRotationEventBoxGroup } from '../../core/lightRotationEventBoxGroup.js';
import { lightRotationEventBox } from './lightRotationEventBox.js';
/**
 * Schema serialization for v3 `Light Rotation Event Box Group`.
 */
export const lightRotationEventBoxGroup = {
    serialize(data) {
        return {
            b: data.time,
            g: data.id,
            e: data.boxes.map((x) => {
                return lightRotationEventBox.serialize(x);
            }),
            customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createLightRotationEventBoxGroup({
            time: data.b,
            id: data.g,
            boxes: data.e?.map((x) => {
                return lightRotationEventBox.deserialize(x);
            }),
            customData: data.customData,
        });
    },
};
