import { deepCopy } from '../../../utils/misc/json.js';
import { createLightTranslationEvent } from '../../core/lightTranslationEvent.js';
/**
 * Schema serialization for v3 `Light Translation Event`.
 */
export const lightTranslationEvent = {
    serialize(data) {
        return {
            b: data.time,
            e: data.easing,
            p: data.previous,
            t: data.translation,
            customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createLightTranslationEvent({
            time: data.b,
            easing: data.e,
            previous: data.p,
            translation: data.t,
            customData: data.customData,
        });
    },
};
