import { deepCopy } from '../../../utils/misc/json.js';
import { createLightTranslationEventBoxGroup } from '../../core/lightTranslationEventBoxGroup.js';
import { lightTranslationEventBox } from './lightTranslationEventBox.js';
/**
 * Schema serialization for v3 `Light Translation Event Box Group`.
 */
export const lightTranslationEventBoxGroup = {
    serialize(data) {
        return {
            b: data.time,
            g: data.id,
            e: data.boxes.map((x) => {
                return lightTranslationEventBox.serialize(x);
            }),
            customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createLightTranslationEventBoxGroup({
            time: data.b,
            id: data.g,
            boxes: data.e?.map((x) => {
                return lightTranslationEventBox.deserialize(x);
            }),
            customData: data.customData,
        });
    },
};
