import { deepCopy } from '../../../utils/misc/json.js';
import { createObstacle } from '../../core/obstacle.js';
/**
 * Schema serialization for v3 `Obstacle`.
 */
export const obstacle = {
    serialize(data) {
        return {
            b: data.time,
            x: data.posX,
            y: data.posY,
            d: data.duration,
            w: data.width,
            h: data.height,
            customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createObstacle({
            time: data.b,
            posX: data.x,
            posY: data.y,
            duration: data.d,
            width: data.w,
            height: data.h,
            customData: data.customData,
        });
    },
};
