import { deepCopy } from '../../../utils/misc/json.js';
import { createRotationEvent } from '../../core/rotationEvent.js';
/**
 * Schema serialization for v3 `Rotation Event`.
 */
export const rotationEvent = {
    serialize(data) {
        return {
            b: data.time,
            e: data.executionTime,
            r: data.rotation,
            customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createRotationEvent({
            time: data.b,
            executionTime: data.e,
            rotation: data.r,
            customData: data.customData,
        });
    },
};
