import { deepCopy } from '../../../utils/misc/json.js';
import { createWaypoint } from '../../core/waypoint.js';
/**
 * Schema serialization for v3 `Waypoint`.
 */
export const waypoint = {
    serialize(data) {
        return {
            b: data.time,
            x: data.posX,
            y: data.posY,
            d: data.direction,
            customData: deepCopy(data.customData),
        };
    },
    deserialize(data) {
        return createWaypoint({
            time: data.b,
            posX: data.x,
            posY: data.y,
            direction: data.d,
            customData: data.customData,
        });
    },
};
