import { deepCopy } from '../../../utils/misc/json.js';
import { createBasicEvent } from '../../core/basicEvent.js';
/**
 * Schema serialization for v4 `Basic Event`.
 */
export const basicEvent = {
    serialize(data) {
        return {
            object: {
                b: data.time,
                i: 0,
                customData: {},
            },
            data: {
                t: data.type,
                i: data.value,
                f: data.floatValue,
                customData: deepCopy(data.customData),
            },
        };
    },
    deserialize(data) {
        return createBasicEvent({
            time: data.object?.b,
            type: data.data?.t,
            value: data.data?.i,
            floatValue: data.data?.f,
            customData: data.data?.customData,
        });
    },
};
