import { deepCopy } from '../../../utils/misc/json.js';
import { createColorBoostEvent } from '../../core/colorBoostEvent.js';
/**
 * Schema serialization for v4 `Color Boost Event`.
 */
export const colorBoostEvent = {
    serialize(data) {
        return {
            object: {
                b: data.time,
                i: 0,
                customData: {},
            },
            data: {
                b: data.toggle ? 1 : 0,
                customData: deepCopy(data.customData),
            },
        };
    },
    deserialize(data) {
        return createColorBoostEvent({
            time: data.object?.b,
            toggle: !!data.data?.b,
            customData: data.data?.customData,
        });
    },
};
