import { deepCopy } from '../../../utils/misc/json.js';
import { createColorNote } from '../../core/colorNote.js';
/**
 * Schema serialization for v4 `Color Note`.
 */
export const colorNote = {
    serialize(data) {
        return {
            object: {
                b: data.time,
                i: 0,
                r: data.laneRotation,
                customData: {},
            },
            data: {
                c: data.color,
                x: data.posX,
                y: data.posY,
                d: data.direction,
                a: data.angleOffset,
                customData: deepCopy(data.customData),
            },
        };
    },
    deserialize(data) {
        return createColorNote({
            time: data.object?.b,
            laneRotation: data.object?.r,
            posX: data.data?.x,
            posY: data.data?.y,
            color: data.data?.c,
            direction: data.data?.d,
            angleOffset: data.data?.a,
            customData: data.data?.customData,
        });
    },
};
