import { v } from '../../../../_deps.js';
import { field } from '../../helpers.js';
import { CustomDataSchema } from '../../shared/declaration/mod.js';
/**
 * Schema declaration for v4 `Object`.
 */
export const ObjectSchema = v.object({
    b: field(v.optional(v.number()), {
        version: '4.0.0',
    }),
    i: field(v.optional(v.pipe(v.number(), v.integer())), {
        version: '4.0.0',
    }),
    customData: field(v.optional(CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Object Lane`.
 */
export const ObjectLaneSchema = v.object({
    b: field(v.optional(v.number()), {
        version: '4.0.0',
    }),
    i: field(v.optional(v.pipe(v.number(), v.integer())), {
        version: '4.0.0',
    }),
    r: field(v.optional(v.pipe(v.number(), v.integer())), {
        version: '4.0.0',
    }),
    customData: field(v.optional(CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Object Chain`.
 */
export const ObjectChainSchema = v.object({
    hb: field(v.optional(v.number()), {
        version: '4.0.0',
    }),
    hr: field(v.optional(v.pipe(v.number(), v.integer())), {
        version: '4.0.0',
    }),
    tb: field(v.optional(v.number()), {
        version: '4.0.0',
    }),
    tr: field(v.optional(v.pipe(v.number(), v.integer())), {
        version: '4.0.0',
    }),
    i: field(v.optional(v.pipe(v.number(), v.integer())), {
        version: '4.0.0',
    }),
    ci: field(v.optional(v.pipe(v.number(), v.integer())), {
        version: '4.0.0',
    }),
    customData: field(v.optional(CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Object Arc`.
 */
export const ObjectArcSchema = v.object({
    hb: field(v.optional(v.number()), {
        version: '4.0.0',
    }),
    hi: field(v.optional(v.pipe(v.number(), v.integer())), {
        version: '4.0.0',
    }),
    hr: field(v.optional(v.pipe(v.number(), v.integer())), {
        version: '4.0.0',
    }),
    tb: field(v.optional(v.number()), {
        version: '4.0.0',
    }),
    ti: field(v.optional(v.pipe(v.number(), v.integer())), {
        version: '4.0.0',
    }),
    tr: field(v.optional(v.pipe(v.number(), v.integer())), {
        version: '4.0.0',
    }),
    ai: field(v.optional(v.pipe(v.number(), v.integer())), {
        version: '4.0.0',
    }),
    customData: field(v.optional(CustomDataSchema)),
});
