import { v } from '../../../../../_deps.js';
import { CharacteristicNameSchema, CustomContributorSchema, } from '../../../shared/declaration/mod.js';
import { CustomColorSchemeSchema, CustomEditorSchema } from '../../../v2/declaration/mod.js';
/** Schema declaration for v4 `Custom Characteristic`. */
export const CustomCharacteristicSchema = v.object({
    characteristic: CharacteristicNameSchema,
    label: v.string(),
    iconPath: v.optional(v.string()),
});
/** Schema declaration for v4 `Info` custom data. */
export const CustomDataInfoSchema = v.looseObject({
    _editors: v.optional(CustomEditorSchema),
    _contributors: v.optional(v.array(CustomContributorSchema)),
    _customEnvironment: v.optional(v.string()),
    _customEnvironmentHash: v.optional(v.string()),
    _characteristics: v.optional(v.array(CustomCharacteristicSchema)),
});
/** Schema declaration for v4 `Info Difficulty` custom data. */
export const CustomDataInfoBeatmapSchema = v.looseObject({
    ...CustomColorSchemeSchema.entries,
    _difficultyLabel: v.optional(v.string()),
    _editorOffset: v.optional(v.number()),
    _editorOldOffset: v.optional(v.number()),
    _warnings: v.optional(v.array(v.string())),
    _information: v.optional(v.array(v.string())),
    _suggestions: v.optional(v.array(v.string())),
    _requirements: v.optional(v.array(v.string())),
    _tags: v.optional(v.array(v.string())),
    _oneSaber: v.optional(v.boolean()),
    _showRotationNoteSpawnLines: v.optional(v.boolean()),
});
