import { v } from '../../../../_deps.js';
import type { IArc, IBombNote, IChain, IColorNote, IDifficulty, INJSEvent, IObstacle, ISpawnRotation } from '../../../../types/beatmap/v4/mod.js';
import { type InferObjectEntries } from '../../helpers.js';
/**
 * Schema declaration for v4 `Color Note`.
 */
export declare const ColorNoteSchema: v.ObjectSchema<InferObjectEntries<IColorNote>, undefined>;
/**
 * Schema declaration for v4 `Bomb Note`.
 */
export declare const BombNoteSchema: v.ObjectSchema<InferObjectEntries<IBombNote>, undefined>;
/**
 * Schema declaration for v4 `Obstacle`.
 */
export declare const ObstacleSchema: v.ObjectSchema<InferObjectEntries<IObstacle>, undefined>;
/**
 * Schema declaration for v4 `Chain`.
 */
export declare const ChainSchema: v.ObjectSchema<InferObjectEntries<IChain>, undefined>;
/**
 * Schema declaration for v4 `Arc`.
 */
export declare const ArcSchema: v.ObjectSchema<InferObjectEntries<IArc>, undefined>;
/**
 * Schema declaration for v4 `Spawn Rotation`.
 *
 * @deprecated removed as of 1.39, convert to `r` in object lane
 */
export declare const SpawnRotationSchema: v.ObjectSchema<InferObjectEntries<ISpawnRotation>, undefined>;
/**
 * Schema declaration for v4 `NJS Event`.
 */
export declare const NJSEventSchema: v.ObjectSchema<InferObjectEntries<INJSEvent>, undefined>;
/**
 * Schema declaration for v4 `Difficulty`.
 */
export declare const DifficultySchema: v.ObjectSchema<InferObjectEntries<IDifficulty>, undefined>;
//# sourceMappingURL=difficulty.d.ts.map