import { EventBoxType } from '../../../types/beatmap/shared/constants.js';
import { deepCopy } from '../../../utils/misc/json.js';
import { createFxEventBoxGroup } from '../../core/fxEventBoxGroup.js';
import { fxEventBox } from './fxEventBox.js';
/**
 * Schema serialization for v4 `FX Event Box Group`.
 */
export const fxEventBoxGroup = {
    serialize(data) {
        return {
            object: {
                t: EventBoxType.FX_FLOAT,
                b: data.time,
                g: data.id,
                e: [],
                customData: deepCopy(data.customData),
            },
            boxData: data.boxes.map((x) => {
                return fxEventBox.serialize(x);
            }),
        };
    },
    deserialize(data) {
        return createFxEventBoxGroup({
            time: data.object?.b,
            id: data.object?.g,
            boxes: data.boxData?.map((x) => {
                return fxEventBox.deserialize(x);
            }),
            customData: data.object?.customData,
        });
    },
};
