import { deepCopy } from '../../../utils/misc/json.js';
import { createFxEventFloat } from '../../core/fxEventFloat.js';
/**
 * Schema serialization for v4 `FX Event Float`.
 */
export const fxEventFloat = {
    serialize(data) {
        return {
            data: {
                p: data.previous,
                e: data.easing,
                v: data.value,
                customData: deepCopy(data.customData),
            },
            time: data.time,
        };
    },
    deserialize(data) {
        return createFxEventFloat({
            time: data.time,
            previous: data.data?.p,
            easing: data.data?.e,
            value: data.data?.v,
            customData: data.data?.customData,
        });
    },
};
