import { deepCopy } from '../../../utils/misc/json.js';
import { createLightColorEvent } from '../../core/lightColorEvent.js';
/**
 * Schema serialization for v4 `Light Color Event`.
 */
export const lightColorEvent = {
    serialize(data) {
        return {
            data: {
                p: data.previous,
                c: data.color,
                e: data.easing,
                b: data.brightness,
                f: data.frequency,
                sb: data.strobeBrightness,
                sf: data.strobeFade,
                customData: deepCopy(data.customData),
            },
            time: data.time,
        };
    },
    deserialize(data) {
        return createLightColorEvent({
            time: data.time,
            previous: data.data?.p,
            color: data.data?.c,
            frequency: data.data?.f,
            easing: data.data?.e,
            brightness: data.data?.b,
            strobeBrightness: data.data?.sb,
            strobeFade: data.data?.sf,
            customData: data.data?.customData,
        });
    },
};
