import { EventBoxType } from '../../../types/beatmap/shared/constants.js';
import { deepCopy } from '../../../utils/misc/json.js';
import { createLightColorEventBoxGroup } from '../../core/lightColorEventBoxGroup.js';
import { lightColorEventBox } from './lightColorEventBox.js';
/**
 * Schema serialization for v4 `Light Color Event Box Group`.
 */
export const lightColorEventBoxGroup = {
    serialize(data) {
        return {
            object: {
                t: EventBoxType.COLOR,
                b: data.time,
                g: data.id,
                e: [],
                customData: deepCopy(data.customData),
            },
            boxData: data.boxes.map((x) => {
                return lightColorEventBox.serialize(x);
            }),
        };
    },
    deserialize(data) {
        return createLightColorEventBoxGroup({
            time: data.object?.b,
            id: data.object?.g,
            boxes: data.boxData?.map((x) => {
                return lightColorEventBox.deserialize(x);
            }),
            customData: data.object?.customData,
        });
    },
};
