import { EventBoxType } from '../../../types/beatmap/shared/constants.js';
import { deepCopy } from '../../../utils/misc/json.js';
import { createLightRotationEventBoxGroup } from '../../core/lightRotationEventBoxGroup.js';
import { lightRotationEventBox } from './lightRotationEventBox.js';
/**
 * Schema serialization for v4 `Light Rotation Event Box Group`.
 */
export const lightRotationEventBoxGroup = {
    serialize(data) {
        return {
            object: {
                t: EventBoxType.ROTATION,
                b: data.time,
                g: data.id,
                e: [],
                customData: deepCopy(data.customData),
            },
            boxData: data.boxes.map((x) => {
                return lightRotationEventBox.serialize(x);
            }),
        };
    },
    deserialize(data) {
        return createLightRotationEventBoxGroup({
            time: data.object?.b,
            id: data.object?.g,
            boxes: data.boxData?.map((x) => {
                return lightRotationEventBox.deserialize(x);
            }),
            customData: data.object?.customData,
        });
    },
};
