import { deepCopy } from '../../../utils/misc/json.js';
import { createLightTranslationEvent } from '../../core/lightTranslationEvent.js';
/**
 * Schema serialization for v4 `Light Translation Event`.
 */
export const lightTranslationEvent = {
    serialize(data) {
        return {
            data: {
                p: data.previous,
                e: data.easing,
                t: data.translation,
                customData: deepCopy(data.customData),
            },
            time: data.time,
        };
    },
    deserialize(data) {
        return createLightTranslationEvent({
            time: data.time,
            previous: data.data?.p,
            easing: data.data?.e,
            translation: data.data?.t,
            customData: data.data?.customData,
        });
    },
};
