import { EventBoxType } from '../../../types/beatmap/shared/constants.js';
import { deepCopy } from '../../../utils/misc/json.js';
import { createLightTranslationEventBoxGroup } from '../../core/lightTranslationEventBoxGroup.js';
import { lightTranslationEventBox } from './lightTranslationEventBox.js';
/**
 * Schema serialization for v4 `Light Translation Event Box Group`.
 */
export const lightTranslationEventBoxGroup = {
    serialize(data) {
        return {
            object: {
                t: EventBoxType.TRANSLATION,
                b: data.time,
                g: data.id,
                e: [],
                customData: deepCopy(data.customData),
            },
            boxData: data.boxes.map((x) => {
                return lightTranslationEventBox.serialize(x);
            }),
        };
    },
    deserialize(data) {
        return createLightTranslationEventBoxGroup({
            time: data.object?.b,
            id: data.object?.g,
            boxes: data.boxData?.map((x) => {
                return lightTranslationEventBox.deserialize(x);
            }),
            customData: data.object?.customData,
        });
    },
};
