import { deepCopy } from '../../../utils/misc/json.js';
import { createNJSEvent } from '../../core/njsEvent.js';
/**
 * Schema serialization for v4 `Basic Event`.
 */
export const njsEvent = {
    serialize(data) {
        return {
            object: {
                b: data.time,
                i: 0,
                customData: {},
            },
            data: {
                d: data.value,
                p: data.previous,
                e: data.easing,
                customData: deepCopy(data.customData),
            },
        };
    },
    deserialize(data) {
        return createNJSEvent({
            time: data.object?.b,
            value: data.data?.d,
            previous: data.data?.p,
            easing: data.data?.e,
            customData: data.data?.customData,
        });
    },
};
