import { deepCopy } from '../../../utils/misc/json.js';
import { createObstacle } from '../../core/obstacle.js';
/**
 * Schema serialization for v4 `Obstacle`.
 */
export const obstacle = {
    serialize(data) {
        return {
            object: {
                b: data.time,
                i: 0,
                r: data.laneRotation,
                customData: {},
            },
            data: {
                x: data.posX,
                y: data.posY,
                d: data.duration,
                w: data.width,
                h: data.height,
                customData: deepCopy(data.customData),
            },
        };
    },
    deserialize(data) {
        return createObstacle({
            time: data.object?.b,
            laneRotation: data.object?.r,
            posX: data.data?.x,
            posY: data.data?.y,
            duration: data.data?.d,
            width: data.data?.w,
            height: data.data?.h,
            customData: data.data?.customData,
        });
    },
};
