import { deepCopy } from '../../../utils/misc/json.js';
import { createRotationEvent } from '../../core/rotationEvent.js';
/**
 * Schema serialization for v4 `Rotation Event`.
 *
 * @deprecated removed as of 1.39, convert to `r` in object lane
 */
export const rotationEvent = {
    serialize(data) {
        return {
            object: { b: data.time },
            data: {
                e: data.executionTime,
                r: data.rotation,
                customData: deepCopy(data.customData),
            },
        };
    },
    deserialize(data) {
        return createRotationEvent({
            time: data.object?.b,
            executionTime: data.data?.e,
            rotation: data.data?.r,
            customData: data.data?.customData,
        });
    },
};
