export function isFloatPointDefinition(point) {
    return isFloatPointDefinitionBase(point);
}
export function isVec3PointDefinition(point) {
    return isVec3PointDefinitionBase(point);
}
export function isVec4PointDefinition(point) {
    return isVec4PointDefinitionBase(point);
}
export function isFloatPointDefinitionBase(point) {
    return (Array.isArray(point) &&
        point.every((x) => Array.isArray(x) &&
            (x.length > 2
                ? typeof x[1] === 'number' && typeof x[2] === 'string'
                : x.length === 2 && typeof x[1] === 'number')));
}
export function isVec3PointDefinitionBase(point) {
    return (Array.isArray(point) &&
        point.every((x) => Array.isArray(x) &&
            (x.length > 4
                ? typeof x[3] === 'number' && typeof x[4] === 'string'
                : x.length === 4 && typeof x[3] === 'number')));
}
export function isVec4PointDefinitionBase(point) {
    return (Array.isArray(point) &&
        point.every((x) => Array.isArray(x) &&
            (x.length > 5
                ? typeof x[4] === 'number' && typeof x[5] === 'string'
                : x.length === 5 && typeof x[4] === 'number')));
}
export function isPointDefinitionOperand(point) {
    return (Array.isArray(point) &&
        point.some((x) => typeof x === 'string' && x.startsWith('op')));
}
