import type { IWrapBombNote } from '../../types/beatmap/wrapper/bombNote.js';
import type { IWrapColorNote } from '../../types/beatmap/wrapper/colorNote.js';
import { type ParityState, type ParityStatus } from './types/parity.js';
export declare class Parity<TColorNote extends Pick<IWrapColorNote, 'time' | 'posX' | 'posY' | 'color' | 'direction'>, TBombNote extends Pick<IWrapBombNote, 'time' | 'posX' | 'posY' | 'color'>> {
    private state;
    private color;
    private rotation;
    private position;
    private warningThreshold;
    private errorThreshold;
    private allowedRotation;
    static readonly CONSTRAINT_ROTATION: number[][];
    constructor(notes: TColorNote[], bombs: TBombNote[], type: number, warningThreshold: number, errorThreshold: number, allowedRotation: number, parity?: ParityState);
    check(noteContext: TColorNote[], bombContext: TBombNote[]): ParityStatus;
    next(noteContext: TColorNote[], bombContext: TBombNote[]): void;
    private predictStartState;
    private predictStartRotation;
    private predictStartPosition;
}
//# sourceMappingURL=parity.d.ts.map