import type { IFilter } from './types/filter.js';
import type { DeepPartial } from '../../types/utils.js';
/**
 * Query function on class object array.
 * ```ts
 * const notesFilter = where(notes, { include: { x: 2, y: [1, 0] }, exclude: { customData: ['color'] } });
 * console.log(...notesFilter);
 * ```
 */
export declare function where<T extends Record<string, any>, U extends DeepPartial<T>>(objects: T[], filter?: IFilter<U>): T[];
//# sourceMappingURL=where.d.ts.map