var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var _Globals_directory;
import { path } from './shims/path.js';
import { logger } from './logger.js';
function tag(str) {
    return ['globals', str];
}
class Globals {
    constructor() {
        _Globals_directory.set(this, './');
    }
    /**
     * Global source and destination directory.
     *
     * Input will be resolved to absolute path, otherwise uses the current working directory (CWD).
     * ```ts
     * // CWD: C:\Users\user\Scripts
     * globals.directory = '.\\Maps'; // C:\Users\user\Scripts\Maps
     * globals.directory = 'C:\\Maps'; // C:\Maps
     * ```
     * **For Windows user:** use `\\` instead of `\` in input as it is an escape character.
     *
     * This will be overriden if directory is specified elsewhere.
     */
    get directory() {
        return __classPrivateFieldGet(this, _Globals_directory, "f");
    }
    set directory(value) {
        value = path.resolve(value.trim());
        __classPrivateFieldSet(this, _Globals_directory, value, "f");
        logger.tInfo(tag('directory'), `Global map directory is set to ${__classPrivateFieldGet(this, _Globals_directory, "f")}`);
    }
}
_Globals_directory = new WeakMap();
/** Global variables. */
export const globals = new Globals();
