// deno-lint-ignore-file no-explicit-any
import { logger } from '../logger.js';
import { fs } from './fs.js';
function tag(name) {
    return ['fs', name];
}
export function readJSONFile(path) {
    logger.tInfo(tag('readJSONFile'), `Async reading JSON file from ${path}`);
    return fs.readTextFile(path).then(JSON.parse);
}
export function readJSONFileSync(path) {
    logger.tInfo(tag('readJSONFileSync'), `Sync reading JSON file from ${path}`);
    return JSON.parse(fs.readTextFileSync(path));
}
export function writeJSONFile(path, json, format) {
    logger.tInfo(tag('writeJSONFile'), `Async writing JSON file to ${path}`);
    return fs.writeTextFile(path, JSON.stringify(json, null, format));
}
export function writeJSONFileSync(path, json, format) {
    logger.tInfo(tag('writeJSONFileSync'), `Sync writing JSON file to ${path}`);
    fs.writeTextFileSync(path, JSON.stringify(json, null, format));
}
