import type { IColor } from '../../../colors.js';
import type { IContributor } from '../../shared/custom/contributor.js';
/**
 * Custom data schema for v1 info.
 */
export interface ICustomInfo {
    contributors?: IContributor[];
    customEnvironment?: string;
    customEnvironmentHash?: string;
}
/**
 * Custom data schema for v1 info difficulty.
 */
export interface ICustomInfoDifficulty {
    /**
     * **Type:** `i32`
     */
    offset?: number;
    /**
     * **Type:** `i32`
     */
    oldOffset?: number;
    chromaToggle?: string;
    customColors?: boolean;
    difficultyLabel?: string;
    colorLeft?: Omit<IColor, 'a'>;
    colorRight?: Omit<IColor, 'a'>;
    envColorLeft?: Omit<IColor, 'a'>;
    envColorRight?: Omit<IColor, 'a'>;
    obstacleColor?: Omit<IColor, 'a'>;
}
//# sourceMappingURL=info.d.ts.map