import type { IContributor } from '../../shared/custom/contributor.js';
import type { IEditor } from './editor.js';
import type { IColorScheme } from './colorScheme.js';
import type { IHeckInfoCustomData, IInfoSettingsCustomData } from './heck.js';
import type { IChromaInfoCustomData } from './chroma.js';
import type { LooseAutocomplete } from '../../../utils.js';
import type { ICustomDataBase } from '../../shared/custom/customData.js';
import type { ModRequirements, ModSuggestions } from '../../shared/modCheck.js';
import type { IVivifyCustomDataInfo } from './vivify.js';
/**
 * Custom Data interface for info.
 */
export interface ICustomDataInfo extends ICustomDataBase, IVivifyCustomDataInfo {
    _editors?: IEditor;
    _contributors?: IContributor[];
    _customEnvironment?: string;
    _customEnvironmentHash?: string;
}
/**
 * Custom Data interface for info set.
 */
export interface ICustomDataInfoSet extends ICustomDataBase {
    _characteristicLabel?: string;
    _characteristicIconImageFilename?: string;
}
type IInfoSettings = IInfoSettingsCustomData & IHeckInfoCustomData & IChromaInfoCustomData;
/**
 * Custom Data interface for info difficulty.
 */
export interface ICustomDataInfoDifficulty extends ICustomDataBase, IColorScheme, IInfoSettings {
    _difficultyLabel?: string;
    _editorOffset?: number;
    _editorOldOffset?: number;
    _warnings?: string[];
    _information?: string[];
    _suggestions?: LooseAutocomplete<ModSuggestions>[];
    _requirements?: LooseAutocomplete<ModRequirements>[];
    _tags?: string[];
    _oneSaber?: boolean;
    _showRotationNoteSpawnLines?: boolean;
}
export {};
//# sourceMappingURL=info.d.ts.map