import type { IBookmark } from './bookmark.js';
import type { IBPMChange } from './bpmChange.js';
import type { IHeckCustomData } from './heck.js';
import type { IChromaCustomData } from './chroma.js';
import type { ICustomEvent } from './customEvent.js';
import type { ICustomDataBase } from '../../shared/custom/customData.js';
import type { IPointDefinition } from './pointDefinition.js';
import type { IColorNote } from '../colorNote.js';
import type { IChain } from '../chain.js';
import type { IBombNote } from '../bombNote.js';
import type { IObstacle } from '../obstacle.js';
/**
 * Custom Data interface for difficulty file.
 */
export interface ICustomDataDifficulty extends ICustomDataBase, IHeckCustomData, IChromaCustomData {
    /**
     * Time spent in editor.
     *
     * **Type:** `f32`
     */
    time?: number;
    fakeColorNotes?: IColorNote[];
    fakeBurstSliders?: IChain[];
    fakeBombNotes?: IBombNote[];
    fakeObstacles?: IObstacle[];
    customEvents?: ICustomEvent[];
    pointDefinitions?: IPointDefinition;
    BPMChanges?: IBPMChange[];
    bookmarks?: IBookmark[];
}
//# sourceMappingURL=difficulty.d.ts.map