import type { IArc } from './arc.js';
import type { IBaseItem } from './baseItem.js';
import type { IBasicEvent } from './basicEvent.js';
import type { IBasicEventTypesWithKeywords } from './basicEventTypesWithKeywords.js';
import type { IBombNote } from './bombNote.js';
import type { IBPMEvent } from './bpmEvent.js';
import type { IChain } from './chain.js';
import type { IColorBoostEvent } from './colorBoostEvent.js';
import type { IColorNote } from './colorNote.js';
import type { ICustomDataDifficulty } from './custom/difficulty.js';
import type { IFxEventBoxGroup } from './fxEventBoxGroup.js';
import type { IFxEventsCollection } from './fxEventsCollection.js';
import type { ILightColorEventBoxGroup } from './lightColorEventBoxGroup.js';
import type { ILightRotationEventBoxGroup } from './lightRotationEventBoxGroup.js';
import type { ILightTranslationEventBoxGroup } from './lightTranslationEventBoxGroup.js';
import type { IObstacle } from './obstacle.js';
import type { IRotationEvent } from './rotationEvent.js';
import type { IWaypoint } from './waypoint.js';
/**
 * Schema for v3 `Difficulty`.
 */
export interface IDifficulty extends IBaseItem {
    version: `3.${0 | 1 | 2 | 3}.0`;
    bpmEvents?: IBPMEvent[];
    rotationEvents?: IRotationEvent[];
    colorNotes?: IColorNote[];
    bombNotes?: IBombNote[];
    obstacles?: IObstacle[];
    sliders?: IArc[];
    burstSliders?: IChain[];
    waypoints?: IWaypoint[];
    basicBeatmapEvents?: IBasicEvent[];
    colorBoostBeatmapEvents?: IColorBoostEvent[];
    lightColorEventBoxGroups?: ILightColorEventBoxGroup[];
    lightRotationEventBoxGroups?: ILightRotationEventBoxGroup[];
    lightTranslationEventBoxGroups?: ILightTranslationEventBoxGroup[];
    vfxEventBoxGroups?: IFxEventBoxGroup[];
    _fxEventsCollection?: IFxEventsCollection;
    basicEventTypesWithKeywords?: IBasicEventTypesWithKeywords;
    useNormalEventsAsCompatibleEvents?: boolean;
    customData?: ICustomDataDifficulty;
}
//# sourceMappingURL=difficulty.d.ts.map