import type { LooseAutocomplete } from '../../../utils.js';
import type { CharacteristicName } from '../../shared/characteristic.js';
import type { IContributor } from '../../shared/custom/contributor.js';
import type { ICustomDataBase } from '../../shared/custom/customData.js';
import type { ModRequirements, ModSuggestions } from '../../shared/modCheck.js';
import type { IChromaInfoCustomData } from '../../v2/custom/chroma.js';
import type { IColorScheme } from '../../v2/custom/colorScheme.js';
import type { IEditor } from '../../v2/custom/editor.js';
import type { IHeckInfoCustomData, IInfoSettingsCustomData } from '../../v2/custom/heck.js';
/**
 * Custom data schema for v4 info.
 */
export interface ICustomDataInfo extends ICustomDataBase {
    _editors?: IEditor;
    _contributors?: IContributor[];
    _customEnvironment?: string;
    _customEnvironmentHash?: string;
    _characteristics?: ICustomCharacteristic[];
}
export interface ICustomCharacteristic {
    characteristic: CharacteristicName;
    label: string;
    iconPath?: string;
}
type IInfoSettings = IInfoSettingsCustomData & IHeckInfoCustomData & IChromaInfoCustomData;
/**
 * Custom data schema for v4 info beatmap.
 */
export interface ICustomDataInfoBeatmap extends ICustomDataBase, IColorScheme, IInfoSettings {
    _difficultyLabel?: string;
    _editorOffset?: number;
    _editorOldOffset?: number;
    _warnings?: string[];
    _information?: string[];
    _suggestions?: LooseAutocomplete<ModSuggestions>[];
    _requirements?: LooseAutocomplete<ModRequirements>[];
    _tags?: string[];
    _oneSaber?: boolean;
    _showRotationNoteSpawnLines?: boolean;
}
export {};
//# sourceMappingURL=info.d.ts.map