import type { IArc } from './arc.js';
import type { IBombNote } from './bombNote.js';
import type { IChain } from './chain.js';
import type { IColorNote } from './colorNote.js';
import type { IItem } from './item.js';
import type { INJSEvent } from './njsEvent.js';
import type { IObject, IObjectArc, IObjectChain, IObjectLane } from './object.js';
import type { IObstacle } from './obstacle.js';
import type { ISpawnRotation } from './spawnRotation.js';
/**
 * Schema for v4 `Difficulty`.
 */
export interface IDifficulty extends IItem {
    version: '4.0.0' | '4.1.0';
    colorNotes?: IObjectLane[];
    colorNotesData?: IColorNote[];
    bombNotes?: IObjectLane[];
    bombNotesData?: IBombNote[];
    obstacles?: IObjectLane[];
    obstaclesData?: IObstacle[];
    chains?: IObjectChain[];
    chainsData?: IChain[];
    arcs?: IObjectArc[];
    arcsData?: IArc[];
    /** @deprecated removed as of 1.39, convert to `r` in object lane */
    spawnRotations?: IObject[];
    /** @deprecated removed as of 1.39, convert to `r` in object lane */
    spawnRotationsData?: ISpawnRotation[];
    njsEvents?: IObject[];
    njsEventData?: INJSEvent[];
}
//# sourceMappingURL=difficulty.d.ts.map