import type { EaseType } from '../../../beatmap/shared/constants.js';
import type { IWrapBaseObject } from './baseObject.js';
/**
 * Wrapper attribute for beatmap FX float event.
 */
export interface IWrapFxEventFloat extends IWrapBaseObject {
    /**
     * Relative beat time to event box group.
     *
     * **Type:** `f32`
     */
    time: number;
    /**
     * Ease type of FX event.
     *
     * **Type:** {@linkcode EaseType}
     */
    easing: EaseType;
    /**
     * Use previous event value in FX event.
     *
     * **Type:** `i32`
     */
    previous: 0 | 1;
    /**
     * Value of FX event.
     *
     * **Type:** `f32`
     */
    value: number;
}
//# sourceMappingURL=fxEventFloat.d.ts.map