import type { Vector3 } from '../../types/vector.js';
/** Convert degrees to radians. */
export declare function radToDeg(rad: number): number;
/** Convert radians to degrees. */
export declare function degToRad(deg: number): number;
/**
 * Convert cartesian coordinates to spherical coordinates.
 *
 * Return `[radius, theta, phi]`.
 */
export declare function cartesianCoordToSphericalCoord(x: number, y: number, z: number): Vector3;
/**
 * Convert spherical coordinates to cartesian coordinates.
 *
 * Return `[x, y, z]`
 */
export declare function sphericalCoordToCartesianCoord(radius: number, theta: number, phi: number): Vector3;
/**
 * Modulo function that can handle negative numbers.
 */
export declare function mod(x: number, m: number): number;
/**
 * Get the shortest distance between two angles.
 */
export declare function shortRotDistance(a: number, b: number, m: number): number;
//# sourceMappingURL=trigonometry.d.ts.map