// deno-lint-ignore-file no-explicit-any
import { saveBeatmap } from '../beatmap/saver/_main.js';
import { globals } from '../globals.js';
import { writeJSONFile, writeJSONFileSync } from '../shims/_json.js';
import { path } from '../shims/path.js';
const defaultOptions = {
    directory: '',
    filename: '',
    format: 0,
    save: {},
};
export function tag(name) {
    return ['writer', name];
}
function getFileName(type, data) {
    switch (type) {
        case 'lightshow':
            return data.lightshowFilename;
        default:
            return data.filename;
    }
}
export function handleWrite(type, data, version, options = {}) {
    const ver = typeof version === 'number' ? version : null;
    const opt = (typeof version !== 'number' ? version : options) ?? {};
    const json = saveBeatmap(type, data, ver, opt.save);
    return writeJSONFile(path.resolve(opt.directory ?? (globals.directory || defaultOptions.directory), opt.filename ?? (getFileName(type, data) || defaultOptions.filename)), json, opt.format).then(() => json);
}
export function handleWriteSync(type, data, version, options = {}) {
    const ver = typeof version === 'number' ? version : null;
    const opt = (typeof version !== 'number' ? version : options) ?? {};
    const json = saveBeatmap(type, data, ver, opt.save);
    writeJSONFileSync(path.resolve(opt.directory ?? (globals.directory || defaultOptions.directory), opt.filename ?? (getFileName(type, data) || defaultOptions.filename)), json, opt.format);
    return json;
}
