import type { InferBeatmap, InferBeatmapSerial, InferBeatmapVersion } from '../types/beatmap/shared/infer.js';
import type { IWriteOptions } from '../types/bsmap/writer.js';
/**
 * Asynchronously write beatmap audio data file.
 * ```ts
 * await writeAudioDataFile(audio, 4);
 * ```
 */
export declare function writeAudioDataFile<TVersion extends InferBeatmapVersion<'audioData'>, TWrapper extends Record<string, any> = InferBeatmap<'audioData'>, TSerial extends Record<string, any> = InferBeatmapSerial<'audioData', TVersion>>(data: TWrapper, version?: TVersion | null, options?: IWriteOptions<'audioData', TVersion, TWrapper, TSerial>): Promise<TSerial>;
export declare function writeAudioDataFile<TVersion extends InferBeatmapVersion<'audioData'>, TWrapper extends Record<string, any> = InferBeatmap<'audioData'>, TSerial extends Record<string, any> = InferBeatmapSerial<'audioData', TVersion>>(data: TWrapper, options?: IWriteOptions<'audioData', TVersion, TWrapper, TSerial>): Promise<TSerial>;
/**
 * Synchronously write beatmap audio data file.
 * ```ts
 * writeAudioDataFileSync(audio, 4);
 * ```
 */
export declare function writeAudioDataFileSync<TVersion extends InferBeatmapVersion<'audioData'>, TWrapper extends Record<string, any> = InferBeatmap<'audioData'>, TSerial extends Record<string, any> = InferBeatmapSerial<'audioData', TVersion>>(data: TWrapper, version?: TVersion | null, options?: IWriteOptions<'audioData', TVersion, TWrapper, TSerial>): TSerial;
export declare function writeAudioDataFileSync<TVersion extends InferBeatmapVersion<'audioData'>, TWrapper extends Record<string, any> = InferBeatmap<'audioData'>, TSerial extends Record<string, any> = InferBeatmapSerial<'audioData', TVersion>>(data: TWrapper, options?: IWriteOptions<'audioData', TVersion, TWrapper, TSerial>): TSerial;
//# sourceMappingURL=audioData.d.ts.map