import type { InferBeatmap, InferBeatmapSerial, InferBeatmapVersion } from '../types/beatmap/shared/infer.js';
import type { IWriteOptions } from '../types/mod.js';
/**
 * Asynchronously write beatmap difficulty file.
 * ```ts
 * await writeDifficultyFile(beatmap, 4);
 * ```
 */
export declare function writeDifficultyFile<TVersion extends InferBeatmapVersion<'difficulty'>, TWrapper extends Record<string, any> = InferBeatmap<'difficulty'>, TSerial extends Record<string, any> = InferBeatmapSerial<'difficulty', TVersion>>(data: TWrapper, version?: TVersion | null, options?: IWriteOptions<'difficulty', TVersion, TWrapper, TSerial>): Promise<TSerial>;
export declare function writeDifficultyFile<TVersion extends InferBeatmapVersion<'difficulty'>, TWrapper extends Record<string, any> = InferBeatmap<'difficulty'>, TSerial extends Record<string, any> = InferBeatmapSerial<'difficulty', TVersion>>(data: TWrapper, options?: IWriteOptions<'difficulty', TVersion, TWrapper, TSerial>): Promise<TSerial>;
/**
 * Synchronously write beatmap difficulty file.
 * ```ts
 * writeDifficultyFileSync(beatmap, 4);
 * ```
 */
export declare function writeDifficultyFileSync<TVersion extends InferBeatmapVersion<'difficulty'>, TWrapper extends Record<string, any> = InferBeatmap<'difficulty'>, TSerial extends Record<string, any> = InferBeatmapSerial<'difficulty', TVersion>>(data: TWrapper, version?: TVersion | null, options?: IWriteOptions<'difficulty', TVersion, TWrapper, TSerial>): TSerial;
export declare function writeDifficultyFileSync<TVersion extends InferBeatmapVersion<'difficulty'>, TWrapper extends Record<string, any> = InferBeatmap<'difficulty'>, TSerial extends Record<string, any> = InferBeatmapSerial<'difficulty', TVersion>>(data: TWrapper, options?: IWriteOptions<'difficulty', TVersion, TWrapper, TSerial>): TSerial;
//# sourceMappingURL=difficulty.d.ts.map