import type { InferBeatmap, InferBeatmapSerial, InferBeatmapVersion } from '../types/beatmap/shared/infer.js';
import type { IWriteOptions } from '../types/mod.js';
/**
 * Asynchronously write beatmap info file.
 * ```ts
 * await writeInfoFile(info, 4);
 * ```
 */
export declare function writeInfoFile<TVersion extends InferBeatmapVersion<'info'>, TWrapper extends Record<string, any> = InferBeatmap<'info'>, TSerial extends Record<string, any> = InferBeatmapSerial<'info', TVersion>>(data: TWrapper, version?: TVersion | null, options?: IWriteOptions<'info', TVersion, TWrapper, TSerial>): Promise<TSerial>;
export declare function writeInfoFile<TVersion extends InferBeatmapVersion<'info'>, TWrapper extends Record<string, any> = InferBeatmap<'info'>, TSerial extends Record<string, any> = InferBeatmapSerial<'info', TVersion>>(data: TWrapper, options?: IWriteOptions<'info', TVersion, TWrapper, TSerial>): Promise<TSerial>;
/**
 * Synchronously write beatmap info file.
 * ```ts
 * writeInfoFileSync(info, 4);
 * ```
 */
export declare function writeInfoFileSync<TVersion extends InferBeatmapVersion<'info'>, TWrapper extends Record<string, any> = InferBeatmap<'info'>, TSerial extends Record<string, any> = InferBeatmapSerial<'info', TVersion>>(data: TWrapper, version?: TVersion | null, options?: IWriteOptions<'info', TVersion, TWrapper, TSerial>): TSerial;
export declare function writeInfoFileSync<TVersion extends InferBeatmapVersion<'info'>, TWrapper extends Record<string, any> = InferBeatmap<'info'>, TSerial extends Record<string, any> = InferBeatmapSerial<'info', TVersion>>(data: TWrapper, options?: IWriteOptions<'info', TVersion, TWrapper, TSerial>): TSerial;
//# sourceMappingURL=info.d.ts.map