"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = default_1;
const json_js_1 = require("../../../utils/misc/json.js");
const _helpers_js_1 = require("./_helpers.js");
function default_1(customData) {
    if (!customData) {
        return {};
    }
    const cd = { ...customData };
    if ((0, json_js_1.isEmpty)(cd)) {
        return {};
    }
    (0, _helpers_js_1.renameKey)(cd, 'color', '_color');
    (0, _helpers_js_1.renameKey)(cd, 'coordinates', '_position');
    (0, _helpers_js_1.renameKey)(cd, 'disableNoteGravity', '_disableNoteGravity');
    (0, _helpers_js_1.renameKey)(cd, 'disableNoteLook', '_disableNoteLook');
    (0, _helpers_js_1.renameKey)(cd, 'flip', '_flip');
    (0, _helpers_js_1.renameKey)(cd, 'localRotation', '_localRotation');
    (0, _helpers_js_1.renameKey)(cd, 'noteJumpMovementSpeed', '_noteJumpMovementSpeed');
    (0, _helpers_js_1.renameKey)(cd, 'noteJumpStartBeatOffset', '_noteJumpStartBeatOffset');
    (0, _helpers_js_1.renameKey)(cd, 'size', '_scale');
    (0, _helpers_js_1.renameKey)(cd, 'track', '_track');
    (0, _helpers_js_1.renameKey)(cd, 'worldRotation', '_rotation');
    // special case
    cd._disableSpawnEffect ??= typeof cd.spawnEffect === 'boolean' ? !cd.spawnEffect : undefined;
    delete cd.spawnEffect;
    cd._interactable ??= typeof cd.uninteractable === 'boolean' ? !cd.uninteractable : undefined;
    delete cd.uninteractable;
    if (cd.animation) {
        cd._animation ??= {
            _color: cd.animation.color,
            _definitePosition: cd.animation.definitePosition,
            _dissolve: cd.animation.dissolve,
            _dissolveArrow: cd.animation.dissolveArrow,
            _interactable: cd.animation.interactable,
            _localRotation: cd.animation.localRotation,
            _position: cd.animation.offsetPosition,
            _rotation: cd.animation.offsetWorldRotation,
            _scale: cd.animation.scale,
            _time: cd.animation.time,
        };
    }
    delete cd.animation;
    return cd;
}
