"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = default_1;
const json_js_1 = require("../../../utils/misc/json.js");
const _helpers_js_1 = require("./_helpers.js");
function default_1(customData) {
    if (!customData) {
        return {};
    }
    const cd = { ...customData };
    if ((0, json_js_1.isEmpty)(cd)) {
        return {};
    }
    (0, _helpers_js_1.renameKey)(cd, '_color', 'color');
    (0, _helpers_js_1.renameKey)(cd, '_position', 'coordinates');
    (0, _helpers_js_1.renameKey)(cd, '_disableNoteGravity', 'disableNoteGravity');
    (0, _helpers_js_1.renameKey)(cd, '_disableNoteLook', 'disableNoteLook');
    (0, _helpers_js_1.renameKey)(cd, '_flip', 'flip');
    (0, _helpers_js_1.renameKey)(cd, '_localRotation', 'localRotation');
    (0, _helpers_js_1.renameKey)(cd, '_noteJumpMovementSpeed', 'noteJumpMovementSpeed');
    (0, _helpers_js_1.renameKey)(cd, '_noteJumpStartBeatOffset', 'noteJumpStartBeatOffset');
    (0, _helpers_js_1.renameKey)(cd, '_scale', 'size');
    (0, _helpers_js_1.renameKey)(cd, '_track', 'track');
    (0, _helpers_js_1.renameKey)(cd, '_rotation', 'worldRotation');
    // special case
    cd.spawnEffect ??= typeof cd._disableSpawnEffect === 'boolean'
        ? !cd._disableSpawnEffect
        : undefined;
    delete cd._disableSpawnEffect;
    cd.uninteractable ??= typeof cd._interactable === 'boolean' ? !cd._interactable : undefined;
    delete cd._interactable;
    if (cd._animation) {
        cd.animation ??= {
            color: cd._animation._color,
            definitePosition: cd._animation._definitePosition,
            dissolve: cd._animation._dissolve,
            dissolveArrow: cd._animation._dissolveArrow,
            interactable: cd._animation._interactable,
            localRotation: cd._animation._localRotation,
            offsetPosition: cd._animation._position,
            offsetWorldRotation: cd._animation._rotation,
            scale: cd._animation._scale,
            time: cd._animation._time,
        };
    }
    delete cd._animation;
    return cd;
}
