"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toV1Info = toV1Info;
const logger_js_1 = require("../../../logger.js");
const environment_js_1 = require("../../helpers/environment.js");
function tag(name) {
    return ['convert', 'toV1Info', name];
}
/**
 * Feeling nostalgic?
 * ```ts
 * const converted = toV1Info(data);
 * ```
 *
 * **WARNING:** Guess you should know this legacy version does not have modern features.
 */
function toV1Info(data, fromVersion = data.version) {
    logger_js_1.logger.tWarn(tag('main'), 'Converting to beatmap v1 may lose certain data!');
    switch (fromVersion) {
        case 1:
        case 2:
        case 3:
        case 4:
            data.environmentBase.normal = data.environmentBase.normal ||
                data.environmentNames.find((e) => !(0, environment_js_1.is360Environment)(e)) ||
                'DefaultEnvironment';
            data.version = 1;
            break;
        default:
            logger_js_1.logger.tWarn(tag('main'), 'Unknown version: version not supported; misinput? Returning original data.');
    }
    return data;
}
