"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toV2AudioData = toV2AudioData;
const logger_js_1 = require("../../../logger.js");
function tag(name) {
    return ['convert', 'toV2Audio', name];
}
/**
 * Convert to beatmap v2.
 * ```ts
 * const converted = toV2AudioData(data);
 * ```
 *
 * **WARNING:** Chain and other new stuff will be gone!
 */
function toV2AudioData(data, fromVersion = data.version) {
    logger_js_1.logger.tWarn(tag('main'), 'Converting to beatmap v2 may lose certain data!');
    switch (fromVersion) {
        case 1:
        case 2:
        case 3:
        case 4:
            data.version = 2;
            break;
        default:
            logger_js_1.logger.tWarn(tag('main'), 'Unknown version: version not supported; misinput? Returning original data.');
    }
    return data;
}
