"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toV2Info = toV2Info;
const logger_js_1 = require("../../../logger.js");
const environment_js_1 = require("../../helpers/environment.js");
function tag(name) {
    return ['convert', 'toV2Info', name];
}
/**
 * Convert to beatmap v2.
 * ```ts
 * const converted = toV2Info(data);
 * ```
 *
 * **WARNING:** Chain and other new stuff will be gone!
 */
function toV2Info(data, fromVersion = data.version) {
    logger_js_1.logger.tWarn(tag('main'), 'Converting to beatmap v2 may lose certain data!');
    switch (fromVersion) {
        case 1:
        case 2:
        case 3:
        case 4:
            data.environmentBase.normal = data.environmentBase.normal ||
                data.environmentNames.find((e) => !(0, environment_js_1.is360Environment)(e)) ||
                'DefaultEnvironment';
            data.environmentBase.allDirections = data.environmentBase.allDirections ||
                data.environmentNames.find((e) => (0, environment_js_1.is360Environment)(e)) ||
                'DefaultEnvironment';
            data.version = 2;
            break;
        default:
            logger_js_1.logger.tWarn(tag('main'), 'Unknown version: version not supported; misinput? Returning original data.');
    }
    return data;
}
