"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toV4AudioData = toV4AudioData;
const logger_js_1 = require("../../../logger.js");
function tag(name) {
    return ['convert', 'toV4Audio', name];
}
/**
 * Convert to beatmap v4.
 * ```ts
 * const converted = toV4Audio(data);
 * ```
 *
 * **WARNING:** Custom data may be lost on conversion, as well as other incompatible attributes.
 */
function toV4AudioData(data, fromVersion = data.version) {
    logger_js_1.logger.tWarn(tag('main'), 'Converting to beatmap v4 may lose certain data!');
    switch (fromVersion) {
        case 1:
        case 2:
        case 3:
        case 4:
            data.version = 4;
            break;
        default:
            logger_js_1.logger.tWarn(tag('main'), 'Unknown version: version not supported; misinput? Returning original data.');
    }
    return data;
}
