import type { IWrapEventBox } from '../../../types/beatmap/wrapper/eventBox.js';
import type { IndexFilter } from '../indexFilter.js';
import { BaseItem } from './baseItem.js';
import type { BaseObject } from './baseObject.js';
/**
 * Base event box beatmap object.
 *
 * @abstract
 */
export declare abstract class EventBox extends BaseItem implements IWrapEventBox {
    filter: IndexFilter;
    beatDistribution: IWrapEventBox['beatDistribution'];
    beatDistributionType: IWrapEventBox['beatDistributionType'];
    easing: IWrapEventBox['easing'];
    affectFirst: IWrapEventBox['affectFirst'];
    abstract events: BaseObject[];
    setFilter(value: IndexFilter): this;
    setBeatDistribution(value: this['beatDistribution']): this;
    setBeatDistributionType(value: this['beatDistributionType']): this;
    setEasing(value: this['easing']): this;
    setAffectFirst(value: this['affectFirst']): this;
    abstract setEvents(value: BaseObject[]): this;
    isValid(fn?: (object: this) => boolean, override?: boolean): boolean;
}
//# sourceMappingURL=eventBox.d.ts.map