"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventBox = void 0;
const baseItem_js_1 = require("./baseItem.js");
/**
 * Base event box beatmap object.
 *
 * @abstract
 */
class EventBox extends baseItem_js_1.BaseItem {
    constructor() {
        super(...arguments);
        Object.defineProperty(this, "filter", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "beatDistribution", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 0
        });
        Object.defineProperty(this, "beatDistributionType", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 1
        });
        Object.defineProperty(this, "easing", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 0
        });
        Object.defineProperty(this, "affectFirst", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 0
        });
    }
    setFilter(value) {
        this.filter = value;
        return this;
    }
    setBeatDistribution(value) {
        this.beatDistribution = value;
        return this;
    }
    setBeatDistributionType(value) {
        this.beatDistributionType = value;
        return this;
    }
    setEasing(value) {
        this.easing = value;
        return this;
    }
    setAffectFirst(value) {
        this.affectFirst = value;
        return this;
    }
    isValid(fn, override) {
        return override ? super.isValid(fn, override) : super.isValid(fn, override) &&
            (this.beatDistributionType === 1 || this.beatDistributionType === 2) &&
            this.easing >= -1 &&
            this.easing <= 103 &&
            this.events.every((e) => typeof e === 'number' || e.isValid()) &&
            this.filter.isValid();
    }
}
exports.EventBox = EventBox;
