"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BPMEvent = void 0;
exports.createBPMEvent = createBPMEvent;
const json_js_1 = require("../../utils/misc/json.js");
const baseObject_js_1 = require("./abstract/baseObject.js");
function createBPMEvent(data = {}) {
    return {
        time: data.time ?? 0,
        bpm: data.bpm ?? 0,
        customData: (0, json_js_1.deepCopy)({ ...data.customData }),
    };
}
/**
 * Core beatmap BPM event.
 */
class BPMEvent extends baseObject_js_1.BaseObject {
    static createOne(data = {}) {
        return new this(data);
    }
    static create(...data) {
        return data.length ? data.map((obj) => new this(obj)) : [new this()];
    }
    constructor(data = {}) {
        super();
        Object.defineProperty(this, "bpm", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.time = data.time ?? BPMEvent.defaultValue.time;
        this.bpm = data.bpm ?? BPMEvent.defaultValue.bpm;
        this.customData = (0, json_js_1.deepCopy)(data.customData ?? BPMEvent.defaultValue.customData);
    }
    isValid(fn, override) {
        return override ? super.isValid(fn, override) : super.isValid(fn, override) && this.bpm > 0;
    }
    setBPM(value) {
        this.bpm = value;
        return this;
    }
}
exports.BPMEvent = BPMEvent;
Object.defineProperty(BPMEvent, "defaultValue", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: createBPMEvent()
});
