"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColorBoostEvent = void 0;
exports.createColorBoostEvent = createColorBoostEvent;
const json_js_1 = require("../../utils/misc/json.js");
const baseObject_js_1 = require("./abstract/baseObject.js");
function createColorBoostEvent(data = {}) {
    return {
        time: data.time ?? 0,
        toggle: data.toggle ?? false,
        customData: (0, json_js_1.deepCopy)({ ...data.customData }),
    };
}
/**
 * Core beatmap color boost event.
 */
class ColorBoostEvent extends baseObject_js_1.BaseObject {
    static createOne(data = {}) {
        return new this(data);
    }
    static create(...data) {
        return data.length ? data.map((obj) => new this(obj)) : [new this()];
    }
    constructor(data = {}) {
        super();
        Object.defineProperty(this, "toggle", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.time = data.time ?? ColorBoostEvent.defaultValue.time;
        this.toggle = data.toggle ?? ColorBoostEvent.defaultValue.toggle;
        this.customData = (0, json_js_1.deepCopy)(data.customData ?? ColorBoostEvent.defaultValue.customData);
    }
    setToggle(value) {
        this.toggle = value;
        return this;
    }
}
exports.ColorBoostEvent = ColorBoostEvent;
Object.defineProperty(ColorBoostEvent, "defaultValue", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: createColorBoostEvent()
});
