import type { IWrapFxEventBox } from '../../types/beatmap/wrapper/fxEventBox.js';
import type { DeepPartial } from '../../types/utils.js';
import { EventBox } from './abstract/eventBox.js';
import { FxEventFloat } from './fxEventFloat.js';
export declare function createFxEventBox(data?: DeepPartial<IWrapFxEventBox>): IWrapFxEventBox;
/**
 * Core beatmap FX event box.
 */
export declare class FxEventBox extends EventBox implements IWrapFxEventBox {
    static defaultValue: IWrapFxEventBox;
    static createOne(data?: DeepPartial<IWrapFxEventBox>): FxEventBox;
    static create(...data: DeepPartial<IWrapFxEventBox>[]): FxEventBox[];
    constructor(data?: DeepPartial<IWrapFxEventBox>);
    reconcile(): this;
    fxDistribution: IWrapFxEventBox['fxDistribution'];
    fxDistributionType: IWrapFxEventBox['fxDistributionType'];
    events: FxEventFloat[];
    setFxDistribution(value: this['fxDistribution']): this;
    setFxDistributionType(value: this['fxDistributionType']): this;
    setEvents(value: this['events']): this;
    isValid(fn?: (object: this) => boolean, override?: boolean): boolean;
}
//# sourceMappingURL=fxEventBox.d.ts.map