"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FxEventBoxGroup = void 0;
exports.createFxEventBoxGroup = createFxEventBoxGroup;
const json_js_1 = require("../../utils/misc/json.js");
const misc_js_1 = require("../helpers/core/misc.js");
const eventBoxGroup_js_1 = require("./abstract/eventBoxGroup.js");
const fxEventBox_js_1 = require("./fxEventBox.js");
function createFxEventBoxGroup(data = {}) {
    return {
        time: data.time ?? 0,
        id: data.id ?? 0,
        boxes: data.boxes?.map(fxEventBox_js_1.createFxEventBox) ?? [],
        customData: (0, json_js_1.deepCopy)({ ...data.customData }),
    };
}
/**
 * Core beatmap FX event box group.
 */
class FxEventBoxGroup extends eventBoxGroup_js_1.EventBoxGroup {
    static createOne(data = {}) {
        return new this(data);
    }
    static create(...data) {
        return data.length ? data.map((obj) => new this(obj)) : [new this()];
    }
    constructor(data = {}) {
        super();
        Object.defineProperty(this, "boxes", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.time = data.time ?? FxEventBoxGroup.defaultValue.time;
        this.id = data.id ?? FxEventBoxGroup.defaultValue.id;
        this.boxes = (data.boxes ?? FxEventBoxGroup.defaultValue.boxes).map((e) => new fxEventBox_js_1.FxEventBox(e));
        this.customData = (0, json_js_1.deepCopy)(data.customData ?? FxEventBoxGroup.defaultValue.customData);
    }
    reconcile() {
        this.boxes = (0, misc_js_1.reconcileClassObject)(this.boxes, fxEventBox_js_1.FxEventBox);
        for (let j = 0; j < this.boxes.length; j++) {
            this.boxes[j].reconcile();
        }
        return this;
    }
}
exports.FxEventBoxGroup = FxEventBoxGroup;
Object.defineProperty(FxEventBoxGroup, "defaultValue", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: createFxEventBoxGroup()
});
