import type { IWrapFxEventFloat } from '../../types/beatmap/wrapper/fxEventFloat.js';
import type { DeepPartial } from '../../types/utils.js';
import { BaseObject } from './abstract/baseObject.js';
export declare function createFxEventFloat(data?: DeepPartial<IWrapFxEventFloat>): IWrapFxEventFloat;
/**
 * Core beatmap FX event float.
 */
export declare class FxEventFloat extends BaseObject implements IWrapFxEventFloat {
    static defaultValue: IWrapFxEventFloat;
    static createOne(data?: Partial<IWrapFxEventFloat>): FxEventFloat;
    static create(...data: Partial<IWrapFxEventFloat>[]): FxEventFloat[];
    constructor(data?: Partial<IWrapFxEventFloat>);
    easing: IWrapFxEventFloat['easing'];
    previous: IWrapFxEventFloat['previous'];
    value: IWrapFxEventFloat['value'];
    setEasing(value: this['easing']): this;
    setPrevious(value: this['previous']): this;
    setValue(value: this['value']): this;
    isValid(fn?: (object: this) => boolean, override?: boolean): boolean;
}
//# sourceMappingURL=fxEventFloat.d.ts.map