import type { Environment360Name, EnvironmentAllName, EnvironmentName, EnvironmentV3Name } from '../../types/beatmap/shared/environment.js';
import type { IWrapInfo, IWrapInfoAudio, IWrapInfoBeatmap, IWrapInfoColorScheme, IWrapInfoSong } from '../../types/beatmap/wrapper/info.js';
import type { DeepPartial, LooseAutocomplete } from '../../types/utils.js';
import { BaseItem } from './abstract/baseItem.js';
import { InfoBeatmap } from './infoBeatmap.js';
export declare function createInfo(data?: DeepPartial<IWrapInfo>): IWrapInfo;
/**
 * Core beatmap info.
 *
 * This object is writable into file.
 */
export declare class Info extends BaseItem implements IWrapInfo {
    static defaultValue: IWrapInfo;
    static createOne(data?: DeepPartial<IWrapInfo>): Info;
    static create(...data: DeepPartial<IWrapInfo>[]): Info[];
    constructor(data?: DeepPartial<IWrapInfo>);
    reconcile(): this;
    isValid(fn?: (object: this) => boolean, override?: boolean): boolean;
    version: number;
    filename: LooseAutocomplete<'Info.dat' | 'info.dat'>;
    song: IWrapInfoSong;
    audio: IWrapInfoAudio;
    songPreviewFilename: string;
    coverImageFilename: string;
    environmentBase: {
        normal: EnvironmentName | EnvironmentV3Name | null;
        allDirections: Environment360Name | null;
    };
    environmentNames: EnvironmentAllName[];
    colorSchemes: IWrapInfoColorScheme[];
    difficulties: InfoBeatmap[];
    clone<U extends this>(): U;
    setFilename(filename: LooseAutocomplete<'Info.dat' | 'info.dat'>): this;
    setVersion(version: number): this;
    /** Sort beatmap object(s) accordingly. */
    sort(): this;
    addMap(data: DeepPartial<IWrapInfoBeatmap>): this;
}
//# sourceMappingURL=info.d.ts.map