import type { CharacteristicName } from '../../types/beatmap/shared/characteristic.js';
import type { DifficultyName } from '../../types/beatmap/shared/difficulty.js';
import type { GenericBeatmapFilename, GenericLightshowFilename } from '../../types/beatmap/shared/filename.js';
import type { IInfoBeatmapAuthors } from '../../types/beatmap/v4/info.js';
import type { IWrapInfoBeatmap } from '../../types/beatmap/wrapper/info.js';
import type { DeepPartial, LooseAutocomplete } from '../../types/utils.js';
import { BaseItem } from './abstract/baseItem.js';
export declare function createInfoBeatmap(data?: DeepPartial<IWrapInfoBeatmap>): IWrapInfoBeatmap;
/**
 * Core beatmap info beatmap.
 */
export declare class InfoBeatmap extends BaseItem implements IWrapInfoBeatmap {
    static defaultValue: IWrapInfoBeatmap;
    static createOne(data?: DeepPartial<IWrapInfoBeatmap>): InfoBeatmap;
    static create(...data: DeepPartial<IWrapInfoBeatmap>[]): InfoBeatmap[];
    constructor(data?: DeepPartial<IWrapInfoBeatmap>);
    isValid(fn?: (object: this) => boolean, override?: boolean): boolean;
    characteristic: CharacteristicName;
    difficulty: DifficultyName;
    filename: LooseAutocomplete<GenericBeatmapFilename>;
    lightshowFilename: LooseAutocomplete<GenericLightshowFilename>;
    authors: IInfoBeatmapAuthors;
    njs: number;
    njsOffset: number;
    colorSchemeId: number;
    environmentId: number;
}
//# sourceMappingURL=infoBeatmap.d.ts.map