import type { IWrapLightColorEvent } from '../../types/beatmap/wrapper/lightColorEvent.js';
import type { DeepPartial } from '../../types/utils.js';
import { BaseObject } from './abstract/baseObject.js';
export declare function createLightColorEvent(data?: DeepPartial<IWrapLightColorEvent>): IWrapLightColorEvent;
/**
 * Core beatmap light color event.
 */
export declare class LightColorEvent extends BaseObject implements IWrapLightColorEvent {
    static defaultValue: IWrapLightColorEvent;
    static createOne(data?: Partial<IWrapLightColorEvent>): LightColorEvent;
    static create(...data: Partial<IWrapLightColorEvent>[]): LightColorEvent[];
    constructor(data?: Partial<IWrapLightColorEvent>);
    previous: IWrapLightColorEvent['previous'];
    color: IWrapLightColorEvent['color'];
    brightness: IWrapLightColorEvent['brightness'];
    frequency: IWrapLightColorEvent['frequency'];
    strobeBrightness: IWrapLightColorEvent['strobeBrightness'];
    strobeFade: IWrapLightColorEvent['strobeFade'];
    easing: IWrapLightColorEvent['easing'];
    setPrevious(value: this['previous']): this;
    setColor(value: this['color']): this;
    setBrightness(value: this['brightness']): this;
    setFrequency(value: this['frequency']): this;
    setStrobeBrightness(value: this['strobeBrightness']): this;
    setStrobeFade(value: this['strobeFade']): this;
    setEasing(value: this['easing']): this;
    isValid(fn?: (object: this) => boolean, override?: boolean): boolean;
}
//# sourceMappingURL=lightColorEvent.d.ts.map