import type { IWrapLightColorEventBox } from '../../types/beatmap/wrapper/lightColorEventBox.js';
import type { DeepPartial } from '../../types/utils.js';
import { EventBox } from './abstract/eventBox.js';
import { LightColorEvent } from './lightColorEvent.js';
export declare function createLightColorEventBox(data?: DeepPartial<IWrapLightColorEventBox>): IWrapLightColorEventBox;
/**
 * Core beatmap light color event box.
 */
export declare class LightColorEventBox extends EventBox implements IWrapLightColorEventBox {
    static defaultValue: IWrapLightColorEventBox;
    static createOne(data?: DeepPartial<IWrapLightColorEventBox>): LightColorEventBox;
    static create(...data: DeepPartial<IWrapLightColorEventBox>[]): LightColorEventBox[];
    constructor(data?: DeepPartial<IWrapLightColorEventBox>);
    reconcile(): this;
    brightnessDistribution: IWrapLightColorEventBox['brightnessDistribution'];
    brightnessDistributionType: IWrapLightColorEventBox['brightnessDistributionType'];
    events: LightColorEvent[];
    setBrightnessDistribution(value: this['brightnessDistribution']): this;
    setBrightnessDistributionType(value: this['brightnessDistributionType']): this;
    setEvents(value: this['events']): this;
    isValid(fn?: (object: this) => boolean, override?: boolean): boolean;
}
//# sourceMappingURL=lightColorEventBox.d.ts.map