"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LightColorEventBoxGroup = void 0;
exports.createLightColorEventBoxGroup = createLightColorEventBoxGroup;
const json_js_1 = require("../../utils/misc/json.js");
const misc_js_1 = require("../helpers/core/misc.js");
const eventBoxGroup_js_1 = require("./abstract/eventBoxGroup.js");
const lightColorEventBox_js_1 = require("./lightColorEventBox.js");
function createLightColorEventBoxGroup(data = {}) {
    return {
        time: data.time ?? 0,
        id: data.id ?? 0,
        boxes: data.boxes?.map((e) => (0, lightColorEventBox_js_1.createLightColorEventBox)(e)) ?? [],
        customData: (0, json_js_1.deepCopy)({ ...data.customData }),
    };
}
/**
 * Core beatmap light color event box group.
 */
class LightColorEventBoxGroup extends eventBoxGroup_js_1.EventBoxGroup {
    static createOne(data = {}) {
        return new this(data);
    }
    static create(...data) {
        return data.length ? data.map((obj) => new this(obj)) : [new this()];
    }
    constructor(data = {}) {
        super();
        Object.defineProperty(this, "boxes", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.time = data.time ?? LightColorEventBoxGroup.defaultValue.time;
        this.id = data.id ?? LightColorEventBoxGroup.defaultValue.id;
        this.boxes = (data.boxes ?? LightColorEventBoxGroup.defaultValue.boxes).map((e) => new lightColorEventBox_js_1.LightColorEventBox(e));
        this.customData = (0, json_js_1.deepCopy)(data.customData ?? LightColorEventBoxGroup.defaultValue.customData);
    }
    reconcile() {
        this.boxes = (0, misc_js_1.reconcileClassObject)(this.boxes, lightColorEventBox_js_1.LightColorEventBox);
        for (let j = 0; j < this.boxes.length; j++) {
            this.boxes[j].reconcile();
        }
        return this;
    }
}
exports.LightColorEventBoxGroup = LightColorEventBoxGroup;
Object.defineProperty(LightColorEventBoxGroup, "defaultValue", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: createLightColorEventBoxGroup()
});
