"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LightRotationEventBoxGroup = void 0;
exports.createLightRotationEventBoxGroup = createLightRotationEventBoxGroup;
const json_js_1 = require("../../utils/misc/json.js");
const misc_js_1 = require("../helpers/core/misc.js");
const eventBoxGroup_js_1 = require("./abstract/eventBoxGroup.js");
const lightRotationEventBox_js_1 = require("./lightRotationEventBox.js");
function createLightRotationEventBoxGroup(data = {}) {
    return {
        time: data.time ?? 0,
        id: data.id ?? 0,
        boxes: data.boxes?.map((e) => (0, lightRotationEventBox_js_1.createLightRotationEventBox)(e)) ?? [],
        customData: (0, json_js_1.deepCopy)({ ...data.customData }),
    };
}
/**
 * Core beatmap light rotation event box group.
 */
class LightRotationEventBoxGroup extends eventBoxGroup_js_1.EventBoxGroup {
    static createOne(data = {}) {
        return new this(data);
    }
    static create(...data) {
        return data.length ? data.map((obj) => new this(obj)) : [new this()];
    }
    constructor(data = {}) {
        super();
        Object.defineProperty(this, "boxes", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.time = data.time ?? LightRotationEventBoxGroup.defaultValue.time;
        this.id = data.id ?? LightRotationEventBoxGroup.defaultValue.id;
        this.boxes = (data.boxes ?? LightRotationEventBoxGroup.defaultValue.boxes).map((e) => new lightRotationEventBox_js_1.LightRotationEventBox(e));
        this.customData = (0, json_js_1.deepCopy)(data.customData ?? LightRotationEventBoxGroup.defaultValue.customData);
    }
    reconcile() {
        this.boxes = (0, misc_js_1.reconcileClassObject)(this.boxes, lightRotationEventBox_js_1.LightRotationEventBox);
        for (let j = 0; j < this.boxes.length; j++) {
            this.boxes[j].reconcile();
        }
        return this;
    }
}
exports.LightRotationEventBoxGroup = LightRotationEventBoxGroup;
Object.defineProperty(LightRotationEventBoxGroup, "defaultValue", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: createLightRotationEventBoxGroup()
});
