import type { IWrapLightTranslationEventBox } from '../../types/beatmap/wrapper/lightTranslationEventBox.js';
import type { DeepPartial } from '../../types/utils.js';
import { EventBox } from './abstract/eventBox.js';
import { LightTranslationEvent } from './lightTranslationEvent.js';
export declare function createLightTranslationEventBox(data?: DeepPartial<IWrapLightTranslationEventBox>): IWrapLightTranslationEventBox;
/**
 * Core beatmap light translation event box.
 */
export declare class LightTranslationEventBox extends EventBox implements IWrapLightTranslationEventBox {
    static defaultValue: IWrapLightTranslationEventBox;
    static createOne(data?: DeepPartial<IWrapLightTranslationEventBox>): LightTranslationEventBox;
    static create(...data: DeepPartial<IWrapLightTranslationEventBox>[]): LightTranslationEventBox[];
    constructor(data?: DeepPartial<IWrapLightTranslationEventBox>);
    reconcile(): this;
    gapDistribution: IWrapLightTranslationEventBox['gapDistribution'];
    gapDistributionType: IWrapLightTranslationEventBox['gapDistributionType'];
    axis: IWrapLightTranslationEventBox['axis'];
    flip: IWrapLightTranslationEventBox['flip'];
    events: LightTranslationEvent[];
    setGapDistribution(value: this['gapDistribution']): this;
    setGapDistributionType(value: this['gapDistributionType']): this;
    setAxis(value: this['axis']): this;
    setFlip(value: this['flip']): this;
    setEvents(value: this['events']): this;
    isValid(fn?: (object: this) => boolean, override?: boolean): boolean;
}
//# sourceMappingURL=lightTranslationEventBox.d.ts.map