"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LightTranslationEventBoxGroup = void 0;
exports.createLightTranslationEventBoxGroup = createLightTranslationEventBoxGroup;
const json_js_1 = require("../../utils/misc/json.js");
const misc_js_1 = require("../helpers/core/misc.js");
const eventBoxGroup_js_1 = require("./abstract/eventBoxGroup.js");
const lightTranslationEventBox_js_1 = require("./lightTranslationEventBox.js");
function createLightTranslationEventBoxGroup(data = {}) {
    return {
        time: data.time ?? 0,
        id: data.id ?? 0,
        boxes: data.boxes?.map((e) => (0, lightTranslationEventBox_js_1.createLightTranslationEventBox)(e)) ?? [],
        customData: (0, json_js_1.deepCopy)({ ...data.customData }),
    };
}
/**
 * Core beatmap light translation event box group.
 */
class LightTranslationEventBoxGroup extends eventBoxGroup_js_1.EventBoxGroup {
    static createOne(data = {}) {
        return new this(data);
    }
    static create(...data) {
        return data.length ? data.map((obj) => new this(obj)) : [new this()];
    }
    constructor(data = {}) {
        super();
        Object.defineProperty(this, "boxes", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.time = data.time ?? LightTranslationEventBoxGroup.defaultValue.time;
        this.id = data.id ?? LightTranslationEventBoxGroup.defaultValue.id;
        this.boxes = (data.boxes ?? LightTranslationEventBoxGroup.defaultValue.boxes).map((e) => new lightTranslationEventBox_js_1.LightTranslationEventBox(e));
        this.customData = (0, json_js_1.deepCopy)(data.customData ??
            LightTranslationEventBoxGroup.defaultValue.customData);
    }
    reconcile() {
        this.boxes = (0, misc_js_1.reconcileClassObject)(this.boxes, lightTranslationEventBox_js_1.LightTranslationEventBox);
        for (let j = 0; j < this.boxes.length; j++) {
            this.boxes[j].reconcile();
        }
        return this;
    }
}
exports.LightTranslationEventBoxGroup = LightTranslationEventBoxGroup;
Object.defineProperty(LightTranslationEventBoxGroup, "defaultValue", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: createLightTranslationEventBoxGroup()
});
