import type { IWrapNJSEvent } from '../../types/beatmap/wrapper/njsEvent.js';
import type { DeepPartial } from '../../types/utils.js';
import { BaseObject } from './abstract/baseObject.js';
export declare function createNJSEvent(data?: DeepPartial<IWrapNJSEvent>): IWrapNJSEvent;
/**
 * Core beatmap NJS event.
 */
export declare class NJSEvent extends BaseObject implements IWrapNJSEvent {
    static defaultValue: IWrapNJSEvent;
    static createOne(data?: Partial<IWrapNJSEvent>): NJSEvent;
    static create(...data: Partial<IWrapNJSEvent>[]): NJSEvent[];
    constructor(data?: Partial<IWrapNJSEvent>);
    value: IWrapNJSEvent['value'];
    previous: IWrapNJSEvent['previous'];
    easing: IWrapNJSEvent['easing'];
    setValue(value: this['value']): this;
    setPrevious(value: this['previous']): this;
    setEasing(value: this['easing']): this;
}
//# sourceMappingURL=njsEvent.d.ts.map