"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NJSEvent = void 0;
exports.createNJSEvent = createNJSEvent;
const json_js_1 = require("../../utils/misc/json.js");
const baseObject_js_1 = require("./abstract/baseObject.js");
function createNJSEvent(data = {}) {
    return {
        time: data.time ?? 0,
        value: data.value ?? 0,
        previous: data.previous ?? 0,
        easing: data.easing ?? 0,
        customData: (0, json_js_1.deepCopy)({ ...data.customData }),
    };
}
/**
 * Core beatmap NJS event.
 */
class NJSEvent extends baseObject_js_1.BaseObject {
    static createOne(data = {}) {
        return new this(data);
    }
    static create(...data) {
        return data.length ? data.map((obj) => new this(obj)) : [new this()];
    }
    constructor(data = {}) {
        super();
        Object.defineProperty(this, "value", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "previous", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "easing", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.time = data.time ?? NJSEvent.defaultValue.time;
        this.value = data.value ?? NJSEvent.defaultValue.value;
        this.previous = data.previous ?? NJSEvent.defaultValue.previous;
        this.easing = data.easing ?? NJSEvent.defaultValue.easing;
        this.customData = (0, json_js_1.deepCopy)(data.customData ?? NJSEvent.defaultValue.customData);
    }
    setValue(value) {
        this.value = value;
        return this;
    }
    setPrevious(value) {
        this.previous = value;
        return this;
    }
    setEasing(value) {
        this.easing = value;
        return this;
    }
}
exports.NJSEvent = NJSEvent;
Object.defineProperty(NJSEvent, "defaultValue", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: createNJSEvent()
});
