import type { IWrapRotationEvent } from '../../types/beatmap/wrapper/rotationEvent.js';
import type { DeepPartial } from '../../types/utils.js';
import { BaseObject } from './abstract/baseObject.js';
export declare function createRotationEvent(data?: DeepPartial<IWrapRotationEvent>): IWrapRotationEvent;
/**
 * Core beatmap rotation event.
 */
export declare class RotationEvent extends BaseObject implements IWrapRotationEvent {
    static defaultValue: IWrapRotationEvent;
    static createOne(data?: Partial<IWrapRotationEvent>): RotationEvent;
    static create(...data: Partial<IWrapRotationEvent>[]): RotationEvent[];
    constructor(data?: Partial<IWrapRotationEvent>);
    executionTime: IWrapRotationEvent['executionTime'];
    rotation: IWrapRotationEvent['rotation'];
    setExecutionTime(value: this['executionTime']): this;
    setRotation(value: this['rotation']): this;
    isValid(fn?: (object: this) => boolean, override?: boolean): boolean;
}
//# sourceMappingURL=rotationEvent.d.ts.map