"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mirrorArcMidAnchor = mirrorArcMidAnchor;
exports.midAnchorCondition = midAnchorCondition;
const helpers_js_1 = require("../../../utils/math/helpers.js");
const trigonometry_js_1 = require("../../../utils/math/trigonometry.js");
const iterator_js_1 = require("../../../utils/misc/iterator.js");
const constants_js_1 = require("../../shared/constants.js");
const baseNote_js_1 = require("./baseNote.js");
/** Mirror note color. */
function mirrorArcMidAnchor(midAnchor) {
    return (0, iterator_js_1.cycle)([constants_js_1.SliderMidAnchorMode.CLOCKWISE, constants_js_1.SliderMidAnchorMode.COUNTER_CLOCKWISE], midAnchor);
}
function midAnchorCondition(arc) {
    return (arc.midAnchor !== constants_js_1.SliderMidAnchorMode.STRAIGHT &&
        arc.direction !== constants_js_1.NoteDirection.ANY &&
        arc.posX === arc.posX &&
        (0, helpers_js_1.nearEqual)((0, trigonometry_js_1.shortRotDistance)((0, baseNote_js_1.resolveNoteAngle)(arc.direction), (0, baseNote_js_1.resolveNoteAngle)(arc.tailDirection), 360), 180));
}
