import { NoteColor } from '../../shared/constants.js';
import type { IWrapBaseNote } from '../../../types/beatmap/wrapper/baseNote.js';
/** Check if note color is red. */
export declare function isRedNoteColor(color: number): boolean;
/** Check if note color is blue. */
export declare function isBlueNoteColor(color: number): boolean;
/** Check if note color is not set (-1). */
export declare function isUnsetNoteColor(color: number): boolean;
/** Compare two notes and return if they would form a double. */
export declare function isDouble<T extends Pick<IWrapBaseNote, 'time' | 'color'>>(object: T, compareTo: T, tolerance?: number): boolean;
/** Get standardised note angle. */
export declare function resolveNoteAngle(direction: number): number;
/** Mirror note color. */
export declare function mirrorNoteColor(color: NoteColor): NoteColor;
/** Mirror note direction horizontally. */
export declare function mirrorNoteDirectionHorizontally(direction: number): number;
/** Mirror note direction vertically. */
export declare function mirrorNoteDirectionVertically(direction: number): number;
//# sourceMappingURL=baseNote.d.ts.map