import type { IOptimizeOptions } from '../../types/beatmap/options/optimize.js';
/**
 * Remap and deduplicate data in array.
 *
 * @param data The data array to remap and deduplicate.
 * @returns The remapped and deduplicated data and a map of the original index to the new index.
 */
export declare function remapDedupe<T>(data: T[]): [T[], Map<number, number>];
/**
 * Delete props with zero values.
 *
 * @param data The data to purge props.
 */
export declare function purgeZeros(data: Record<string, any>): void;
/** Recursively clean object data. */
export declare function deepClean(obj: {
    [key: string | number]: any;
} | any[], name: string, options: IOptimizeOptions): void;
//# sourceMappingURL=optimize.d.ts.map