import type { IWrapBeatmapSubset } from '../../types/beatmap/wrapper/beatmap.js';
type IScoreBeatmapSubset = IWrapBeatmapSubset<'colorNotes' | 'arcs' | 'chains', 'time' | 'posX' | 'posY' | 'color' | 'tailTime' | 'tailPosX' | 'tailPosY' | 'sliceCount'>;
/** Scoring type of note. */
export declare const enum ScoreType {
    NONE = 0,
    NORMAL = 1,
    ARC_HEAD = 2,
    ARC_TAIL = 3,
    CHAIN_HEAD = 4,
    CHAIN_ELEMENT = 5
}
/** Score value given by each scoring type of note. */
export declare const ScoreValue: {
    readonly [key in ScoreType]: number;
};
/** Calculate max score from beatmap. */
export declare function calculateScore<T extends IScoreBeatmapSubset>(beatmap: T): number;
export {};
//# sourceMappingURL=score.d.ts.map