import type { BeatmapFileType } from '../../types/beatmap/shared/schema.js';
import type { Version } from '../../types/beatmap/shared/version.js';
/**
 * Get implicit version based on beatmap type.
 *
 * The implicit version is used when the version is not specified
 * in the beatmap due to certain issues related within time period.
 */
export declare function implicitVersion(type: BeatmapFileType): Version;
/** Get beatmap version from JSON. */
export declare function retrieveVersion<T extends Record<string, any>>(json: T): Version | null;
/**
 * Compare version between two versions.
 *
 * @returns -1 if current version is lower, 1 if higher, 0 if equal
 */
export declare function compareVersion(current: Version, compareTo: Version): -1 | 0 | 1;
//# sourceMappingURL=version.d.ts.map