import type { ILoadOptions } from '../../types/beatmap/options/loader.js';
import type { InferBeatmap, InferBeatmapSerial, InferBeatmapVersion } from '../../types/beatmap/shared/infer.js';
/**
 * Load beatmap audio data.
 * ```ts
 * const data = loadAudioData(json, 4);
 * console.log(data);
 * ```
 *
 * Mismatched beatmap version will be automatically converted, unspecified will leave the version as is but not known.
 */
export declare function loadAudioData<TVersion extends InferBeatmapVersion<'audioData'>, TWrapper extends Record<string, any> = InferBeatmap<'audioData'>, TSerial extends Record<string, any> = InferBeatmapSerial<'audioData', TVersion>>(json: TSerial, version?: TVersion | null, options?: ILoadOptions<'audioData', TVersion, TWrapper, TSerial>): TWrapper;
export declare function loadAudioData<TVersion extends InferBeatmapVersion<'audioData'>, TWrapper extends Record<string, any> = InferBeatmap<'audioData'>, TSerial extends Record<string, any> = InferBeatmapSerial<'audioData', TVersion>>(json: TSerial, options?: ILoadOptions<'audioData', TVersion, TWrapper, TSerial>): TWrapper;
//# sourceMappingURL=audioData.d.ts.map