import type { ILoadOptions } from '../../types/beatmap/options/loader.js';
import type { InferBeatmap, InferBeatmapSerial, InferBeatmapVersion } from '../../types/beatmap/shared/infer.js';
/**
 * Load beatmap difficulty.
 * ```ts
 * const data = loadDifficulty(json, 4);
 * console.log(data);
 * ```
 *
 * Mismatched beatmap version will be automatically converted, unspecified will leave the version as is but not known.
 */
export declare function loadDifficulty<TVersion extends InferBeatmapVersion<'difficulty'>, TWrapper extends Record<string, any> = InferBeatmap<'difficulty'>, TSerial extends Record<string, any> = InferBeatmapSerial<'difficulty', TVersion>>(json: TSerial, version?: TVersion | null, options?: ILoadOptions<'difficulty', TVersion, TWrapper, TSerial>): TWrapper;
export declare function loadDifficulty<TVersion extends InferBeatmapVersion<'difficulty'>, TWrapper extends Record<string, any> = InferBeatmap<'difficulty'>, TSerial extends Record<string, any> = InferBeatmapSerial<'difficulty', TVersion>>(json: TSerial, options?: ILoadOptions<'difficulty', TVersion, TWrapper, TSerial>): TWrapper;
//# sourceMappingURL=difficulty.d.ts.map