import type { ILoadOptions } from '../../types/beatmap/options/loader.js';
import type { InferBeatmap, InferBeatmapSerial, InferBeatmapVersion } from '../../types/beatmap/shared/infer.js';
/**
 * Load beatmap lightshow.
 * ```ts
 * const data = loadLightshow(json, 4);
 * console.log(data);
 * ```
 *
 * Mismatched beatmap version will be automatically converted, unspecified will leave the version as is but not known.
 */
export declare function loadLightshow<TVersion extends InferBeatmapVersion<'lightshow'>, TWrapper extends Record<string, any> = InferBeatmap<'lightshow'>, TSerial extends Record<string, any> = InferBeatmapSerial<'lightshow', TVersion>>(json: TSerial, version?: TVersion | null, options?: ILoadOptions<'lightshow', TVersion, TWrapper, TSerial>): TWrapper;
export declare function loadLightshow<TVersion extends InferBeatmapVersion<'lightshow'>, TWrapper extends Record<string, any> = InferBeatmap<'lightshow'>, TSerial extends Record<string, any> = InferBeatmapSerial<'lightshow', TVersion>>(json: TSerial, options?: ILoadOptions<'lightshow', TVersion, TWrapper, TSerial>): TWrapper;
//# sourceMappingURL=lightshow.d.ts.map