import type { ICompatibilityOptions } from '../../types/beatmap/options/compatibility.js';
import type { InferBeatmap, InferBeatmapVersion } from '../../types/beatmap/shared/infer.js';
import type { BeatmapFileType } from '../../types/beatmap/shared/schema.js';
type CompatibilityMap<T extends BeatmapFileType> = {
    [TVersion in InferBeatmapVersion<T>]: <TSerial extends InferBeatmap<T>>(data: TSerial, options: ICompatibilityOptions) => void;
};
/** Compatibility function version map for beatmap info. */
export declare const infoCompatibilityMap: CompatibilityMap<'info'>;
/** Compatibility function version map for beatmap audio data. */
export declare const audioDataCompatibilityMap: CompatibilityMap<'audioData'>;
/** Compatibility function version map for beatmap difficulty. */
export declare const difficultyCompatibilityMap: CompatibilityMap<'difficulty'>;
/** Compatibility function version map for beatmap lightshow. */
export declare const lightshowCompatibilityMap: CompatibilityMap<'lightshow'>;
export {};
//# sourceMappingURL=compatibility.d.ts.map