"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lightshowCompatibilityMap = exports.difficultyCompatibilityMap = exports.audioDataCompatibilityMap = exports.infoCompatibilityMap = void 0;
const difficulty_js_1 = require("../schema/v1/compat/difficulty.js");
const info_js_1 = require("../schema/v1/compat/info.js");
const audioData_js_1 = require("../schema/v2/compat/audioData.js");
const difficulty_js_2 = require("../schema/v2/compat/difficulty.js");
const info_js_2 = require("../schema/v2/compat/info.js");
const difficulty_js_3 = require("../schema/v3/compat/difficulty.js");
const lightshow_js_1 = require("../schema/v3/compat/lightshow.js");
const audioData_js_2 = require("../schema/v4/compat/audioData.js");
const difficulty_js_4 = require("../schema/v4/compat/difficulty.js");
const info_js_3 = require("../schema/v4/compat/info.js");
const lightshow_js_2 = require("../schema/v4/compat/lightshow.js");
/** Compatibility function version map for beatmap info. */
exports.infoCompatibilityMap = {
    1: info_js_1.compatInfo,
    2: info_js_2.compatInfo,
    4: info_js_3.compatInfo,
};
/** Compatibility function version map for beatmap audio data. */
exports.audioDataCompatibilityMap = {
    2: audioData_js_1.compatAudioData,
    4: audioData_js_2.compatAudioData,
};
/** Compatibility function version map for beatmap difficulty. */
exports.difficultyCompatibilityMap = {
    1: difficulty_js_1.compatDifficulty,
    2: difficulty_js_2.compatDifficulty,
    3: difficulty_js_3.compatDifficulty,
    4: difficulty_js_4.compatDifficulty,
};
/** Compatibility function version map for beatmap lightshow. */
exports.lightshowCompatibilityMap = {
    3: lightshow_js_1.compatLightshow,
    4: lightshow_js_2.compatLightshow,
};
