import type { InferBeatmap, InferBeatmapVersion } from '../../types/beatmap/shared/infer.js';
import type { BeatmapFileType } from '../../types/beatmap/shared/schema.js';
type ConverterMap<T extends BeatmapFileType> = {
    [TVersion in InferBeatmapVersion<T>]: <TWrapper extends InferBeatmap<T>>(data: TWrapper, fromVersion?: number) => TWrapper;
};
/** Conversion function version map for beatmap info. */
export declare const infoConvertMap: ConverterMap<'info'>;
/** Conversion function version map for beatmap audio data. */
export declare const audioDataConvertMap: ConverterMap<'audioData'>;
/** Conversion function version map for beatmap data. */
export declare const beatmapConvertMap: ConverterMap<'difficulty' | 'lightshow'>;
export declare function convertBeatmap<TFileType extends BeatmapFileType, TVersion extends InferBeatmapVersion<TFileType>, TWrapper extends InferBeatmap<TFileType>>(type: TFileType, targetVersion: TVersion, data: TWrapper, sourceVersion?: InferBeatmapVersion<TFileType>): TWrapper;
export {};
//# sourceMappingURL=converter.d.ts.map