"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.beatmapConvertMap = exports.audioDataConvertMap = exports.infoConvertMap = void 0;
exports.convertBeatmap = convertBeatmap;
const beatmap_js_1 = require("../converter/toV1/beatmap.js");
const info_js_1 = require("../converter/toV1/info.js");
const audioData_js_1 = require("../converter/toV2/audioData.js");
const beatmap_js_2 = require("../converter/toV2/beatmap.js");
const info_js_2 = require("../converter/toV2/info.js");
const beatmap_js_3 = require("../converter/toV3/beatmap.js");
const audioData_js_2 = require("../converter/toV4/audioData.js");
const beatmap_js_4 = require("../converter/toV4/beatmap.js");
const info_js_3 = require("../converter/toV4/info.js");
/** Conversion function version map for beatmap info. */
exports.infoConvertMap = {
    1: info_js_1.toV1Info,
    2: info_js_2.toV2Info,
    4: info_js_3.toV4Info,
};
/** Conversion function version map for beatmap audio data. */
exports.audioDataConvertMap = {
    2: audioData_js_1.toV2AudioData,
    4: audioData_js_2.toV4AudioData,
};
/** Conversion function version map for beatmap data. */
exports.beatmapConvertMap = {
    1: beatmap_js_1.toV1Beatmap,
    2: beatmap_js_2.toV2Beatmap,
    3: beatmap_js_3.toV3Beatmap,
    4: beatmap_js_4.toV4Beatmap,
};
function convertBeatmap(type, targetVersion, data, sourceVersion) {
    switch (type) {
        case 'info': {
            const convert = exports.infoConvertMap[targetVersion];
            return convert(data, sourceVersion);
        }
        case 'audioData': {
            const convert = exports.audioDataConvertMap[targetVersion];
            return convert(data, sourceVersion);
        }
        case 'difficulty': {
            const convert = exports.beatmapConvertMap[targetVersion];
            return convert(data, sourceVersion);
        }
        case 'lightshow': {
            const convert = exports.beatmapConvertMap[targetVersion];
            return convert(data, sourceVersion);
        }
        default: {
            throw new Error('');
        }
    }
}
