import type { IOptimizeOptions } from '../../types/beatmap/options/optimize.js';
import type { InferBeatmapSerial, InferBeatmapVersion } from '../../types/beatmap/shared/infer.js';
import type { BeatmapFileType } from '../../types/mod.js';
type OptimizeMap<T extends BeatmapFileType> = {
    [key in InferBeatmapVersion<T>]: (data: InferBeatmapSerial<T, key>, options: IOptimizeOptions) => void;
};
/** Optimize function version map for schema beatmap info. */
export declare const infoOptimizeMap: OptimizeMap<'info'>;
/** Optimize function version map for schema beatmap difficulty. */
export declare const difficultyOptimizeMap: OptimizeMap<'difficulty'>;
/** Optimize function version map for schema beatmap lightshow. */
export declare const lightshowOptimizeMap: OptimizeMap<'lightshow'>;
export declare function optimizeBeatmap<TFileType extends BeatmapFileType, TVersion extends InferBeatmapVersion<TFileType>, TSerial extends InferBeatmapSerial<TFileType, TVersion>>(type: TFileType, ver: TVersion, data: TSerial, options: IOptimizeOptions): void;
export {};
//# sourceMappingURL=optimizer.d.ts.map