import type { ISaveOptions } from '../../types/beatmap/options/saver.js';
import type { InferBeatmap, InferBeatmapSerial, InferBeatmapVersion } from '../../types/beatmap/shared/infer.js';
/**
 * Save beatmap audio data.
 * ```ts
 * const json = saveAudioData(data, 4);
 * console.log(json);
 * ```
 *
 * Mismatched beatmap version will be automatically converted, unspecified will leave the version as is but not known.
 */
export declare function saveAudioData<TVersion extends InferBeatmapVersion<'audioData'>, TWrapper extends Record<string, any> = InferBeatmap<'audioData'>, TSerial extends Record<string, any> = InferBeatmapSerial<'audioData', TVersion>>(data: TWrapper, version?: TVersion | null, options?: ISaveOptions<'audioData', TVersion, TWrapper, TSerial>): TSerial;
export declare function saveAudioData<TVersion extends InferBeatmapVersion<'audioData'>, TWrapper extends Record<string, any> = InferBeatmap<'audioData'>, TSerial extends Record<string, any> = InferBeatmapSerial<'audioData', TVersion>>(data: TWrapper, options?: ISaveOptions<'audioData', TVersion, TWrapper, TSerial>): TSerial;
//# sourceMappingURL=audioData.d.ts.map