import type { ISaveOptions } from '../../types/beatmap/options/saver.js';
import type { InferBeatmap, InferBeatmapSerial, InferBeatmapVersion } from '../../types/beatmap/shared/infer.js';
/**
 * Save beatmap lightshow.
 * ```ts
 * const json = saveLightshow(data, 4);
 * console.log(json);
 * ```
 *
 * Mismatched beatmap version will be automatically converted, unspecified will leave the version as is but not known.
 */
export declare function saveLightshow<TVersion extends InferBeatmapVersion<'lightshow'>, TWrapper extends Record<string, any> = InferBeatmap<'lightshow'>, TSerial extends Record<string, any> = InferBeatmapSerial<'lightshow', TVersion>>(data: TWrapper, version?: TVersion | null, options?: ISaveOptions<'lightshow', TVersion, TWrapper, TSerial>): TSerial;
export declare function saveLightshow<TVersion extends InferBeatmapVersion<'lightshow'>, TWrapper extends Record<string, any> = InferBeatmap<'lightshow'>, TSerial extends Record<string, any> = InferBeatmapSerial<'lightshow', TVersion>>(data: TWrapper, options?: ISaveOptions<'lightshow', TVersion, TWrapper, TSerial>): TSerial;
//# sourceMappingURL=lightshow.d.ts.map