"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BookmarkSetSchema = exports.BookmarkElementSchema = void 0;
const _deps_js_1 = require("../../../../_deps.js");
const helpers_js_1 = require("../../helpers.js");
const mod_js_1 = require("../../shared/declaration/mod.js");
/** Schema declaration for official editor `Bookmark Element`  */
exports.BookmarkElementSchema = _deps_js_1.v.object({
    beat: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '1.0.0',
    }),
    label: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '1.0.0',
    }),
    text: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '1.0.0',
    }),
});
/** Schema declaration for official editor `Bookmark Set`  */
exports.BookmarkSetSchema = (0, helpers_js_1.entity)(() => '1.0.0', {
    name: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '1.0.0',
    }),
    characteristic: (0, helpers_js_1.field)(_deps_js_1.v.union([mod_js_1.CharacteristicNameSchema, _deps_js_1.v.literal('')]), {
        version: '1.0.0',
    }),
    difficulty: (0, helpers_js_1.field)(_deps_js_1.v.union([mod_js_1.DifficultyNameSchema, _deps_js_1.v.literal('')]), {
        version: '1.0.0',
    }),
    color: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '1.0.0',
    }),
    bookmarks: (0, helpers_js_1.field)(_deps_js_1.v.array(exports.BookmarkElementSchema), {
        version: '1.0.0',
    }),
});
