import { v } from '../../../../_deps.js';
import { Axis, CharacteristicName, DifficultyName, DifficultyRank, DistributionType, EaseType, Environment360Name, EnvironmentAllName, EnvironmentName, EnvironmentV3Name, EventBoxType, EventLightColor, EventType, ExecutionTime, FxType, IndexFilterType, LightRotationDirection, LimitAlsoAffectsType, NoteType, ObstacleType, RandomType, TransitionType } from '../../../../types/beatmap/shared/mod.js';
import { EventLightValue, NoteColor, NoteDirection, OffsetDirection, PosX, PosY, SliderMidAnchorMode } from '../../../shared/constants.js';
/** Schema declaration for semantic version. */
export declare const VersionSchema: v.SchemaWithPipe<readonly [v.StringSchema<undefined>, v.RegexAction<string, undefined>]>;
/** Schema declaration for custom data. */
export declare const CustomDataSchema: v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>;
/** Schema declaration for {@linkcode CharacteristicName} */
export declare const CharacteristicNameSchema: v.PicklistSchema<typeof CharacteristicName, undefined>;
/** Schema declaration for {@linkcode DifficultyName} */
export declare const DifficultyNameSchema: v.PicklistSchema<typeof DifficultyName, undefined>;
/** Schema declaration for {@linkcode DifficultyRank} */
export declare const DifficultyRankSchema: v.PicklistSchema<typeof DifficultyRank, undefined>;
/** Schema declaration for {@linkcode EnvironmentName} */
export declare const EnvironmentNameSchema: v.PicklistSchema<typeof EnvironmentName, undefined>;
/** Schema declaration for {@linkcode EnvironmentV3Name} */
export declare const EnvironmentV3NameSchema: v.PicklistSchema<typeof EnvironmentV3Name, undefined>;
/** Schema declaration for {@linkcode Environment360Name} */
export declare const Environment360NameSchema: v.PicklistSchema<typeof Environment360Name, undefined>;
/** Schema declaration for {@linkcode EnvironmentAllName} */
export declare const EnvironmentAllNameSchema: v.PicklistSchema<typeof EnvironmentAllName, undefined>;
/** Schema declaration for {@linkcode PosX} */
export declare const PosXSchema: v.EnumSchema<typeof PosX, undefined>;
/** Schema declaration for {@linkcode PosY} */
export declare const PosYSchema: v.EnumSchema<typeof PosY, undefined>;
/** Schema declaration for {@linkcode NoteColor} */
export declare const NoteColorSchema: v.EnumSchema<typeof NoteColor, undefined>;
/** Schema declaration for {@linkcode NoteDirection} */
export declare const NoteDirectionSchema: v.EnumSchema<typeof NoteDirection, undefined>;
/** Schema declaration for {@linkcode OffsetDirection} */
export declare const OffsetDirectionSchema: v.EnumSchema<typeof OffsetDirection, undefined>;
/** Schema declaration for {@linkcode OffsetDirection} */
export declare const SliderMidAnchorModeSchema: v.EnumSchema<typeof SliderMidAnchorMode, undefined>;
/** Schema declaration for {@linkcode EventLightValue} */
export declare const EventLightValueSchema: v.EnumSchema<typeof EventLightValue, undefined>;
/** Schema declaration for {@linkcode EventType} */
export declare const EventTypeSchema: v.EnumSchema<typeof EventType, undefined>;
/** Schema declaration for {@linkcode ExecutionTime} */
export declare const ExecutionTimeSchema: v.EnumSchema<typeof ExecutionTime, undefined>;
/** Schema declaration for {@linkcode IndexFilterType} */
export declare const IndexFilterTypeSchema: v.EnumSchema<typeof IndexFilterType, undefined>;
/** Schema declaration for {@linkcode LimitAlsoAffectsType} */
export declare const LimitAlsoAffectsTypeSchema: v.EnumSchema<typeof LimitAlsoAffectsType, undefined>;
/** Schema declaration for {@linkcode RandomType} */
export declare const RandomTypeSchema: v.EnumSchema<typeof RandomType, undefined>;
/** Schema declaration for {@linkcode DistributionType} */
export declare const DistributionTypeSchema: v.EnumSchema<typeof DistributionType, undefined>;
/** Schema declaration for {@linkcode EaseType} */
export declare const EaseTypeSchema: v.EnumSchema<typeof EaseType, undefined>;
/** Schema declaration for {@linkcode EventLightColor} */
export declare const EventLightColorSchema: v.EnumSchema<typeof EventLightColor, undefined>;
/** Schema declaration for {@linkcode Axis} */
export declare const AxisSchema: v.EnumSchema<typeof Axis, undefined>;
/** Schema declaration for {@linkcode LightRotationDirection} */
export declare const LightRotationDirectionSchema: v.EnumSchema<typeof LightRotationDirection, undefined>;
/** Schema declaration for {@linkcode NoteType} */
export declare const NoteTypeSchema: v.EnumSchema<typeof NoteType, undefined>;
/** Schema declaration for {@linkcode ObstacleType} */
export declare const ObstacleTypeSchema: v.EnumSchema<typeof ObstacleType, undefined>;
/** Schema declaration for {@linkcode TransitionType} */
export declare const TransitionTypeSchema: v.EnumSchema<typeof TransitionType, undefined>;
/** Schema declaration for {@linkcode FxType} */
export declare const FxTypeSchema: v.EnumSchema<typeof FxType, undefined>;
/** Schema declaration for {@linkcode EventBoxType} */
export declare const EventBoxTypeSchema: v.EnumSchema<typeof EventBoxType, undefined>;
//# sourceMappingURL=common.d.ts.map