"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventBoxTypeSchema = exports.FxTypeSchema = exports.TransitionTypeSchema = exports.ObstacleTypeSchema = exports.NoteTypeSchema = exports.LightRotationDirectionSchema = exports.AxisSchema = exports.EventLightColorSchema = exports.EaseTypeSchema = exports.DistributionTypeSchema = exports.RandomTypeSchema = exports.LimitAlsoAffectsTypeSchema = exports.IndexFilterTypeSchema = exports.ExecutionTimeSchema = exports.EventTypeSchema = exports.EventLightValueSchema = exports.SliderMidAnchorModeSchema = exports.OffsetDirectionSchema = exports.NoteDirectionSchema = exports.NoteColorSchema = exports.PosYSchema = exports.PosXSchema = exports.EnvironmentAllNameSchema = exports.Environment360NameSchema = exports.EnvironmentV3NameSchema = exports.EnvironmentNameSchema = exports.DifficultyRankSchema = exports.DifficultyNameSchema = exports.CharacteristicNameSchema = exports.CustomDataSchema = exports.VersionSchema = void 0;
const _deps_js_1 = require("../../../../_deps.js");
const mod_js_1 = require("../../../../types/beatmap/shared/mod.js");
const constants_js_1 = require("../../../shared/constants.js");
/** Schema declaration for semantic version. */
exports.VersionSchema = _deps_js_1.v.pipe(_deps_js_1.v.string(), _deps_js_1.v.regex(/^(0|[1-9]\d*)\.(0|[1-9]\d*)\.(0|[1-9]\d*)$/));
/** Schema declaration for custom data. */
exports.CustomDataSchema = _deps_js_1.v.record(_deps_js_1.v.string(), _deps_js_1.v.any());
/** Schema declaration for {@linkcode CharacteristicName} */
exports.CharacteristicNameSchema = _deps_js_1.v.picklist(mod_js_1.CharacteristicName);
/** Schema declaration for {@linkcode DifficultyName} */
exports.DifficultyNameSchema = _deps_js_1.v.picklist(mod_js_1.DifficultyName);
/** Schema declaration for {@linkcode DifficultyRank} */
exports.DifficultyRankSchema = _deps_js_1.v.picklist(mod_js_1.DifficultyRank);
/** Schema declaration for {@linkcode EnvironmentName} */
exports.EnvironmentNameSchema = _deps_js_1.v.picklist(mod_js_1.EnvironmentName);
/** Schema declaration for {@linkcode EnvironmentV3Name} */
exports.EnvironmentV3NameSchema = _deps_js_1.v.picklist(mod_js_1.EnvironmentV3Name);
/** Schema declaration for {@linkcode Environment360Name} */
exports.Environment360NameSchema = _deps_js_1.v.picklist(mod_js_1.Environment360Name);
/** Schema declaration for {@linkcode EnvironmentAllName} */
exports.EnvironmentAllNameSchema = _deps_js_1.v.picklist(mod_js_1.EnvironmentAllName);
/** Schema declaration for {@linkcode PosX} */
exports.PosXSchema = _deps_js_1.v.enum_(constants_js_1.PosX);
/** Schema declaration for {@linkcode PosY} */
exports.PosYSchema = _deps_js_1.v.enum_(constants_js_1.PosY);
/** Schema declaration for {@linkcode NoteColor} */
exports.NoteColorSchema = _deps_js_1.v.enum_(constants_js_1.NoteColor);
/** Schema declaration for {@linkcode NoteDirection} */
exports.NoteDirectionSchema = _deps_js_1.v.enum_(constants_js_1.NoteDirection);
/** Schema declaration for {@linkcode OffsetDirection} */
exports.OffsetDirectionSchema = _deps_js_1.v.enum_(constants_js_1.OffsetDirection);
/** Schema declaration for {@linkcode OffsetDirection} */
exports.SliderMidAnchorModeSchema = _deps_js_1.v.enum_(constants_js_1.SliderMidAnchorMode);
/** Schema declaration for {@linkcode EventLightValue} */
exports.EventLightValueSchema = _deps_js_1.v.enum_(constants_js_1.EventLightValue);
/** Schema declaration for {@linkcode EventType} */
exports.EventTypeSchema = _deps_js_1.v.enum_(mod_js_1.EventType);
/** Schema declaration for {@linkcode ExecutionTime} */
exports.ExecutionTimeSchema = _deps_js_1.v.enum_(mod_js_1.ExecutionTime);
/** Schema declaration for {@linkcode IndexFilterType} */
exports.IndexFilterTypeSchema = _deps_js_1.v.enum_(mod_js_1.IndexFilterType);
/** Schema declaration for {@linkcode LimitAlsoAffectsType} */
exports.LimitAlsoAffectsTypeSchema = _deps_js_1.v.enum_(mod_js_1.LimitAlsoAffectsType);
/** Schema declaration for {@linkcode RandomType} */
exports.RandomTypeSchema = _deps_js_1.v.enum_(mod_js_1.RandomType);
/** Schema declaration for {@linkcode DistributionType} */
exports.DistributionTypeSchema = _deps_js_1.v.enum_(mod_js_1.DistributionType);
/** Schema declaration for {@linkcode EaseType} */
exports.EaseTypeSchema = _deps_js_1.v.enum_(mod_js_1.EaseType);
/** Schema declaration for {@linkcode EventLightColor} */
exports.EventLightColorSchema = _deps_js_1.v.enum_(mod_js_1.EventLightColor);
/** Schema declaration for {@linkcode Axis} */
exports.AxisSchema = _deps_js_1.v.enum_(mod_js_1.Axis);
/** Schema declaration for {@linkcode LightRotationDirection} */
exports.LightRotationDirectionSchema = _deps_js_1.v.enum_(mod_js_1.LightRotationDirection);
/** Schema declaration for {@linkcode NoteType} */
exports.NoteTypeSchema = _deps_js_1.v.enum_(mod_js_1.NoteType);
/** Schema declaration for {@linkcode ObstacleType} */
exports.ObstacleTypeSchema = _deps_js_1.v.enum_(mod_js_1.ObstacleType);
/** Schema declaration for {@linkcode TransitionType} */
exports.TransitionTypeSchema = _deps_js_1.v.enum_(mod_js_1.TransitionType);
/** Schema declaration for {@linkcode FxType} */
exports.FxTypeSchema = _deps_js_1.v.enum_(mod_js_1.FxType);
/** Schema declaration for {@linkcode EventBoxType} */
exports.EventBoxTypeSchema = _deps_js_1.v.enum_(mod_js_1.EventBoxType);
