import { v } from '../../../../_deps.js';
/** Schema declaration for one-dimensional vector tuple. */
export declare const Vector1Schema: v.TupleSchema<[v.NumberSchema<undefined>], undefined>;
/** Schema declaration for two-dimensional vector tuple. */
export declare const Vector2Schema: v.TupleSchema<[v.NumberSchema<undefined>, v.NumberSchema<undefined>], undefined>;
/** Schema declaration for three-dimensional vector tuple. */
export declare const Vector3Schema: v.TupleSchema<[v.NumberSchema<undefined>, v.NumberSchema<undefined>, v.NumberSchema<undefined>], undefined>;
/** Schema declaration for four-dimensional vector tuple. */
export declare const Vector4Schema: v.TupleSchema<[v.NumberSchema<undefined>, v.NumberSchema<undefined>, v.NumberSchema<undefined>, v.NumberSchema<undefined>], undefined>;
/** Schema declaration for three-dimensional vector object. */
export declare const Vector2ObjectSchema: v.ObjectSchema<{
    readonly x: v.NumberSchema<undefined>;
    readonly y: v.NumberSchema<undefined>;
}, undefined>;
/** Schema declaration for three-dimensional vector object. */
export declare const Vector3ObjectSchema: v.ObjectSchema<{
    readonly x: v.NumberSchema<undefined>;
    readonly y: v.NumberSchema<undefined>;
    readonly z: v.NumberSchema<undefined>;
}, undefined>;
/** Schema declaration for float vector. */
export declare const VectorFloatSchema: v.TupleSchema<[v.SchemaWithPipe<readonly [v.NumberSchema<undefined>, v.MinValueAction<number, 0, undefined>, v.MaxValueAction<number, 1, undefined>]>], undefined>;
/** Schema declaration for three-dimensional color vector. */
export declare const Vector3ColorSchema: v.TupleSchema<[v.SchemaWithPipe<readonly [v.NumberSchema<undefined>, v.MinValueAction<number, 0, undefined>, v.MaxValueAction<number, 1, undefined>]>, v.SchemaWithPipe<readonly [v.NumberSchema<undefined>, v.MinValueAction<number, 0, undefined>, v.MaxValueAction<number, 1, undefined>]>, v.SchemaWithPipe<readonly [v.NumberSchema<undefined>, v.MinValueAction<number, 0, undefined>, v.MaxValueAction<number, 1, undefined>]>], undefined>;
/** Schema declaration for four-dimensional color vector. */
export declare const Vector4ColorSchema: v.TupleSchema<[v.SchemaWithPipe<readonly [v.NumberSchema<undefined>, v.MinValueAction<number, 0, undefined>, v.MaxValueAction<number, 1, undefined>]>, v.SchemaWithPipe<readonly [v.NumberSchema<undefined>, v.MinValueAction<number, 0, undefined>, v.MaxValueAction<number, 1, undefined>]>, v.SchemaWithPipe<readonly [v.NumberSchema<undefined>, v.MinValueAction<number, 0, undefined>, v.MaxValueAction<number, 1, undefined>]>, v.SchemaWithPipe<readonly [v.NumberSchema<undefined>, v.MinValueAction<number, 0, undefined>, v.MaxValueAction<number, 1, undefined>]>], undefined>;
//# sourceMappingURL=vector.d.ts.map