"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Vector4ColorSchema = exports.Vector3ColorSchema = exports.VectorFloatSchema = exports.Vector3ObjectSchema = exports.Vector2ObjectSchema = exports.Vector4Schema = exports.Vector3Schema = exports.Vector2Schema = exports.Vector1Schema = void 0;
const _deps_js_1 = require("../../../../_deps.js");
/** Schema declaration for one-dimensional vector tuple. */
exports.Vector1Schema = _deps_js_1.v.tuple([_deps_js_1.v.number()]);
/** Schema declaration for two-dimensional vector tuple. */
exports.Vector2Schema = _deps_js_1.v.tuple([_deps_js_1.v.number(), _deps_js_1.v.number()]);
/** Schema declaration for three-dimensional vector tuple. */
exports.Vector3Schema = _deps_js_1.v.tuple([_deps_js_1.v.number(), _deps_js_1.v.number(), _deps_js_1.v.number()]);
/** Schema declaration for four-dimensional vector tuple. */
exports.Vector4Schema = _deps_js_1.v.tuple([_deps_js_1.v.number(), _deps_js_1.v.number(), _deps_js_1.v.number(), _deps_js_1.v.number()]);
/** Schema declaration for three-dimensional vector object. */
exports.Vector2ObjectSchema = _deps_js_1.v.object({ x: _deps_js_1.v.number(), y: _deps_js_1.v.number() });
/** Schema declaration for three-dimensional vector object. */
exports.Vector3ObjectSchema = _deps_js_1.v.object({ x: _deps_js_1.v.number(), y: _deps_js_1.v.number(), z: _deps_js_1.v.number() });
/** Schema declaration for float vector. */
exports.VectorFloatSchema = _deps_js_1.v.tuple([
    _deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.minValue(0), _deps_js_1.v.maxValue(1)),
]);
/** Schema declaration for three-dimensional color vector. */
exports.Vector3ColorSchema = _deps_js_1.v.tuple([
    _deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.minValue(0), _deps_js_1.v.maxValue(1)),
    _deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.minValue(0), _deps_js_1.v.maxValue(1)),
    _deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.minValue(0), _deps_js_1.v.maxValue(1)),
]);
/** Schema declaration for four-dimensional color vector. */
exports.Vector4ColorSchema = _deps_js_1.v.tuple([
    _deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.minValue(0), _deps_js_1.v.maxValue(1)),
    _deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.minValue(0), _deps_js_1.v.maxValue(1)),
    _deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.minValue(0), _deps_js_1.v.maxValue(1)),
    _deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.minValue(0), _deps_js_1.v.maxValue(1)),
]);
