"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.compatInfo = compatInfo;
const logger_js_1 = require("../../../../logger.js");
const _common_js_1 = require("./_common.js");
/**
 * Check if beatmap info is compatible with v1 `Info` schema.
 */
function compatInfo(info, options) {
    const hasIncompat = info.audio.shufflePeriod !== 0.5 ||
        info.audio.shuffle !== 0 ||
        info.audio.audioOffset !== 0;
    if (hasIncompat) {
        if (options.throwOn.incompatibleObject) {
            throw new Error('Info is not compatible with v4');
        }
        else {
            logger_js_1.logger.tWarn((0, _common_js_1.tag)('compatInfo'), 'Info is not compatible with v4, certain data may be lost!');
        }
    }
}
