"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DifficultySchema = exports.CustomBookmarkSchema = exports.CustomBPMChangeOldSchema = exports.EventSchema = exports.ObstacleSchema = exports.NoteSchema = void 0;
const _deps_js_1 = require("../../../../_deps.js");
const helpers_js_1 = require("../../helpers.js");
const mod_js_1 = require("../../shared/declaration/mod.js");
/**
 * Schema declaration for v1 `Note`.
 */
exports.NoteSchema = _deps_js_1.v.object({
    _time: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '1.5.0',
    }),
    _type: (0, helpers_js_1.field)(mod_js_1.NoteTypeSchema, {
        version: '1.5.0',
    }),
    _lineIndex: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer()), {
        version: '1.5.0',
    }),
    _lineLayer: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer()), {
        version: '1.5.0',
    }),
    _cutDirection: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer(), _deps_js_1.v.minValue(0)), {
        version: '1.5.0',
    }),
});
/**
 * Schema declaration for v1 `Obstacle`.
 */
exports.ObstacleSchema = _deps_js_1.v.object({
    _time: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '1.5.0',
    }),
    _lineIndex: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer()), {
        version: '1.5.0',
    }),
    _type: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer()), {
        version: '1.5.0',
    }),
    _duration: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '1.5.0',
    }),
    _width: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer()), {
        version: '1.5.0',
    }),
});
/**
 * Schema declaration for v1 `Event`.
 */
exports.EventSchema = _deps_js_1.v.object({
    _time: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '1.5.0',
    }),
    _type: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer()), {
        version: '1.5.0',
    }),
    _value: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer()), {
        version: '1.5.0',
    }),
});
/**
 * Schema declaration for v1 `BPM Change`.
 */
exports.CustomBPMChangeOldSchema = _deps_js_1.v.object({
    _time: (0, helpers_js_1.field)(_deps_js_1.v.number()),
    _bpm: (0, helpers_js_1.field)(_deps_js_1.v.number()),
    _BPM: (0, helpers_js_1.field)(_deps_js_1.v.never()),
    _beatsPerBar: (0, helpers_js_1.field)(_deps_js_1.v.number()),
    _metronomeOffset: (0, helpers_js_1.field)(_deps_js_1.v.number()),
});
/**
 * Schema declaration for v1 `Bookmark`.
 */
exports.CustomBookmarkSchema = _deps_js_1.v.object({
    _time: (0, helpers_js_1.field)(_deps_js_1.v.number()),
    _name: (0, helpers_js_1.field)(_deps_js_1.v.string()),
});
/**
 * Schema declaration for v1 `Difficulty`.
 */
exports.DifficultySchema = (0, helpers_js_1.entity)((x) => x._version || '1.5.0', {
    _version: (0, helpers_js_1.field)((0, helpers_js_1.mask)(mod_js_1.VersionSchema), {
        version: '1.5.0',
    }),
    _beatsPerMinute: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '1.5.0',
    }),
    _beatsPerBar: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '1.5.0',
    }),
    _shuffle: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '1.5.0',
    }),
    _shufflePeriod: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '1.5.0',
    }),
    _noteJumpSpeed: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '1.5.0',
    }),
    _noteJumpStartBeatOffset: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '1.5.0',
    }),
    _notes: (0, helpers_js_1.field)(_deps_js_1.v.array(exports.NoteSchema), {
        version: '1.5.0',
    }),
    _obstacles: (0, helpers_js_1.field)(_deps_js_1.v.array(exports.ObstacleSchema), {
        version: '1.5.0',
    }),
    _events: (0, helpers_js_1.field)(_deps_js_1.v.array(exports.EventSchema), {
        version: '1.5.0',
    }),
    _time: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number())),
    _BPMChanges: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.CustomBPMChangeOldSchema))),
    _bookmarks: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.CustomBookmarkSchema))),
});
