"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InfoSchema = exports.InfoDifficultySchema = exports.CustomColorObjectSchema = void 0;
const _deps_js_1 = require("../../../../_deps.js");
const helpers_js_1 = require("../../helpers.js");
const mod_js_1 = require("../../shared/declaration/mod.js");
/**
 * Schema declaration for v1 `Color`.
 */
exports.CustomColorObjectSchema = _deps_js_1.v.object({
    r: _deps_js_1.v.number(),
    g: _deps_js_1.v.number(),
    b: _deps_js_1.v.number(),
});
/**
 * Schema declaration for v1 `Info Difficulty`.
 */
exports.InfoDifficultySchema = _deps_js_1.v.object({
    difficulty: (0, helpers_js_1.field)(mod_js_1.DifficultyNameSchema, {
        version: '1.0.0',
    }),
    difficultyRank: (0, helpers_js_1.field)(_deps_js_1.v.picklist([1, 2, 3, 4, 5, 6, 7, 8, 9, 10]), {
        version: '1.0.0',
    }),
    audioPath: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '1.0.0',
    }),
    jsonPath: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '1.0.0',
    }),
    characteristic: (0, helpers_js_1.field)(mod_js_1.CharacteristicNameSchema, {
        version: '1.0.0',
    }),
    offset: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number())),
    oldOffset: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number())),
    chromaToggle: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.string())),
    customColors: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.boolean())),
    difficultyLabel: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.string())),
    colorLeft: (0, helpers_js_1.field)(_deps_js_1.v.optional(exports.CustomColorObjectSchema)),
    colorRight: (0, helpers_js_1.field)(_deps_js_1.v.optional(exports.CustomColorObjectSchema)),
    envColorLeft: (0, helpers_js_1.field)(_deps_js_1.v.optional(exports.CustomColorObjectSchema)),
    envColorRight: (0, helpers_js_1.field)(_deps_js_1.v.optional(exports.CustomColorObjectSchema)),
    obstacleColor: (0, helpers_js_1.field)(_deps_js_1.v.optional(exports.CustomColorObjectSchema)),
});
/**
 * Schema declaration for v1 `Info`.
 */
exports.InfoSchema = (0, helpers_js_1.entity)(() => '1.0.0', {
    songName: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '1.0.0',
    }),
    songSubName: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '1.0.0',
    }),
    authorName: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '1.0.0',
    }),
    beatsPerMinute: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '1.0.0',
    }),
    previewStartTime: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '1.0.0',
    }),
    previewDuration: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '1.0.0',
    }),
    coverImagePath: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '1.0.0',
    }),
    environmentName: (0, helpers_js_1.field)((0, helpers_js_1.mask)(_deps_js_1.v.string()), {
        version: '1.0.0',
    }),
    difficultyLevels: (0, helpers_js_1.field)(_deps_js_1.v.array(exports.InfoDifficultySchema), {
        version: '1.0.0',
    }),
    oneSaber: (0, helpers_js_1.field)(_deps_js_1.v.boolean(), {
        version: '1.0.0',
    }),
    contributors: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(mod_js_1.CustomContributorSchema)), {
        version: '1.0.0',
    }),
    customEnvironment: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.string()), {
        version: '1.0.0',
    }),
    customEnvironmentHash: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.string()), {
        version: '1.0.0',
    }),
});
