"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.optimizeDifficulty = optimizeDifficulty;
const helpers_js_1 = require("../../../../utils/math/helpers.js");
/**
 * Optimize v1 `Difficulty` schema data.
 */
function optimizeDifficulty(data, options) {
    for (let i1 = 0; i1 < data._notes.length; i1++) {
        const o1 = data._notes[i1];
        if (options.floatTrim) {
            o1._time = (0, helpers_js_1.round)(o1._time, options.floatTrim);
        }
    }
    for (let i1 = 0; i1 < data._obstacles.length; i1++) {
        const o1 = data._obstacles[i1];
        if (options.floatTrim) {
            o1._time = (0, helpers_js_1.round)(o1._time, options.floatTrim);
            o1._duration = (0, helpers_js_1.round)(o1._duration, options.floatTrim);
        }
    }
    for (let i1 = 0; i1 < data._events.length; i1++) {
        const o1 = data._events[i1];
        if (options.floatTrim) {
            o1._time = (0, helpers_js_1.round)(o1._time, options.floatTrim);
        }
    }
}
