"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.optimizeInfo = optimizeInfo;
const helpers_js_1 = require("../../../../utils/math/helpers.js");
/**
 * Optimize v1 `Info` schema data.
 */
function optimizeInfo(data, options) {
    if (options.floatTrim) {
        data.previewDuration = (0, helpers_js_1.round)(data.previewDuration, options.floatTrim);
        data.previewStartTime = (0, helpers_js_1.round)(data.previewStartTime, options.floatTrim);
    }
    if (options.stringTrim) {
        data.authorName = data.authorName.trim();
        data.songName = data.songName.trim();
        data.songSubName = data.songSubName.trim();
    }
}
