"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.arc = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const arc_js_1 = require("../../core/arc.js");
/**
 * Schema serialization for v2 `Arc`.
 */
exports.arc = {
    serialize(data) {
        return {
            _colorType: data.color,
            _headTime: data.time,
            _headLineIndex: data.posX,
            _headLineLayer: data.posY,
            _headCutDirection: data.direction,
            _headControlPointLengthMultiplier: data.lengthMultiplier,
            _tailTime: data.tailTime,
            _tailLineIndex: data.tailPosX,
            _tailLineLayer: data.tailPosY,
            _tailCutDirection: data.tailDirection,
            _tailControlPointLengthMultiplier: data.tailLengthMultiplier,
            _sliderMidAnchorMode: data.midAnchor,
            _customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, arc_js_1.createArc)({
            color: data._colorType,
            time: data._headTime,
            posX: data._headLineIndex,
            posY: data._headLineLayer,
            direction: data._headCutDirection,
            lengthMultiplier: data._headControlPointLengthMultiplier,
            tailTime: data._tailTime,
            tailPosX: data._tailLineIndex,
            tailPosY: data._tailLineLayer,
            tailDirection: data._tailCutDirection,
            tailLengthMultiplier: data._tailControlPointLengthMultiplier,
            midAnchor: data._sliderMidAnchorMode,
            customData: data._customData,
        });
    },
};
