"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.basicEvent = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const basicEvent_js_1 = require("../../core/basicEvent.js");
/**
 * Schema serialization for v2 `Basic Event`.
 */
exports.basicEvent = {
    serialize(data) {
        return {
            _time: data.time,
            _type: data.type,
            _value: data.value,
            _floatValue: data.floatValue,
            _customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, basicEvent_js_1.createBasicEvent)({
            time: data._time,
            type: data._type,
            value: data._value,
            floatValue: data._floatValue,
            customData: data._customData,
        });
    },
};
