"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.bombNote = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const bombNote_js_1 = require("../../core/bombNote.js");
/**
 * Schema serialization for v2 `Bomb Note`.
 */
exports.bombNote = {
    serialize(data) {
        return {
            _time: data.time,
            _type: 3,
            _lineIndex: data.posX,
            _lineLayer: data.posY,
            _cutDirection: data.direction,
            _customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, bombNote_js_1.createBombNote)({
            time: data._time,
            posX: data._lineIndex,
            posY: data._lineLayer,
            direction: data._cutDirection,
            customData: data._customData,
        });
    },
};
