"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.bpmEvent = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const bpmEvent_js_1 = require("../../core/bpmEvent.js");
/**
 * Schema serialization for v2 `BPM Event`.
 */
exports.bpmEvent = {
    serialize(data) {
        return {
            _time: data.time,
            _type: 100,
            _value: 0,
            _floatValue: data.bpm,
            _customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, bpmEvent_js_1.createBPMEvent)({
            time: data._time,
            bpm: data._floatValue ?? data._value,
            customData: data._customData,
        });
    },
};
