"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.colorBoostEvent = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const colorBoostEvent_js_1 = require("../../core/colorBoostEvent.js");
/**
 * Schema serialization for v2 `Color Boost Event`.
 */
exports.colorBoostEvent = {
    serialize(data) {
        return {
            _time: data.time,
            _type: 5,
            _value: data.toggle ? 1 : 0,
            _floatValue: 0,
            _customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, colorBoostEvent_js_1.createColorBoostEvent)({
            time: data._time,
            toggle: !!data._value,
            customData: data._customData,
        });
    },
};
