"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.colorNote = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const colorNote_js_1 = require("../../core/colorNote.js");
const constants_js_1 = require("../../shared/constants.js");
/**
 * Schema serialization for v2 `Color Note`.
 */
exports.colorNote = {
    serialize(data) {
        return {
            _time: data.time,
            _type: data.color,
            _lineIndex: data.posX,
            _lineLayer: data.posY,
            _cutDirection: data.direction,
            _customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, colorNote_js_1.createColorNote)({
            time: data._time,
            posX: data._lineIndex,
            posY: data._lineLayer,
            color: [constants_js_1.NoteColor.RED, constants_js_1.NoteColor.BLUE][data._type ?? 0],
            direction: data._cutDirection,
            customData: data._customData,
        });
    },
};
