"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.compatAudioData = compatAudioData;
const logger_js_1 = require("../../../../logger.js");
const _common_js_1 = require("./_common.js");
/**
 * Checks if beatmap audio data is compatible with v2 `AudioData` schema.
 */
function compatAudioData(data, options) {
    const hasIncompat = !!data.lufsData.length;
    if (hasIncompat) {
        if (options.throwOn.incompatibleObject) {
            throw new Error('Audio data is not compatible with v2');
        }
        else {
            logger_js_1.logger.tWarn((0, _common_js_1.tag)('compatAudioData'), 'Audio data is not compatible with v2, certain data may be lost!');
        }
    }
}
