"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BPMInfoSchema = exports.BPMInfoRegionSchema = void 0;
const _deps_js_1 = require("../../../../_deps.js");
const helpers_js_1 = require("../../helpers.js");
const mod_js_1 = require("../../shared/declaration/mod.js");
/**
 * Schema declaration for v2 `BPMInfo Region`.
 */
exports.BPMInfoRegionSchema = _deps_js_1.v.object({
    _startSampleIndex: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer(), _deps_js_1.v.minValue(0)), {
        version: '2.0.0',
    }),
    _endSampleIndex: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer(), _deps_js_1.v.minValue(0)), {
        version: '2.0.0',
    }),
    _startBeat: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '2.0.0',
    }),
    _endBeat: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '2.0.0',
    }),
});
/**
 * Schema declaration for v2 `BPMInfo`.
 */
exports.BPMInfoSchema = (0, helpers_js_1.entity)((x) => x._version || '2.0.0', {
    _version: (0, helpers_js_1.field)((0, helpers_js_1.mask)(mod_js_1.VersionSchema), {
        version: '2.0.0',
    }),
    _songSampleCount: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer(), _deps_js_1.v.minValue(0)), {
        version: '2.0.0',
    }),
    _songFrequency: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer(), _deps_js_1.v.minValue(0)), {
        version: '2.0.0',
    }),
    _regions: (0, helpers_js_1.field)(_deps_js_1.v.array(exports.BPMInfoRegionSchema), {
        version: '2.0.0',
    }),
});
