"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomDataInfoSetDifficultySchema = exports.CustomDataInfoSetSchema = exports.CustomDataInfoSchema = void 0;
const _deps_js_1 = require("../../../../../_deps.js");
const contributor_js_1 = require("../../../shared/declaration/custom/contributor.js");
const colorScheme_js_1 = require("./colorScheme.js");
const editor_js_1 = require("./editor.js");
/** Schema declaration for v2 `Info` custom data. */
exports.CustomDataInfoSchema = _deps_js_1.v.looseObject({
    _editors: _deps_js_1.v.optional(editor_js_1.CustomEditorSchema),
    _contributors: _deps_js_1.v.optional(_deps_js_1.v.array(contributor_js_1.CustomContributorSchema)),
    _customEnvironment: _deps_js_1.v.optional(_deps_js_1.v.string()),
    _customEnvironmentHash: _deps_js_1.v.optional(_deps_js_1.v.string()),
});
/** Schema declaration for v2 `Info Set` custom data. */
exports.CustomDataInfoSetSchema = _deps_js_1.v.looseObject({
    _characteristicLabel: _deps_js_1.v.optional(_deps_js_1.v.string()),
    _characteristicIconImageFilename: _deps_js_1.v.optional(_deps_js_1.v.string()),
});
/** Schema declaration for v2 `Info Set Difficulty` custom data. */
exports.CustomDataInfoSetDifficultySchema = _deps_js_1.v.looseObject({
    ...colorScheme_js_1.CustomColorSchemeSchema.entries,
    _difficultyLabel: _deps_js_1.v.optional(_deps_js_1.v.string()),
    _editorOffset: _deps_js_1.v.optional(_deps_js_1.v.number()),
    _editorOldOffset: _deps_js_1.v.optional(_deps_js_1.v.number()),
    _warnings: _deps_js_1.v.optional(_deps_js_1.v.array(_deps_js_1.v.string())),
    _information: _deps_js_1.v.optional(_deps_js_1.v.array(_deps_js_1.v.string())),
    _suggestions: _deps_js_1.v.optional(_deps_js_1.v.array(_deps_js_1.v.string())),
    _requirements: _deps_js_1.v.optional(_deps_js_1.v.array(_deps_js_1.v.string())),
    _tags: _deps_js_1.v.optional(_deps_js_1.v.array(_deps_js_1.v.string())),
    _oneSaber: _deps_js_1.v.optional(_deps_js_1.v.boolean()),
    _showRotationNoteSpawnLines: _deps_js_1.v.optional(_deps_js_1.v.boolean()),
});
