"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DifficultySchema = exports.SpecialEventsKeywordFiltersSchema = exports.SpecialEventsKeywordFiltersKeywordsSchema = exports.WaypointSchema = exports.EventSchema = exports.ObstacleSchema = exports.ArcSchema = exports.NoteSchema = void 0;
const _deps_js_1 = require("../../../../_deps.js");
const helpers_js_1 = require("../../helpers.js");
const mod_js_1 = require("../../shared/declaration/mod.js");
/**
 * Schema declaration for v2 `Note`.
 */
exports.NoteSchema = _deps_js_1.v.object({
    _time: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '2.0.0',
    }),
    _type: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.NoteTypeSchema), {
        version: '2.0.0',
    }),
    _lineIndex: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '2.0.0',
    }),
    _lineLayer: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '2.0.0',
    }),
    _cutDirection: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer(), _deps_js_1.v.minValue(0))), {
        version: '2.0.0',
    }),
    _customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v2 `Arc`.
 */
exports.ArcSchema = _deps_js_1.v.object({
    _colorType: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.NoteColorSchema), {
        version: '2.6.0',
    }),
    _headTime: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '2.6.0',
    }),
    _headLineIndex: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '2.6.0',
    }),
    _headLineLayer: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '2.6.0',
    }),
    _headControlPointLengthMultiplier: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '2.6.0',
    }),
    _headCutDirection: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer(), _deps_js_1.v.minValue(0))), {
        version: '2.6.0',
    }),
    _tailTime: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '2.6.0',
    }),
    _tailLineIndex: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '2.6.0',
    }),
    _tailLineLayer: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '2.6.0',
    }),
    _tailControlPointLengthMultiplier: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '2.6.0',
    }),
    _tailCutDirection: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer(), _deps_js_1.v.minValue(0))), {
        version: '2.6.0',
    }),
    _sliderMidAnchorMode: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.SliderMidAnchorModeSchema), {
        version: '2.6.0',
    }),
    _customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v2 `Obstacle`.
 */
exports.ObstacleSchema = _deps_js_1.v.object({
    _time: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '2.0.0',
    }),
    _lineIndex: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '2.0.0',
    }),
    _type: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '2.0.0',
    }),
    _duration: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '2.0.0',
    }),
    _width: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '2.0.0',
    }),
    _customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v2 `Event`.
 */
exports.EventSchema = _deps_js_1.v.object({
    _time: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '2.0.0',
    }),
    _type: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '2.0.0',
    }),
    _value: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '2.0.0',
    }),
    _floatValue: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '2.5.0',
    }),
    _customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v2 `Waypoint`.
 */
exports.WaypointSchema = _deps_js_1.v.object({
    _time: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '2.2.0',
    }),
    _lineIndex: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '2.2.0',
    }),
    _lineLayer: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '2.2.0',
    }),
    _offsetDirection: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.OffsetDirectionSchema), {
        version: '2.2.0',
    }),
    _customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v2 `Special Events Keyword Filters Keywords`.
 */
exports.SpecialEventsKeywordFiltersKeywordsSchema = _deps_js_1.v.object({
    _keyword: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.string()), {
        version: '2.4.0',
    }),
    _specialEvents: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer()))), {
        version: '2.4.0',
    }),
});
/**
 * Schema declaration for v2 `Special Events Keyword Filters`.
 */
exports.SpecialEventsKeywordFiltersSchema = _deps_js_1.v.object({
    _keywords: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.SpecialEventsKeywordFiltersKeywordsSchema)), {
        version: '2.4.0',
    }),
});
/**
 * Schema declaration for v2 `Difficulty`.
 */
exports.DifficultySchema = (0, helpers_js_1.entity)((x) => x._version || '2.0.0', {
    _version: (0, helpers_js_1.field)(_deps_js_1.v.optional((0, helpers_js_1.mask)(mod_js_1.VersionSchema)), {
        version: '2.0.0',
    }),
    _events: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.EventSchema)), {
        version: '2.0.0',
    }),
    _notes: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.NoteSchema)), {
        version: '2.0.0',
    }),
    _sliders: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.ArcSchema)), {
        version: '2.6.0',
    }),
    _waypoints: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.WaypointSchema)), {
        version: '2.2.0',
    }),
    _obstacles: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.ObstacleSchema)), {
        version: '2.0.0',
    }),
    _specialEventsKeywordFilters: (0, helpers_js_1.field)(_deps_js_1.v.optional(exports.SpecialEventsKeywordFiltersSchema), {
        version: '2.4.0',
    }),
    _customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
