"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InfoSchema = exports.InfoColorSchemeSchema = exports.InfoColorSchemeDataSchema = exports.ColorObjectSchema = exports.InfoSetSchema = exports.InfoSetDifficultySchema = void 0;
const _deps_js_1 = require("../../../../_deps.js");
const helpers_js_1 = require("../../helpers.js");
const mod_js_1 = require("../../shared/declaration/mod.js");
/** Schema declaration for v2 `InfoSetDifficulty`. */
exports.InfoSetDifficultySchema = _deps_js_1.v.object({
    _difficulty: (0, helpers_js_1.field)(mod_js_1.DifficultyNameSchema, {
        version: '2.0.0',
    }),
    _difficultyRank: (0, helpers_js_1.field)(mod_js_1.DifficultyRankSchema, {
        version: '2.0.0',
    }),
    _beatmapFilename: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '2.0.0',
    }),
    _noteJumpMovementSpeed: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '2.0.0',
    }),
    _noteJumpStartBeatOffset: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '2.0.0',
    }),
    _beatmapColorSchemeIdx: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer()), {
        version: '2.1.0',
    }),
    _environmentNameIdx: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer()), {
        version: '2.1.0',
    }),
    _customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/** Schema declaration for v2 `InfoSet`. */
exports.InfoSetSchema = _deps_js_1.v.object({
    _beatmapCharacteristicName: (0, helpers_js_1.field)(mod_js_1.CharacteristicNameSchema, {
        version: '2.0.0',
    }),
    _difficultyBeatmaps: (0, helpers_js_1.field)(_deps_js_1.v.array(exports.InfoSetDifficultySchema), {
        version: '2.0.0',
    }),
    _customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/** Schema declaration for v2 `Color`. */
exports.ColorObjectSchema = _deps_js_1.v.object({
    r: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '2.1.0',
    }),
    g: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '2.1.0',
    }),
    b: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '2.1.0',
    }),
    a: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '2.1.0',
    }),
});
/** Schema declaration for v2 `InfoColorSchemeData`. */
exports.InfoColorSchemeDataSchema = _deps_js_1.v.object({
    colorSchemeId: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '2.1.0',
    }),
    saberAColor: (0, helpers_js_1.field)(exports.ColorObjectSchema, {
        version: '2.1.0',
    }),
    saberBColor: (0, helpers_js_1.field)(exports.ColorObjectSchema, {
        version: '2.1.0',
    }),
    environmentColor0: (0, helpers_js_1.field)(exports.ColorObjectSchema, {
        version: '2.1.0',
    }),
    environmentColor1: (0, helpers_js_1.field)(exports.ColorObjectSchema, {
        version: '2.1.0',
    }),
    obstaclesColor: (0, helpers_js_1.field)(exports.ColorObjectSchema, {
        version: '2.1.0',
    }),
    environmentColor0Boost: (0, helpers_js_1.field)(exports.ColorObjectSchema, {
        version: '2.1.0',
    }),
    environmentColor1Boost: (0, helpers_js_1.field)(exports.ColorObjectSchema, {
        version: '2.1.0',
    }),
    environmentColorW: (0, helpers_js_1.field)(_deps_js_1.v.optional(exports.ColorObjectSchema), {
        version: '2.1.0',
    }),
    environmentColorWBoost: (0, helpers_js_1.field)(_deps_js_1.v.optional(exports.ColorObjectSchema), {
        version: '2.1.0',
    }),
});
/** Schema declaration for v2 `InfoColorScheme`. */
exports.InfoColorSchemeSchema = _deps_js_1.v.object({
    useOverride: (0, helpers_js_1.field)(_deps_js_1.v.boolean(), {
        version: '2.1.0',
    }),
    colorScheme: (0, helpers_js_1.field)(exports.InfoColorSchemeDataSchema, {
        version: '2.1.0',
    }),
});
/** Schema declaration for v2 `Info`. */
exports.InfoSchema = (0, helpers_js_1.entity)((x) => x._version || '2.0.0', {
    _version: (0, helpers_js_1.field)((0, helpers_js_1.mask)(mod_js_1.VersionSchema), {
        version: '2.0.0',
    }),
    _songName: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '2.0.0',
    }),
    _songSubName: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '2.0.0',
    }),
    _songAuthorName: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '2.0.0',
    }),
    _levelAuthorName: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '2.0.0',
    }),
    _beatsPerMinute: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '2.0.0',
    }),
    _songTimeOffset: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '2.0.0',
    }),
    _shuffle: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '2.0.0',
    }),
    _shufflePeriod: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '2.0.0',
    }),
    _previewStartTime: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '2.0.0',
    }),
    _previewDuration: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '2.0.0',
    }),
    _songFilename: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '2.0.0',
    }),
    _coverImageFilename: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '2.0.0',
    }),
    _environmentName: (0, helpers_js_1.field)((0, helpers_js_1.mask)(_deps_js_1.v.string()), {
        version: '2.0.0',
    }),
    _allDirectionsEnvironmentName: (0, helpers_js_1.field)(_deps_js_1.v.optional((0, helpers_js_1.mask)(_deps_js_1.v.string())), {
        version: '2.0.0',
    }),
    _environmentNames: (0, helpers_js_1.field)(_deps_js_1.v.array((0, helpers_js_1.mask)(_deps_js_1.v.string())), {
        version: '2.1.0',
    }),
    _colorSchemes: (0, helpers_js_1.field)(_deps_js_1.v.array(exports.InfoColorSchemeSchema), {
        version: '2.1.0',
    }),
    _difficultyBeatmapSets: (0, helpers_js_1.field)(_deps_js_1.v.array(exports.InfoSetSchema), {
        version: '2.0.0',
    }),
    _customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
