"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.infoBeatmap = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const infoBeatmap_js_1 = require("../../core/infoBeatmap.js");
const difficulty_js_1 = require("../../shared/difficulty.js");
/**
 * Schema serialization for v2 `Info Beatmap`.
 */
exports.infoBeatmap = {
    serialize(data) {
        return {
            _difficulty: data.difficulty,
            _difficultyRank: difficulty_js_1.DifficultyRanking[data.difficulty],
            _beatmapFilename: data.filename,
            _noteJumpMovementSpeed: data.njs,
            _noteJumpStartBeatOffset: data.njsOffset,
            _beatmapColorSchemeIdx: data.colorSchemeId,
            _environmentNameIdx: data.environmentId,
            _customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data, options) {
        return (0, infoBeatmap_js_1.createInfoBeatmap)({
            characteristic: options?.characteristic,
            difficulty: data._difficulty,
            authors: {
                mappers: options?.authors?.mappers,
                lighters: options?.authors?.lighters,
            },
            filename: data._beatmapFilename,
            lightshowFilename: options?.lightshowFilename,
            njs: data._noteJumpMovementSpeed,
            njsOffset: data._noteJumpStartBeatOffset,
            colorSchemeId: data._beatmapColorSchemeIdx,
            environmentId: data._environmentNameIdx,
            customData: data._customData,
        });
    },
};
