"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.waypoint = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const waypoint_js_1 = require("../../core/waypoint.js");
/**
 * Schema serialization for v2 `Waypoint`.
 */
exports.waypoint = {
    serialize(data) {
        return {
            _time: data.time,
            _lineIndex: data.posX,
            _lineLayer: data.posY,
            _offsetDirection: data.direction,
            _customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, waypoint_js_1.createWaypoint)({
            time: data._time,
            posX: data._lineIndex,
            posY: data._lineLayer,
            direction: data._offsetDirection,
            customData: data._customData,
        });
    },
};
