"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.arc = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const arc_js_1 = require("../../core/arc.js");
/**
 * Schema serialization for v3 `Arc`.
 */
exports.arc = {
    serialize(data) {
        return {
            b: data.time,
            c: data.color,
            x: data.posX,
            y: data.posY,
            d: data.direction,
            mu: data.lengthMultiplier,
            tb: data.tailTime,
            tx: data.tailPosX,
            ty: data.tailPosY,
            tc: data.tailDirection,
            tmu: data.tailLengthMultiplier,
            m: data.midAnchor,
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, arc_js_1.createArc)({
            time: data.b,
            color: data.c,
            posX: data.x,
            posY: data.y,
            direction: data.d,
            lengthMultiplier: data.mu,
            tailTime: data.tb,
            tailPosX: data.tx,
            tailPosY: data.ty,
            tailDirection: data.tc,
            tailLengthMultiplier: data.tmu,
            midAnchor: data.m,
            customData: data.customData,
        });
    },
};
