"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.bpmEvent = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const bpmEvent_js_1 = require("../../core/bpmEvent.js");
/**
 * Schema serialization for v3 `BPM Event`.
 */
exports.bpmEvent = {
    serialize(data) {
        return {
            b: data.time,
            m: data.bpm,
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, bpmEvent_js_1.createBPMEvent)({
            time: data.b,
            bpm: data.m,
            customData: data.customData,
        });
    },
};
