"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.chain = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const chain_js_1 = require("../../core/chain.js");
/**
 * Schema serialization for v3 `Chain`.
 */
exports.chain = {
    serialize(data) {
        return {
            b: data.time,
            c: data.color,
            x: data.posX,
            y: data.posY,
            d: data.direction,
            tb: data.tailTime,
            tx: data.tailPosX,
            ty: data.tailPosY,
            sc: data.sliceCount,
            s: data.squish,
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, chain_js_1.createChain)({
            time: data.b,
            color: data.c,
            posX: data.x,
            posY: data.y,
            direction: data.d,
            tailTime: data.tb,
            tailPosX: data.tx,
            tailPosY: data.ty,
            sliceCount: data.sc,
            squish: data.s,
            customData: data.customData,
        });
    },
};
