"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.colorBoostEvent = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const colorBoostEvent_js_1 = require("../../core/colorBoostEvent.js");
/**
 * Schema serialization for v3 `Color Boost Event`.
 */
exports.colorBoostEvent = {
    serialize(data) {
        return {
            b: data.time,
            o: data.toggle,
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data = {}) {
        return (0, colorBoostEvent_js_1.createColorBoostEvent)({
            time: data.b,
            toggle: !!data.o,
            customData: data.customData,
        });
    },
};
