"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.colorNote = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const colorNote_js_1 = require("../../core/colorNote.js");
/**
 * Schema serialization for v3 `Color Note`.
 */
exports.colorNote = {
    serialize(data) {
        return {
            b: data.time,
            c: data.color,
            x: data.posX,
            y: data.posY,
            d: data.direction,
            a: data.angleOffset,
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, colorNote_js_1.createColorNote)({
            time: data.b,
            posX: data.x,
            posY: data.y,
            color: data.c,
            direction: data.d,
            angleOffset: data.a,
            customData: data.customData,
        });
    },
};
