"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.compatDifficulty = compatDifficulty;
const logger_js_1 = require("../../../../logger.js");
const has_js_1 = require("../../../helpers/modded/has.js");
const _common_js_1 = require("./_common.js");
/**
 * Checks if beatmap data is compatible with v3 `Difficulty` schema.
 */
function compatDifficulty(bm, options) {
    const hasME = bm.difficulty.colorNotes.some(has_js_1.hasMappingExtensionsNote) ||
        bm.difficulty.bombNotes.some(has_js_1.hasMappingExtensionsBombNote) ||
        bm.difficulty.arcs.some(has_js_1.hasMappingExtensionsArc) ||
        bm.difficulty.chains.some(has_js_1.hasMappingExtensionsChain) ||
        bm.difficulty.obstacles.some(has_js_1.hasMappingExtensionsObstacleV3);
    if (hasME) {
        if (options.throwOn.mappingExtensions) {
            throw new Error('Beatmap contain Mapping Extensions value');
        }
        else {
            logger_js_1.logger.tWarn((0, _common_js_1.tag)('compatDifficulty'), 'Beatmap contain Mapping Extensions value and require Mapping Extensions mod to function!');
        }
    }
}
