"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DifficultySchema = exports.FxEventsCollectionSchema = exports.FxEventIntSchema = exports.FxEventFloatSchema = exports.BasicEventTypesWithKeywordsSchema = exports.BasicEventTypesForKeywordsSchema = exports.VfxEventBoxGroupSchema = exports.VfxEventBoxSchema = exports.LightTranslationEventBoxGroupSchema = exports.LightTranslationEventBoxSchema = exports.LightTranslationBaseSchema = exports.LightRotationEventBoxGroupSchema = exports.LightRotationEventBoxSchema = exports.LightRotationBaseSchema = exports.LightColorEventBoxGroupSchema = exports.LightColorEventBoxSchema = exports.LightColorBaseSchema = exports.IndexFilterSchema = exports.ColorBoostEventSchema = exports.RotationEventSchema = exports.BPMChangeEventSchema = exports.BasicEventSchema = exports.WaypointSchema = exports.ObstacleSchema = exports.ChainSchema = exports.ArcSchema = exports.BombNoteSchema = exports.ColorNoteSchema = void 0;
const _deps_js_1 = require("../../../../_deps.js");
const helpers_js_1 = require("../../helpers.js");
const mod_js_1 = require("../../shared/declaration/mod.js");
/**
 * Schema declaration for v3 `Color Note`.
 */
exports.ColorNoteSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    x: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    y: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    a: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    c: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.NoteColorSchema), {
        version: '3.0.0',
    }),
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer(), _deps_js_1.v.minValue(0))), {
        version: '3.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `Bomb Note`.
 */
exports.BombNoteSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    x: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    y: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `Arc`.
 */
exports.ArcSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    c: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.NoteColorSchema), {
        version: '3.0.0',
    }),
    x: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    y: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer(), _deps_js_1.v.minValue(0))), {
        version: '3.0.0',
    }),
    tb: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    tx: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    ty: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    mu: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    tmu: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    tc: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer(), _deps_js_1.v.minValue(0))), {
        version: '3.0.0',
    }),
    m: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.SliderMidAnchorModeSchema), {
        version: '3.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `Chain`.
 */
exports.ChainSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    c: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.NoteColorSchema), {
        version: '3.0.0',
    }),
    x: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    y: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer(), _deps_js_1.v.minValue(0))), {
        version: '3.0.0',
    }),
    tb: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    tx: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    ty: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    sc: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    s: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `Obstacle`.
 */
exports.ObstacleSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    x: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    y: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    w: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    h: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `Waypoint`.
 */
exports.WaypointSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    x: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    y: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.OffsetDirectionSchema), {
        version: '3.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `Basic Event`.
 */
exports.BasicEventSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    et: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    i: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    f: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `BPM Change Event`.
 */
exports.BPMChangeEventSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    m: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `Rotation Event`.
 */
exports.RotationEventSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.ExecutionTimeSchema), {
        version: '3.0.0',
    }),
    r: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `Color Boost Event`.
 */
exports.ColorBoostEventSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    o: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.boolean()), {
        version: '3.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `Index Filter`.
 */
exports.IndexFilterSchema = _deps_js_1.v.object({
    f: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.IndexFilterTypeSchema), {
        version: '3.0.0',
    }),
    p: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    t: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    r: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '3.0.0',
    }),
    c: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.1.0',
    }),
    n: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.RandomTypeSchema), {
        version: '3.1.0',
    }),
    s: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.1.0',
    }),
    l: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.1.0',
    }),
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.LimitAlsoAffectsTypeSchema), {
        version: '3.1.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `Light Color Event`.
 */
exports.LightColorBaseSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    i: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.TransitionTypeSchema), {
        version: '3.0.0',
    }),
    c: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.EventLightColorSchema), {
        version: '3.0.0',
    }),
    s: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    f: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    sb: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.3.0',
    }),
    sf: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '3.3.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `Light Color Event Box`.
 */
exports.LightColorEventBoxSchema = _deps_js_1.v.object({
    f: (0, helpers_js_1.field)(_deps_js_1.v.optional(exports.IndexFilterSchema), {
        version: '3.0.0',
    }),
    w: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.DistributionTypeSchema), {
        version: '3.0.0',
    }),
    r: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    t: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.DistributionTypeSchema), {
        version: '3.0.0',
    }),
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '3.0.0',
    }),
    i: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.EaseTypeSchema), {
        version: '3.2.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.LightColorBaseSchema)), {
        version: '3.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `Light Color Event Box Group`.
 */
exports.LightColorEventBoxGroupSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    g: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.LightColorEventBoxSchema)), {
        version: '3.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `Light Rotation Event`.
 */
exports.LightRotationBaseSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    p: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '3.0.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.EaseTypeSchema), {
        version: '3.0.0',
    }),
    l: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    r: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    o: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.LightRotationDirectionSchema), {
        version: '3.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `Light Rotation Event Box`.
 */
exports.LightRotationEventBoxSchema = _deps_js_1.v.object({
    f: (0, helpers_js_1.field)(_deps_js_1.v.optional(exports.IndexFilterSchema), {
        version: '3.0.0',
    }),
    w: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.DistributionTypeSchema), {
        version: '3.0.0',
    }),
    s: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    t: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.DistributionTypeSchema), {
        version: '3.0.0',
    }),
    a: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.AxisSchema), {
        version: '3.0.0',
    }),
    r: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '3.0.0',
    }),
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '3.0.0',
    }),
    i: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.EaseTypeSchema), {
        version: '3.2.0',
    }),
    l: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.LightRotationBaseSchema)), {
        version: '3.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `Light Rotation Event Box Group`.
 */
exports.LightRotationEventBoxGroupSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.0.0',
    }),
    g: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.0.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.LightRotationEventBoxSchema)), {
        version: '3.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `Light Translation Event`.
 */
exports.LightTranslationBaseSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.2.0',
    }),
    p: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '3.2.0',
    }),
    t: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.2.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.EaseTypeSchema), {
        version: '3.2.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `Light Translation Event Box`.
 */
exports.LightTranslationEventBoxSchema = _deps_js_1.v.object({
    f: (0, helpers_js_1.field)(_deps_js_1.v.optional(exports.IndexFilterSchema), {
        version: '3.2.0',
    }),
    w: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.2.0',
    }),
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.DistributionTypeSchema), {
        version: '3.2.0',
    }),
    s: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.2.0',
    }),
    t: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.DistributionTypeSchema), {
        version: '3.2.0',
    }),
    a: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.AxisSchema), {
        version: '3.2.0',
    }),
    r: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '3.2.0',
    }),
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '3.2.0',
    }),
    i: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.EaseTypeSchema), {
        version: '3.2.0',
    }),
    l: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.LightTranslationBaseSchema)), {
        version: '3.2.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `Light Translation Event Box Group`.
 */
exports.LightTranslationEventBoxGroupSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.2.0',
    }),
    g: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.2.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.LightTranslationEventBoxSchema)), {
        version: '3.2.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `VFX Event Box`.
 */
exports.VfxEventBoxSchema = _deps_js_1.v.object({
    f: (0, helpers_js_1.field)(_deps_js_1.v.optional(exports.IndexFilterSchema), {
        version: '3.3.0',
    }),
    w: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.3.0',
    }),
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.DistributionTypeSchema), {
        version: '3.3.0',
    }),
    l: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer()))), {
        version: '3.3.0',
    }),
    s: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.3.0',
    }),
    t: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.DistributionTypeSchema), {
        version: '3.3.0',
    }),
    i: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.EaseTypeSchema), {
        version: '3.3.0',
    }),
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '3.3.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `VFX Event Box Group`.
 */
exports.VfxEventBoxGroupSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.3.0',
    }),
    g: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.3.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.VfxEventBoxSchema)), {
        version: '3.3.0',
    }),
    t: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.FxTypeSchema), {
        version: '3.3.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `Basic Event Types with Keywords`.
 */
exports.BasicEventTypesForKeywordsSchema = _deps_js_1.v.object({
    k: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.string()), {
        version: '3.0.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer()))), {
        version: '3.0.0',
    }),
});
/**
 * Schema declaration for v3 `Basic Event Types with Keywords`.
 */
exports.BasicEventTypesWithKeywordsSchema = _deps_js_1.v.object({
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.BasicEventTypesForKeywordsSchema)), {
        version: '3.0.0',
    }),
});
/**
 * Schema declaration for v3 `FX Event Float`.
 */
exports.FxEventFloatSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.3.0',
    }),
    p: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '3.3.0',
    }),
    v: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.3.0',
    }),
    i: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.EaseTypeSchema), {
        version: '3.3.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `FX Event Int`.
 */
exports.FxEventIntSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '3.3.0',
    }),
    p: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '3.3.0',
    }),
    v: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '3.3.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v3 `FX Events Collection`.
 */
exports.FxEventsCollectionSchema = _deps_js_1.v.object({
    _fl: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.FxEventFloatSchema)), {
        version: '3.3.0',
    }),
    _il: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.FxEventIntSchema)), {
        version: '3.3.0',
    }),
});
/**
 * Schema declaration for v3 `Difficulty`.
 */
exports.DifficultySchema = (0, helpers_js_1.entity)((x) => x.version || '3.0.0', {
    version: (0, helpers_js_1.field)((0, helpers_js_1.mask)(mod_js_1.VersionSchema), {
        version: '3.0.0',
    }),
    bpmEvents: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.BPMChangeEventSchema)), {
        version: '3.0.0',
    }),
    rotationEvents: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.RotationEventSchema)), {
        version: '3.0.0',
    }),
    colorNotes: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.ColorNoteSchema)), {
        version: '3.0.0',
    }),
    bombNotes: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.BombNoteSchema)), {
        version: '3.0.0',
    }),
    obstacles: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.ObstacleSchema)), {
        version: '3.0.0',
    }),
    sliders: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.ArcSchema)), {
        version: '3.0.0',
    }),
    burstSliders: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.ChainSchema)), {
        version: '3.0.0',
    }),
    waypoints: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.WaypointSchema)), {
        version: '3.0.0',
    }),
    basicBeatmapEvents: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.BasicEventSchema)), {
        version: '3.0.0',
    }),
    colorBoostBeatmapEvents: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.ColorBoostEventSchema)), {
        version: '3.0.0',
    }),
    lightColorEventBoxGroups: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.LightColorEventBoxGroupSchema)), {
        version: '3.0.0',
    }),
    lightRotationEventBoxGroups: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.LightRotationEventBoxGroupSchema)), {
        version: '3.0.0',
    }),
    lightTranslationEventBoxGroups: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.LightTranslationEventBoxGroupSchema)), {
        version: '3.2.0',
    }),
    vfxEventBoxGroups: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.VfxEventBoxGroupSchema)), {
        version: '3.3.0',
    }),
    _fxEventsCollection: (0, helpers_js_1.field)(_deps_js_1.v.optional(exports.FxEventsCollectionSchema), {
        version: '3.3.0',
    }),
    basicEventTypesWithKeywords: (0, helpers_js_1.field)(_deps_js_1.v.optional(exports.BasicEventTypesWithKeywordsSchema), {
        version: '3.0.0',
    }),
    useNormalEventsAsCompatibleEvents: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.boolean()), {
        version: '3.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
