"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fxEventBoxGroup = void 0;
const constants_js_1 = require("../../../types/beatmap/shared/constants.js");
const json_js_1 = require("../../../utils/misc/json.js");
const fxEventBoxGroup_js_1 = require("../../core/fxEventBoxGroup.js");
const fxEventBox_js_1 = require("./fxEventBox.js");
/**
 * Schema serialization for v3 `FX Event Box Group`.
 */
exports.fxEventBoxGroup = {
    serialize(data) {
        return {
            object: {
                t: constants_js_1.FxType.FLOAT,
                b: data.time,
                g: data.id,
                e: [],
                customData: (0, json_js_1.deepCopy)(data.customData),
            },
            boxData: data.boxes.map((x) => {
                return fxEventBox_js_1.fxEventBox.serialize(x);
            }),
        };
    },
    deserialize(data) {
        return (0, fxEventBoxGroup_js_1.createFxEventBoxGroup)({
            time: data.object?.b,
            id: data.object?.g,
            boxes: data.boxData?.map((x) => {
                return fxEventBox_js_1.fxEventBox.deserialize(x);
            }),
            customData: data.object?.customData,
        });
    },
};
