"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fxEventFloat = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const fxEventFloat_js_1 = require("../../core/fxEventFloat.js");
/**
 * Schema serialization for v3 `FX Event Float`.
 */
exports.fxEventFloat = {
    serialize(data) {
        return {
            b: data.time,
            i: data.easing,
            p: data.previous,
            v: data.value,
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, fxEventFloat_js_1.createFxEventFloat)({
            time: data.b,
            easing: data.i,
            previous: data.p,
            value: data.v,
            customData: data.customData,
        });
    },
};
