"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fxEventInt = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const fxEventInt_js_1 = require("../../core/fxEventInt.js");
/**
 * Schema serialization for v3 `FX Event Int`.
 */
exports.fxEventInt = {
    serialize(data) {
        return {
            b: data.time,
            p: data.previous,
            v: data.value,
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, fxEventInt_js_1.createFxEventInt)({
            time: data.b,
            previous: data.p,
            value: data.v,
            customData: data.customData,
        });
    },
};
