"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lightColorEvent = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const lightColorEvent_js_1 = require("../../core/lightColorEvent.js");
const constants_js_1 = require("../../shared/constants.js");
/**
 * Schema serialization for v3 `Light Color Event`.
 */
exports.lightColorEvent = {
    serialize(data) {
        return {
            b: data.time,
            c: data.color,
            f: data.frequency,
            i: data.previous
                ? constants_js_1.TransitionType.EXTEND
                : data.easing === constants_js_1.EaseType.NONE
                    ? constants_js_1.TransitionType.INSTANT
                    : constants_js_1.TransitionType.INTERPOLATE,
            s: data.brightness,
            sb: data.strobeBrightness,
            sf: data.strobeFade,
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, lightColorEvent_js_1.createLightColorEvent)({
            time: data.b,
            color: data.c,
            frequency: data.f,
            previous: data.i === constants_js_1.TransitionType.EXTEND ? 1 : 0,
            easing: data.i === constants_js_1.TransitionType.INTERPOLATE ? constants_js_1.EaseType.LINEAR : constants_js_1.EaseType.NONE,
            brightness: data.s,
            strobeBrightness: data.sb,
            strobeFade: data.sf,
            customData: data.customData,
        });
    },
};
