"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lightColorEventBox = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const lightColorEventBox_js_1 = require("../../core/lightColorEventBox.js");
const indexFilter_js_1 = require("./indexFilter.js");
const lightColorEvent_js_1 = require("./lightColorEvent.js");
/**
 * Schema serialization for v3 `Light Color Event Box`.
 */
exports.lightColorEventBox = {
    serialize(data) {
        return {
            f: indexFilter_js_1.indexFilter.serialize(data.filter),
            w: data.beatDistribution,
            d: data.beatDistributionType,
            r: data.brightnessDistribution,
            t: data.brightnessDistributionType,
            b: data.affectFirst,
            i: data.easing,
            e: data.events.map((x) => {
                return lightColorEvent_js_1.lightColorEvent.serialize(x);
            }),
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, lightColorEventBox_js_1.createLightColorEventBox)({
            filter: indexFilter_js_1.indexFilter.deserialize(data.f ?? {}),
            beatDistribution: data.w,
            beatDistributionType: data.d,
            brightnessDistribution: data.r,
            brightnessDistributionType: data.t,
            affectFirst: data.b,
            easing: data.i,
            events: data.e?.map((x) => {
                return lightColorEvent_js_1.lightColorEvent.deserialize(x);
            }),
            customData: data.customData,
        });
    },
};
