"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lightColorEventBoxGroup = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const lightColorEventBoxGroup_js_1 = require("../../core/lightColorEventBoxGroup.js");
const lightColorEventBox_js_1 = require("./lightColorEventBox.js");
/**
 * Schema serialization for v3 `Light Color Event Box Group`.
 */
exports.lightColorEventBoxGroup = {
    serialize(data) {
        return {
            b: data.time,
            g: data.id,
            e: data.boxes.map((x) => {
                return lightColorEventBox_js_1.lightColorEventBox.serialize(x);
            }),
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, lightColorEventBoxGroup_js_1.createLightColorEventBoxGroup)({
            time: data.b,
            id: data.g,
            boxes: data.e?.map((x) => {
                return lightColorEventBox_js_1.lightColorEventBox.deserialize(x);
            }),
            customData: data.customData,
        });
    },
};
