"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lightRotationEvent = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const lightRotationEvent_js_1 = require("../../core/lightRotationEvent.js");
/**
 * Schema serialization for v3 `Light Rotation Event`.
 */
exports.lightRotationEvent = {
    serialize(data) {
        return {
            b: data.time,
            e: data.easing,
            l: data.loop,
            o: data.direction,
            p: data.previous,
            r: data.rotation,
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, lightRotationEvent_js_1.createLightRotationEvent)({
            time: data.b,
            easing: data.e,
            loop: data.l,
            direction: data.o,
            previous: data.p,
            rotation: data.r,
            customData: data.customData,
        });
    },
};
