"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lightRotationEventBox = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const lightRotationEventBox_js_1 = require("../../core/lightRotationEventBox.js");
const indexFilter_js_1 = require("./indexFilter.js");
const lightRotationEvent_js_1 = require("./lightRotationEvent.js");
/**
 * Schema serialization for v3 `Light Rotation Event Box`.
 */
exports.lightRotationEventBox = {
    serialize(data) {
        return {
            f: indexFilter_js_1.indexFilter.serialize(data.filter),
            w: data.beatDistribution,
            d: data.beatDistributionType,
            s: data.rotationDistribution,
            t: data.rotationDistributionType,
            a: data.axis,
            r: data.flip,
            b: data.affectFirst,
            i: data.easing,
            l: data.events.map((x) => {
                return lightRotationEvent_js_1.lightRotationEvent.serialize(x);
            }),
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, lightRotationEventBox_js_1.createLightRotationEventBox)({
            filter: indexFilter_js_1.indexFilter.deserialize(data.f ?? {}),
            beatDistribution: data.w,
            beatDistributionType: data.d,
            rotationDistribution: data.s,
            rotationDistributionType: data.t,
            axis: data.a,
            flip: data.r,
            affectFirst: data.b,
            easing: data.i,
            events: data.l?.map((x) => {
                return lightRotationEvent_js_1.lightRotationEvent.deserialize(x);
            }),
            customData: data.customData,
        });
    },
};
