"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lightRotationEventBoxGroup = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const lightRotationEventBoxGroup_js_1 = require("../../core/lightRotationEventBoxGroup.js");
const lightRotationEventBox_js_1 = require("./lightRotationEventBox.js");
/**
 * Schema serialization for v3 `Light Rotation Event Box Group`.
 */
exports.lightRotationEventBoxGroup = {
    serialize(data) {
        return {
            b: data.time,
            g: data.id,
            e: data.boxes.map((x) => {
                return lightRotationEventBox_js_1.lightRotationEventBox.serialize(x);
            }),
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, lightRotationEventBoxGroup_js_1.createLightRotationEventBoxGroup)({
            time: data.b,
            id: data.g,
            boxes: data.e?.map((x) => {
                return lightRotationEventBox_js_1.lightRotationEventBox.deserialize(x);
            }),
            customData: data.customData,
        });
    },
};
