"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lightTranslationEvent = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const lightTranslationEvent_js_1 = require("../../core/lightTranslationEvent.js");
/**
 * Schema serialization for v3 `Light Translation Event`.
 */
exports.lightTranslationEvent = {
    serialize(data) {
        return {
            b: data.time,
            e: data.easing,
            p: data.previous,
            t: data.translation,
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, lightTranslationEvent_js_1.createLightTranslationEvent)({
            time: data.b,
            easing: data.e,
            previous: data.p,
            translation: data.t,
            customData: data.customData,
        });
    },
};
