"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lightTranslationEventBox = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const lightTranslationEventBox_js_1 = require("../../core/lightTranslationEventBox.js");
const indexFilter_js_1 = require("./indexFilter.js");
const lightTranslationEvent_js_1 = require("./lightTranslationEvent.js");
/**
 * Schema serialization for v3 `Light Translation Event Box`.
 */
exports.lightTranslationEventBox = {
    serialize(data) {
        return {
            f: indexFilter_js_1.indexFilter.serialize(data.filter),
            w: data.beatDistribution,
            d: data.beatDistributionType,
            s: data.gapDistribution,
            t: data.gapDistributionType,
            a: data.axis,
            r: data.flip,
            b: data.affectFirst,
            i: data.easing,
            l: data.events.map((x) => {
                return lightTranslationEvent_js_1.lightTranslationEvent.serialize(x);
            }),
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, lightTranslationEventBox_js_1.createLightTranslationEventBox)({
            filter: indexFilter_js_1.indexFilter.deserialize(data.f ?? {}),
            beatDistribution: data.w,
            beatDistributionType: data.d,
            gapDistribution: data.s,
            gapDistributionType: data.t,
            axis: data.a,
            flip: data.r,
            affectFirst: data.b,
            easing: data.i,
            events: data.l?.map((x) => {
                return lightTranslationEvent_js_1.lightTranslationEvent.deserialize(x);
            }),
            customData: data.customData,
        });
    },
};
