"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lightTranslationEventBoxGroup = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const lightTranslationEventBoxGroup_js_1 = require("../../core/lightTranslationEventBoxGroup.js");
const lightTranslationEventBox_js_1 = require("./lightTranslationEventBox.js");
/**
 * Schema serialization for v3 `Light Translation Event Box Group`.
 */
exports.lightTranslationEventBoxGroup = {
    serialize(data) {
        return {
            b: data.time,
            g: data.id,
            e: data.boxes.map((x) => {
                return lightTranslationEventBox_js_1.lightTranslationEventBox.serialize(x);
            }),
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, lightTranslationEventBoxGroup_js_1.createLightTranslationEventBoxGroup)({
            time: data.b,
            id: data.g,
            boxes: data.e?.map((x) => {
                return lightTranslationEventBox_js_1.lightTranslationEventBox.deserialize(x);
            }),
            customData: data.customData,
        });
    },
};
