"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.obstacle = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const obstacle_js_1 = require("../../core/obstacle.js");
/**
 * Schema serialization for v3 `Obstacle`.
 */
exports.obstacle = {
    serialize(data) {
        return {
            b: data.time,
            x: data.posX,
            y: data.posY,
            d: data.duration,
            w: data.width,
            h: data.height,
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, obstacle_js_1.createObstacle)({
            time: data.b,
            posX: data.x,
            posY: data.y,
            duration: data.d,
            width: data.w,
            height: data.h,
            customData: data.customData,
        });
    },
};
