"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.rotationEvent = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const rotationEvent_js_1 = require("../../core/rotationEvent.js");
/**
 * Schema serialization for v3 `Rotation Event`.
 */
exports.rotationEvent = {
    serialize(data) {
        return {
            b: data.time,
            e: data.executionTime,
            r: data.rotation,
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, rotationEvent_js_1.createRotationEvent)({
            time: data.b,
            executionTime: data.e,
            rotation: data.r,
            customData: data.customData,
        });
    },
};
