"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.waypoint = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const waypoint_js_1 = require("../../core/waypoint.js");
/**
 * Schema serialization for v3 `Waypoint`.
 */
exports.waypoint = {
    serialize(data) {
        return {
            b: data.time,
            x: data.posX,
            y: data.posY,
            d: data.direction,
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, waypoint_js_1.createWaypoint)({
            time: data.b,
            posX: data.x,
            posY: data.y,
            direction: data.d,
            customData: data.customData,
        });
    },
};
