"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.arc = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const arc_js_1 = require("../../core/arc.js");
/**
 * Schema serialization for v4 `Arc`.
 */
exports.arc = {
    serialize(data) {
        return {
            object: {
                ai: 0,
                hb: data.time,
                hi: 0,
                hr: data.laneRotation,
                tb: data.tailTime,
                ti: 0,
                tr: data.tailLaneRotation,
                customData: {},
            },
            data: {
                m: data.lengthMultiplier,
                tm: data.tailLengthMultiplier,
                a: data.midAnchor,
                customData: (0, json_js_1.deepCopy)(data.customData),
            },
            headData: {
                c: data.color,
                x: data.posX,
                y: data.posY,
                d: data.direction,
                a: 0,
                customData: {},
            },
            tailData: {
                c: data.color,
                x: data.tailPosX,
                y: data.tailPosY,
                d: data.tailDirection,
                a: 0,
                customData: {},
            },
        };
    },
    deserialize(data) {
        return (0, arc_js_1.createArc)({
            time: data.object?.hb,
            laneRotation: data.object?.hr,
            tailTime: data.object?.tb,
            tailLaneRotation: data.object?.tr,
            color: data.headData?.c,
            posX: data.headData?.x,
            posY: data.headData?.y,
            direction: data.headData?.d,
            lengthMultiplier: data.data?.m,
            tailPosX: data.tailData?.x,
            tailPosY: data.tailData?.y,
            tailDirection: data.tailData?.d,
            tailLengthMultiplier: data.data?.tm,
            midAnchor: data.data?.a,
            customData: data.data?.customData,
        });
    },
};
