"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.basicEvent = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const basicEvent_js_1 = require("../../core/basicEvent.js");
/**
 * Schema serialization for v4 `Basic Event`.
 */
exports.basicEvent = {
    serialize(data) {
        return {
            object: {
                b: data.time,
                i: 0,
                customData: {},
            },
            data: {
                t: data.type,
                i: data.value,
                f: data.floatValue,
                customData: (0, json_js_1.deepCopy)(data.customData),
            },
        };
    },
    deserialize(data) {
        return (0, basicEvent_js_1.createBasicEvent)({
            time: data.object?.b,
            type: data.data?.t,
            value: data.data?.i,
            floatValue: data.data?.f,
            customData: data.data?.customData,
        });
    },
};
