"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.colorNote = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const colorNote_js_1 = require("../../core/colorNote.js");
/**
 * Schema serialization for v4 `Color Note`.
 */
exports.colorNote = {
    serialize(data) {
        return {
            object: {
                b: data.time,
                i: 0,
                r: data.laneRotation,
                customData: {},
            },
            data: {
                c: data.color,
                x: data.posX,
                y: data.posY,
                d: data.direction,
                a: data.angleOffset,
                customData: (0, json_js_1.deepCopy)(data.customData),
            },
        };
    },
    deserialize(data) {
        return (0, colorNote_js_1.createColorNote)({
            time: data.object?.b,
            laneRotation: data.object?.r,
            posX: data.data?.x,
            posY: data.data?.y,
            color: data.data?.c,
            direction: data.data?.d,
            angleOffset: data.data?.a,
            customData: data.data?.customData,
        });
    },
};
