"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AudioDataSchema = exports.AudioDataLUFSSchema = exports.AudioDataBPMSchema = void 0;
const _deps_js_1 = require("../../../../_deps.js");
const helpers_js_1 = require("../../helpers.js");
const mod_js_1 = require("../../shared/declaration/mod.js");
/**
 * Schema declaration for v4 `Audio Data BPM`.
 */
exports.AudioDataBPMSchema = _deps_js_1.v.object({
    si: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer(), _deps_js_1.v.minValue(0)), {
        version: '4.0.0',
    }),
    ei: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer(), _deps_js_1.v.minValue(0)), {
        version: '4.0.0',
    }),
    sb: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '4.0.0',
    }),
    eb: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '4.0.0',
    }),
});
/**
 * Schema declaration for v4 `Audio Data LUFS`.
 */
exports.AudioDataLUFSSchema = _deps_js_1.v.object({
    si: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer(), _deps_js_1.v.minValue(0)), {
        version: '4.0.0',
    }),
    ei: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer(), _deps_js_1.v.minValue(0)), {
        version: '4.0.0',
    }),
    l: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '4.0.0',
    }),
});
/**
 * Schema declaration for v4 `Audio`.
 */
exports.AudioDataSchema = (0, helpers_js_1.entity)((x) => x.version || '4.0.0', {
    version: (0, helpers_js_1.field)((0, helpers_js_1.mask)(mod_js_1.VersionSchema), {
        version: '4.0.0',
    }),
    songChecksum: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '4.0.0',
    }),
    songSampleCount: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer(), _deps_js_1.v.minValue(0)), {
        version: '4.0.0',
    }),
    songFrequency: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer(), _deps_js_1.v.minValue(0)), {
        version: '4.0.0',
    }),
    bpmData: (0, helpers_js_1.field)(_deps_js_1.v.array(exports.AudioDataBPMSchema), {
        version: '4.0.0',
    }),
    lufsData: (0, helpers_js_1.field)(_deps_js_1.v.array(exports.AudioDataLUFSSchema), {
        version: '4.0.0',
    }),
});
