"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ObjectArcSchema = exports.ObjectChainSchema = exports.ObjectLaneSchema = exports.ObjectSchema = void 0;
const _deps_js_1 = require("../../../../_deps.js");
const helpers_js_1 = require("../../helpers.js");
const mod_js_1 = require("../../shared/declaration/mod.js");
/**
 * Schema declaration for v4 `Object`.
 */
exports.ObjectSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    i: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Object Lane`.
 */
exports.ObjectLaneSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    i: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    r: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Object Chain`.
 */
exports.ObjectChainSchema = _deps_js_1.v.object({
    hb: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    hr: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    tb: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    tr: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    i: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    ci: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Object Arc`.
 */
exports.ObjectArcSchema = _deps_js_1.v.object({
    hb: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    hi: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    hr: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    tb: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    ti: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    tr: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    ai: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
