"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomDataInfoBeatmapSchema = exports.CustomDataInfoSchema = exports.CustomCharacteristicSchema = void 0;
const _deps_js_1 = require("../../../../../_deps.js");
const mod_js_1 = require("../../../shared/declaration/mod.js");
const mod_js_2 = require("../../../v2/declaration/mod.js");
/** Schema declaration for v4 `Custom Characteristic`. */
exports.CustomCharacteristicSchema = _deps_js_1.v.object({
    characteristic: mod_js_1.CharacteristicNameSchema,
    label: _deps_js_1.v.string(),
    iconPath: _deps_js_1.v.optional(_deps_js_1.v.string()),
});
/** Schema declaration for v4 `Info` custom data. */
exports.CustomDataInfoSchema = _deps_js_1.v.looseObject({
    _editors: _deps_js_1.v.optional(mod_js_2.CustomEditorSchema),
    _contributors: _deps_js_1.v.optional(_deps_js_1.v.array(mod_js_1.CustomContributorSchema)),
    _customEnvironment: _deps_js_1.v.optional(_deps_js_1.v.string()),
    _customEnvironmentHash: _deps_js_1.v.optional(_deps_js_1.v.string()),
    _characteristics: _deps_js_1.v.optional(_deps_js_1.v.array(exports.CustomCharacteristicSchema)),
});
/** Schema declaration for v4 `Info Difficulty` custom data. */
exports.CustomDataInfoBeatmapSchema = _deps_js_1.v.looseObject({
    ...mod_js_2.CustomColorSchemeSchema.entries,
    _difficultyLabel: _deps_js_1.v.optional(_deps_js_1.v.string()),
    _editorOffset: _deps_js_1.v.optional(_deps_js_1.v.number()),
    _editorOldOffset: _deps_js_1.v.optional(_deps_js_1.v.number()),
    _warnings: _deps_js_1.v.optional(_deps_js_1.v.array(_deps_js_1.v.string())),
    _information: _deps_js_1.v.optional(_deps_js_1.v.array(_deps_js_1.v.string())),
    _suggestions: _deps_js_1.v.optional(_deps_js_1.v.array(_deps_js_1.v.string())),
    _requirements: _deps_js_1.v.optional(_deps_js_1.v.array(_deps_js_1.v.string())),
    _tags: _deps_js_1.v.optional(_deps_js_1.v.array(_deps_js_1.v.string())),
    _oneSaber: _deps_js_1.v.optional(_deps_js_1.v.boolean()),
    _showRotationNoteSpawnLines: _deps_js_1.v.optional(_deps_js_1.v.boolean()),
});
