"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DifficultySchema = exports.NJSEventSchema = exports.SpawnRotationSchema = exports.ArcSchema = exports.ChainSchema = exports.ObstacleSchema = exports.BombNoteSchema = exports.ColorNoteSchema = void 0;
const _deps_js_1 = require("../../../../_deps.js");
const helpers_js_1 = require("../../helpers.js");
const mod_js_1 = require("../../shared/declaration/mod.js");
const common_js_1 = require("./common.js");
/**
 * Schema declaration for v4 `Color Note`.
 */
exports.ColorNoteSchema = _deps_js_1.v.object({
    x: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    y: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    a: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    c: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.NoteColorSchema), {
        version: '4.0.0',
    }),
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer(), _deps_js_1.v.minValue(0))), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Bomb Note`.
 */
exports.BombNoteSchema = _deps_js_1.v.object({
    x: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    y: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Obstacle`.
 */
exports.ObstacleSchema = _deps_js_1.v.object({
    x: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    y: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    w: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    h: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Chain`.
 */
exports.ChainSchema = _deps_js_1.v.object({
    tx: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    ty: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    c: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    s: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number())), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Arc`.
 */
exports.ArcSchema = _deps_js_1.v.object({
    m: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    tm: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    a: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.SliderMidAnchorModeSchema), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Spawn Rotation`.
 *
 * @deprecated removed as of 1.39, convert to `r` in object lane
 */
exports.SpawnRotationSchema = _deps_js_1.v.object({
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.ExecutionTimeSchema), {
        version: '4.0.0',
    }),
    r: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `NJS Event`.
 */
exports.NJSEventSchema = _deps_js_1.v.object({
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.1.0',
    }),
    p: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '4.1.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.EaseTypeSchema), {
        version: '4.1.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Difficulty`.
 */
exports.DifficultySchema = (0, helpers_js_1.entity)((x) => x.version || '4.0.0', {
    version: (0, helpers_js_1.field)((0, helpers_js_1.mask)(mod_js_1.VersionSchema), {
        version: '4.0.0',
    }),
    colorNotes: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(common_js_1.ObjectLaneSchema)), {
        version: '4.0.0',
    }),
    colorNotesData: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.ColorNoteSchema)), {
        version: '4.0.0',
    }),
    bombNotes: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(common_js_1.ObjectLaneSchema)), {
        version: '4.0.0',
    }),
    bombNotesData: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.BombNoteSchema)), {
        version: '4.0.0',
    }),
    obstacles: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(common_js_1.ObjectLaneSchema)), {
        version: '4.0.0',
    }),
    obstaclesData: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.ObstacleSchema)), {
        version: '4.0.0',
    }),
    chains: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(common_js_1.ObjectChainSchema)), {
        version: '4.0.0',
    }),
    chainsData: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.ChainSchema)), {
        version: '4.0.0',
    }),
    arcs: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(common_js_1.ObjectArcSchema)), {
        version: '4.0.0',
    }),
    arcsData: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.ArcSchema)), {
        version: '4.0.0',
    }),
    spawnRotations: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(common_js_1.ObjectSchema)), {
        version: '4.0.0',
    }),
    spawnRotationsData: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.SpawnRotationSchema)), {
        version: '4.0.0',
    }),
    njsEvents: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(common_js_1.ObjectSchema)), {
        version: '4.1.0',
    }),
    njsEventData: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.NJSEventSchema)), {
        version: '4.1.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
