"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InfoSchema = exports.InfoDifficultySchema = exports.InfoBeatmapAuthorsSchema = exports.InfoColorSchemeSchema = exports.InfoAudioSchema = exports.InfoSongSchema = void 0;
const _deps_js_1 = require("../../../../_deps.js");
const helpers_js_1 = require("../../helpers.js");
const mod_js_1 = require("../../shared/declaration/mod.js");
/**
 * Schema declaration for v4 `Info Song`.
 */
exports.InfoSongSchema = _deps_js_1.v.object({
    title: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '4.0.0',
    }),
    subTitle: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '4.0.0',
    }),
    author: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '4.0.0',
    }),
});
/**
 * Schema declaration for v4 `Info Audio`.
 */
exports.InfoAudioSchema = _deps_js_1.v.object({
    songFilename: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '4.0.0',
    }),
    songDuration: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '4.0.0',
    }),
    audioDataFilename: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '4.0.0',
    }),
    bpm: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '4.0.0',
    }),
    lufs: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '4.0.0',
    }),
    previewStartTime: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '4.0.0',
    }),
    previewDuration: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '4.0.0',
    }),
});
/**
 * Schema declaration for v4 `Info Color Scheme`.
 */
exports.InfoColorSchemeSchema = _deps_js_1.v.object({
    colorSchemeName: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '4.0.0',
    }),
    overrideNotes: (0, helpers_js_1.field)(_deps_js_1.v.boolean(), {
        version: '4.0.1',
    }),
    saberAColor: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '4.0.0',
    }),
    saberBColor: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '4.0.0',
    }),
    obstaclesColor: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '4.0.0',
    }),
    overrideLights: (0, helpers_js_1.field)(_deps_js_1.v.boolean(), {
        version: '4.0.1',
    }),
    environmentColor0: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '4.0.0',
    }),
    environmentColor1: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '4.0.0',
    }),
    environmentColor0Boost: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '4.0.0',
    }),
    environmentColor1Boost: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '4.0.0',
    }),
    environmentColorW: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.string()), {
        version: '4.0.0',
    }),
    environmentColorWBoost: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.string()), {
        version: '4.0.0',
    }),
});
/**
 * Schema declaration for v4 `Info Beatmap Authors`.
 */
exports.InfoBeatmapAuthorsSchema = _deps_js_1.v.object({
    mappers: (0, helpers_js_1.field)(_deps_js_1.v.array(_deps_js_1.v.string()), {
        version: '4.0.0',
    }),
    lighters: (0, helpers_js_1.field)(_deps_js_1.v.array(_deps_js_1.v.string()), {
        version: '4.0.0',
    }),
});
/**
 * Schema declaration for v4 `Info Beatmap`.
 */
exports.InfoDifficultySchema = _deps_js_1.v.object({
    characteristic: (0, helpers_js_1.field)(mod_js_1.CharacteristicNameSchema, {
        version: '4.0.0',
    }),
    difficulty: (0, helpers_js_1.field)(mod_js_1.DifficultyNameSchema, {
        version: '4.0.0',
    }),
    beatmapAuthors: (0, helpers_js_1.field)(exports.InfoBeatmapAuthorsSchema, {
        version: '4.0.0',
    }),
    environmentNameIdx: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer()), {
        version: '4.0.0',
    }),
    beatmapColorSchemeIdx: (0, helpers_js_1.field)(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer()), {
        version: '4.0.0',
    }),
    noteJumpMovementSpeed: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '4.0.0',
    }),
    noteJumpStartBeatOffset: (0, helpers_js_1.field)(_deps_js_1.v.number(), {
        version: '4.0.0',
    }),
    lightshowDataFilename: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '4.0.0',
    }),
    beatmapDataFilename: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Info`.
 */
exports.InfoSchema = (0, helpers_js_1.entity)((x) => x.version || '4.0.0', {
    version: (0, helpers_js_1.field)((0, helpers_js_1.mask)(mod_js_1.VersionSchema), {
        version: '4.0.0',
    }),
    song: (0, helpers_js_1.field)(exports.InfoSongSchema, {
        version: '4.0.0',
    }),
    audio: (0, helpers_js_1.field)(exports.InfoAudioSchema, {
        version: '4.0.0',
    }),
    songPreviewFilename: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '4.0.0',
    }),
    coverImageFilename: (0, helpers_js_1.field)(_deps_js_1.v.string(), {
        version: '4.0.0',
    }),
    environmentNames: (0, helpers_js_1.field)(_deps_js_1.v.array((0, helpers_js_1.mask)(_deps_js_1.v.string())), {
        version: '4.0.0',
    }),
    colorSchemes: (0, helpers_js_1.field)(_deps_js_1.v.array(exports.InfoColorSchemeSchema), {
        version: '4.0.0',
    }),
    difficultyBeatmaps: (0, helpers_js_1.field)(_deps_js_1.v.array(exports.InfoDifficultySchema), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
