import { v } from '../../../../_deps.js';
import type { IBasicEvent, IColorBoostEvent, IEventBox, IEventBoxGroup, IFxEventBox, IFxEventFloat, IIndexFilter, ILightColorEvent, ILightColorEventBox, ILightRotationEvent, ILightRotationEventBox, ILightshow, ILightTranslationEvent, ILightTranslationEventBox, IWaypoint } from '../../../../types/beatmap/v4/mod.js';
import { type InferObjectEntries } from '../../helpers.js';
/**
 * Schema declaration for v4 `Waypoint`.
 */
export declare const WaypointSchema: v.ObjectSchema<InferObjectEntries<IWaypoint>, undefined>;
/**
 * Schema declaration for v4 `Basic Event`.
 */
export declare const BasicEventSchema: v.ObjectSchema<InferObjectEntries<IBasicEvent>, undefined>;
/**
 * Schema declaration for v4 `Color Boost Event`.
 */
export declare const ColorBoostEventSchema: v.ObjectSchema<InferObjectEntries<IColorBoostEvent>, undefined>;
/**
 * Schema declaration for v4 `Event Box`.
 */
export declare const EventBoxSchema: v.ObjectSchema<InferObjectEntries<IEventBox>, undefined>;
/**
 * Schema declaration for v4 `Event Box Group`.
 */
export declare const EventBoxGroupSchema: v.ObjectSchema<InferObjectEntries<IEventBoxGroup>, undefined>;
/**
 * Schema declaration for v4 `Index Filter`.
 */
export declare const IndexFilterSchema: v.ObjectSchema<InferObjectEntries<IIndexFilter>, undefined>;
/**
 * Schema declaration for v4 `Light Color Event Box`.
 */
export declare const LightColorEventBoxSchema: v.ObjectSchema<InferObjectEntries<ILightColorEventBox>, undefined>;
/**
 * Schema declaration for v4 `Light Color Event`.
 */
export declare const LightColorEventSchema: v.ObjectSchema<InferObjectEntries<ILightColorEvent>, undefined>;
/**
 * Schema declaration for v4 `Light Rotation Event Box`.
 */
export declare const LightRotationEventBoxSchema: v.ObjectSchema<InferObjectEntries<ILightRotationEventBox>, undefined>;
/**
 * Schema declaration for v4 `Light Rotation Event`.
 */
export declare const LightRotationEventSchema: v.ObjectSchema<InferObjectEntries<ILightRotationEvent>, undefined>;
/**
 * Schema declaration for v4 `Light Translation Event Box`.
 */
export declare const LightTranslationEventBoxSchema: v.ObjectSchema<InferObjectEntries<ILightTranslationEventBox>, undefined>;
/**
 * Schema declaration for v4 `Light Translation Event`.
 */
export declare const LightTranslationEventSchema: v.ObjectSchema<InferObjectEntries<ILightTranslationEvent>, undefined>;
/**
 * Schema declaration for v4 `FX Event Box`.
 */
export declare const FXEventBoxSchema: v.ObjectSchema<InferObjectEntries<IFxEventBox>, undefined>;
/**
 * Schema declaration for v4 `FX Event Float`.
 */
export declare const FXEventFloatSchema: v.ObjectSchema<InferObjectEntries<IFxEventFloat>, undefined>;
/**
 * Schema declaration for v4 `Lightshow`.
 */
export declare const LightshowSchema: v.ObjectSchema<InferObjectEntries<ILightshow>, undefined>;
//# sourceMappingURL=lightshow.d.ts.map