"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LightshowSchema = exports.FXEventFloatSchema = exports.FXEventBoxSchema = exports.LightTranslationEventSchema = exports.LightTranslationEventBoxSchema = exports.LightRotationEventSchema = exports.LightRotationEventBoxSchema = exports.LightColorEventSchema = exports.LightColorEventBoxSchema = exports.IndexFilterSchema = exports.EventBoxGroupSchema = exports.EventBoxSchema = exports.ColorBoostEventSchema = exports.BasicEventSchema = exports.WaypointSchema = void 0;
const _deps_js_1 = require("../../../../_deps.js");
const helpers_js_1 = require("../../helpers.js");
const mod_js_1 = require("../../shared/declaration/mod.js");
const mod_js_2 = require("../../v3/mod.js");
const common_js_1 = require("./common.js");
/**
 * Schema declaration for v4 `Waypoint`.
 */
exports.WaypointSchema = _deps_js_1.v.object({
    x: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    y: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.OffsetDirectionSchema), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Basic Event`.
 */
exports.BasicEventSchema = _deps_js_1.v.object({
    t: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    i: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    f: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Color Boost Event`.
 */
exports.ColorBoostEventSchema = _deps_js_1.v.object({
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Event Box`.
 */
exports.EventBoxSchema = _deps_js_1.v.object({
    f: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    l: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(common_js_1.ObjectSchema)), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Event Box Group`.
 */
exports.EventBoxGroupSchema = _deps_js_1.v.object({
    t: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.EventBoxTypeSchema), {
        version: '4.0.0',
    }),
    g: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.EventBoxSchema)), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Index Filter`.
 */
exports.IndexFilterSchema = _deps_js_1.v.object({
    f: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.IndexFilterTypeSchema), {
        version: '4.0.0',
    }),
    p: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    t: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    r: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '4.0.0',
    }),
    c: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    n: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.RandomTypeSchema), {
        version: '4.0.0',
    }),
    s: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    l: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.LimitAlsoAffectsTypeSchema), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Light Color Event Box`.
 */
exports.LightColorEventBoxSchema = _deps_js_1.v.object({
    w: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.DistributionTypeSchema), {
        version: '4.0.0',
    }),
    s: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    t: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.DistributionTypeSchema), {
        version: '4.0.0',
    }),
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '4.0.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.EaseTypeSchema), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Light Color Event`.
 */
exports.LightColorEventSchema = _deps_js_1.v.object({
    p: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '4.0.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.EaseTypeSchema), {
        version: '4.0.0',
    }),
    c: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.EventLightColorSchema), {
        version: '4.0.0',
    }),
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    f: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    sb: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    sf: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Light Rotation Event Box`.
 */
exports.LightRotationEventBoxSchema = _deps_js_1.v.object({
    w: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.DistributionTypeSchema), {
        version: '4.0.0',
    }),
    s: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    t: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.DistributionTypeSchema), {
        version: '4.0.0',
    }),
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '4.0.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.EaseTypeSchema), {
        version: '4.0.0',
    }),
    a: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.AxisSchema), {
        version: '4.0.0',
    }),
    f: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Light Rotation Event`.
 */
exports.LightRotationEventSchema = _deps_js_1.v.object({
    p: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '4.0.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.EaseTypeSchema), {
        version: '4.0.0',
    }),
    l: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.pipe(_deps_js_1.v.number(), _deps_js_1.v.integer())), {
        version: '4.0.0',
    }),
    r: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.LightRotationDirectionSchema), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Light Translation Event Box`.
 */
exports.LightTranslationEventBoxSchema = _deps_js_1.v.object({
    w: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.DistributionTypeSchema), {
        version: '4.0.0',
    }),
    s: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    t: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.DistributionTypeSchema), {
        version: '4.0.0',
    }),
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '4.0.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.EaseTypeSchema), {
        version: '4.0.0',
    }),
    a: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.AxisSchema), {
        version: '4.0.0',
    }),
    f: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Light Translation Event`.
 */
exports.LightTranslationEventSchema = _deps_js_1.v.object({
    p: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '4.0.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.EaseTypeSchema), {
        version: '4.0.0',
    }),
    t: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `FX Event Box`.
 */
exports.FXEventBoxSchema = _deps_js_1.v.object({
    w: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    d: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.DistributionTypeSchema), {
        version: '4.0.0',
    }),
    s: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    t: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.DistributionTypeSchema), {
        version: '4.0.0',
    }),
    b: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '4.0.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.EaseTypeSchema), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `FX Event Float`.
 */
exports.FXEventFloatSchema = _deps_js_1.v.object({
    p: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.picklist([0, 1])), {
        version: '4.0.0',
    }),
    e: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.EaseTypeSchema), {
        version: '4.0.0',
    }),
    v: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.number()), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
/**
 * Schema declaration for v4 `Lightshow`.
 */
exports.LightshowSchema = (0, helpers_js_1.entity)((x) => x.version || '4.0.0', {
    version: (0, helpers_js_1.field)((0, helpers_js_1.mask)(mod_js_1.VersionSchema), {
        version: '4.0.0',
    }),
    waypoints: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(common_js_1.ObjectLaneSchema)), {
        version: '4.0.0',
    }),
    waypointsData: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.WaypointSchema)), {
        version: '4.0.0',
    }),
    basicEvents: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(common_js_1.ObjectSchema)), {
        version: '4.0.0',
    }),
    basicEventsData: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.BasicEventSchema)), {
        version: '4.0.0',
    }),
    colorBoostEvents: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(common_js_1.ObjectSchema)), {
        version: '4.0.0',
    }),
    colorBoostEventsData: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.ColorBoostEventSchema)), {
        version: '4.0.0',
    }),
    eventBoxGroups: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.EventBoxGroupSchema)), {
        version: '4.0.0',
    }),
    indexFilters: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.IndexFilterSchema)), {
        version: '4.0.0',
    }),
    lightColorEventBoxes: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.LightColorEventBoxSchema)), {
        version: '4.0.0',
    }),
    lightColorEvents: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.LightColorEventSchema)), {
        version: '4.0.0',
    }),
    lightRotationEventBoxes: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.LightRotationEventBoxSchema)), {
        version: '4.0.0',
    }),
    lightRotationEvents: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.LightRotationEventSchema)), {
        version: '4.0.0',
    }),
    lightTranslationEventBoxes: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.LightTranslationEventBoxSchema)), {
        version: '4.0.0',
    }),
    lightTranslationEvents: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.LightTranslationEventSchema)), {
        version: '4.0.0',
    }),
    fxEventBoxes: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.FXEventBoxSchema)), {
        version: '4.0.0',
    }),
    floatFxEvents: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.array(exports.FXEventFloatSchema)), {
        version: '4.0.0',
    }),
    basicEventTypesWithKeywords: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_2.BasicEventTypesWithKeywordsSchema), {
        version: '4.0.0',
    }),
    useNormalEventsAsCompatibleEvents: (0, helpers_js_1.field)(_deps_js_1.v.optional(_deps_js_1.v.boolean()), {
        version: '4.0.0',
    }),
    customData: (0, helpers_js_1.field)(_deps_js_1.v.optional(mod_js_1.CustomDataSchema)),
});
