"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fxEventBox = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const fxEventBox_js_1 = require("../../core/fxEventBox.js");
const fxEventFloat_js_1 = require("./fxEventFloat.js");
const indexFilter_js_1 = require("./indexFilter.js");
/**
 * Schema serialization for v4 `FX Event Box`.
 */
exports.fxEventBox = {
    serialize(data) {
        return {
            data: {
                w: data.beatDistribution,
                d: data.beatDistributionType,
                s: data.fxDistribution,
                t: data.fxDistributionType,
                b: data.affectFirst,
                e: data.easing,
                customData: (0, json_js_1.deepCopy)(data.customData),
            },
            eventData: data.events.map((x) => {
                return fxEventFloat_js_1.fxEventFloat.serialize(x);
            }),
            filterData: indexFilter_js_1.indexFilter.serialize(data.filter),
        };
    },
    deserialize(data) {
        return (0, fxEventBox_js_1.createFxEventBox)({
            filter: indexFilter_js_1.indexFilter.deserialize(data.filterData ?? {}),
            beatDistribution: data.data?.w,
            beatDistributionType: data.data?.d,
            fxDistribution: data.data?.s,
            fxDistributionType: data.data?.t,
            affectFirst: data.data?.b,
            easing: data.data?.e,
            events: data.eventData?.map((x) => {
                return fxEventFloat_js_1.fxEventFloat.deserialize(x);
            }),
            customData: data.data?.customData,
        });
    },
};
