"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fxEventFloat = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const fxEventFloat_js_1 = require("../../core/fxEventFloat.js");
/**
 * Schema serialization for v4 `FX Event Float`.
 */
exports.fxEventFloat = {
    serialize(data) {
        return {
            data: {
                p: data.previous,
                e: data.easing,
                v: data.value,
                customData: (0, json_js_1.deepCopy)(data.customData),
            },
            time: data.time,
        };
    },
    deserialize(data) {
        return (0, fxEventFloat_js_1.createFxEventFloat)({
            time: data.time,
            previous: data.data?.p,
            easing: data.data?.e,
            value: data.data?.v,
            customData: data.data?.customData,
        });
    },
};
