"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.indexFilter = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const indexFilter_js_1 = require("../../core/indexFilter.js");
/**
 * Schema serialization for v4 `Index Filter`.
 */
exports.indexFilter = {
    serialize(data) {
        return {
            f: data.type,
            p: data.p0,
            t: data.p1,
            r: data.reverse,
            c: data.chunks,
            n: data.random,
            s: data.seed,
            l: data.limit,
            d: data.limitAffectsType,
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, indexFilter_js_1.createIndexFilter)({
            type: data.f,
            p0: data.p,
            p1: data.t,
            reverse: data.r,
            chunks: data.c,
            random: data.n,
            seed: data.s,
            limit: data.l,
            limitAffectsType: data.d,
            customData: data.customData,
        });
    },
};
