"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.infoBeatmap = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const infoBeatmap_js_1 = require("../../core/infoBeatmap.js");
/**
 * Schema serialization for v4 `Info Beatmap`.
 */
exports.infoBeatmap = {
    serialize(data) {
        return {
            characteristic: data.characteristic,
            difficulty: data.difficulty,
            beatmapAuthors: {
                mappers: [...data.authors.mappers],
                lighters: [...data.authors.lighters],
            },
            environmentNameIdx: data.environmentId,
            beatmapColorSchemeIdx: data.colorSchemeId,
            noteJumpMovementSpeed: data.njs,
            noteJumpStartBeatOffset: data.njsOffset,
            lightshowDataFilename: data.lightshowFilename,
            beatmapDataFilename: data.filename,
            customData: (0, json_js_1.deepCopy)(data.customData),
        };
    },
    deserialize(data) {
        return (0, infoBeatmap_js_1.createInfoBeatmap)({
            characteristic: data.characteristic,
            difficulty: data.difficulty,
            authors: {
                mappers: data.beatmapAuthors?.mappers,
                lighters: data.beatmapAuthors?.lighters,
            },
            filename: data.beatmapDataFilename,
            lightshowFilename: data.lightshowDataFilename,
            njs: data.noteJumpMovementSpeed,
            njsOffset: data.noteJumpStartBeatOffset,
            colorSchemeId: data.beatmapColorSchemeIdx,
            environmentId: data.environmentNameIdx,
            customData: data.customData,
        });
    },
};
