"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lightColorEvent = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const lightColorEvent_js_1 = require("../../core/lightColorEvent.js");
/**
 * Schema serialization for v4 `Light Color Event`.
 */
exports.lightColorEvent = {
    serialize(data) {
        return {
            data: {
                p: data.previous,
                c: data.color,
                e: data.easing,
                b: data.brightness,
                f: data.frequency,
                sb: data.strobeBrightness,
                sf: data.strobeFade,
                customData: (0, json_js_1.deepCopy)(data.customData),
            },
            time: data.time,
        };
    },
    deserialize(data) {
        return (0, lightColorEvent_js_1.createLightColorEvent)({
            time: data.time,
            previous: data.data?.p,
            color: data.data?.c,
            frequency: data.data?.f,
            easing: data.data?.e,
            brightness: data.data?.b,
            strobeBrightness: data.data?.sb,
            strobeFade: data.data?.sf,
            customData: data.data?.customData,
        });
    },
};
