"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lightColorEventBox = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const lightColorEventBox_js_1 = require("../../core/lightColorEventBox.js");
const indexFilter_js_1 = require("./indexFilter.js");
const lightColorEvent_js_1 = require("./lightColorEvent.js");
/**
 * Schema serialization for v4 `Light Color Event Box`.
 */
exports.lightColorEventBox = {
    serialize(data) {
        return {
            data: {
                w: data.beatDistribution,
                d: data.beatDistributionType,
                s: data.brightnessDistribution,
                t: data.brightnessDistributionType,
                b: data.affectFirst,
                e: data.easing,
                customData: (0, json_js_1.deepCopy)(data.customData),
            },
            eventData: data.events.map((x) => {
                return lightColorEvent_js_1.lightColorEvent.serialize(x);
            }),
            filterData: indexFilter_js_1.indexFilter.serialize(data.filter),
        };
    },
    deserialize(data) {
        return (0, lightColorEventBox_js_1.createLightColorEventBox)({
            filter: indexFilter_js_1.indexFilter.deserialize(data.filterData ?? {}),
            beatDistribution: data.data?.w,
            beatDistributionType: data.data?.d,
            brightnessDistribution: data.data?.s,
            brightnessDistributionType: data.data?.t,
            affectFirst: data.data?.b,
            easing: data.data?.e,
            events: data.eventData?.map((x) => {
                return lightColorEvent_js_1.lightColorEvent.deserialize(x);
            }),
            customData: data.data?.customData,
        });
    },
};
