"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lightColorEventBoxGroup = void 0;
const constants_js_1 = require("../../../types/beatmap/shared/constants.js");
const json_js_1 = require("../../../utils/misc/json.js");
const lightColorEventBoxGroup_js_1 = require("../../core/lightColorEventBoxGroup.js");
const lightColorEventBox_js_1 = require("./lightColorEventBox.js");
/**
 * Schema serialization for v4 `Light Color Event Box Group`.
 */
exports.lightColorEventBoxGroup = {
    serialize(data) {
        return {
            object: {
                t: constants_js_1.EventBoxType.COLOR,
                b: data.time,
                g: data.id,
                e: [],
                customData: (0, json_js_1.deepCopy)(data.customData),
            },
            boxData: data.boxes.map((x) => {
                return lightColorEventBox_js_1.lightColorEventBox.serialize(x);
            }),
        };
    },
    deserialize(data) {
        return (0, lightColorEventBoxGroup_js_1.createLightColorEventBoxGroup)({
            time: data.object?.b,
            id: data.object?.g,
            boxes: data.boxData?.map((x) => {
                return lightColorEventBox_js_1.lightColorEventBox.deserialize(x);
            }),
            customData: data.object?.customData,
        });
    },
};
