"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lightRotationEvent = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const lightRotationEvent_js_1 = require("../../core/lightRotationEvent.js");
/**
 * Schema serialization for v4 `Light Rotation Event`.
 */
exports.lightRotationEvent = {
    serialize(data) {
        return {
            data: {
                p: data.previous,
                l: data.loop,
                e: data.easing,
                r: data.rotation,
                d: data.direction,
                customData: (0, json_js_1.deepCopy)(data.customData),
            },
            time: data.time,
        };
    },
    deserialize(data) {
        return (0, lightRotationEvent_js_1.createLightRotationEvent)({
            time: data.time,
            previous: data.data?.p,
            easing: data.data?.e,
            loop: data.data?.l,
            rotation: data.data?.r,
            direction: data.data?.d,
            customData: data.data?.customData,
        });
    },
};
