"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lightRotationEventBoxGroup = void 0;
const constants_js_1 = require("../../../types/beatmap/shared/constants.js");
const json_js_1 = require("../../../utils/misc/json.js");
const lightRotationEventBoxGroup_js_1 = require("../../core/lightRotationEventBoxGroup.js");
const lightRotationEventBox_js_1 = require("./lightRotationEventBox.js");
/**
 * Schema serialization for v4 `Light Rotation Event Box Group`.
 */
exports.lightRotationEventBoxGroup = {
    serialize(data) {
        return {
            object: {
                t: constants_js_1.EventBoxType.ROTATION,
                b: data.time,
                g: data.id,
                e: [],
                customData: (0, json_js_1.deepCopy)(data.customData),
            },
            boxData: data.boxes.map((x) => {
                return lightRotationEventBox_js_1.lightRotationEventBox.serialize(x);
            }),
        };
    },
    deserialize(data) {
        return (0, lightRotationEventBoxGroup_js_1.createLightRotationEventBoxGroup)({
            time: data.object?.b,
            id: data.object?.g,
            boxes: data.boxData?.map((x) => {
                return lightRotationEventBox_js_1.lightRotationEventBox.deserialize(x);
            }),
            customData: data.object?.customData,
        });
    },
};
