"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lightTranslationEvent = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const lightTranslationEvent_js_1 = require("../../core/lightTranslationEvent.js");
/**
 * Schema serialization for v4 `Light Translation Event`.
 */
exports.lightTranslationEvent = {
    serialize(data) {
        return {
            data: {
                p: data.previous,
                e: data.easing,
                t: data.translation,
                customData: (0, json_js_1.deepCopy)(data.customData),
            },
            time: data.time,
        };
    },
    deserialize(data) {
        return (0, lightTranslationEvent_js_1.createLightTranslationEvent)({
            time: data.time,
            previous: data.data?.p,
            easing: data.data?.e,
            translation: data.data?.t,
            customData: data.data?.customData,
        });
    },
};
