"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lightTranslationEventBoxGroup = void 0;
const constants_js_1 = require("../../../types/beatmap/shared/constants.js");
const json_js_1 = require("../../../utils/misc/json.js");
const lightTranslationEventBoxGroup_js_1 = require("../../core/lightTranslationEventBoxGroup.js");
const lightTranslationEventBox_js_1 = require("./lightTranslationEventBox.js");
/**
 * Schema serialization for v4 `Light Translation Event Box Group`.
 */
exports.lightTranslationEventBoxGroup = {
    serialize(data) {
        return {
            object: {
                t: constants_js_1.EventBoxType.TRANSLATION,
                b: data.time,
                g: data.id,
                e: [],
                customData: (0, json_js_1.deepCopy)(data.customData),
            },
            boxData: data.boxes.map((x) => {
                return lightTranslationEventBox_js_1.lightTranslationEventBox.serialize(x);
            }),
        };
    },
    deserialize(data) {
        return (0, lightTranslationEventBoxGroup_js_1.createLightTranslationEventBoxGroup)({
            time: data.object?.b,
            id: data.object?.g,
            boxes: data.boxData?.map((x) => {
                return lightTranslationEventBox_js_1.lightTranslationEventBox.deserialize(x);
            }),
            customData: data.object?.customData,
        });
    },
};
