"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.njsEvent = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const njsEvent_js_1 = require("../../core/njsEvent.js");
/**
 * Schema serialization for v4 `Basic Event`.
 */
exports.njsEvent = {
    serialize(data) {
        return {
            object: {
                b: data.time,
                i: 0,
                customData: {},
            },
            data: {
                d: data.value,
                p: data.previous,
                e: data.easing,
                customData: (0, json_js_1.deepCopy)(data.customData),
            },
        };
    },
    deserialize(data) {
        return (0, njsEvent_js_1.createNJSEvent)({
            time: data.object?.b,
            value: data.data?.d,
            previous: data.data?.p,
            easing: data.data?.e,
            customData: data.data?.customData,
        });
    },
};
