"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.obstacle = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const obstacle_js_1 = require("../../core/obstacle.js");
/**
 * Schema serialization for v4 `Obstacle`.
 */
exports.obstacle = {
    serialize(data) {
        return {
            object: {
                b: data.time,
                i: 0,
                r: data.laneRotation,
                customData: {},
            },
            data: {
                x: data.posX,
                y: data.posY,
                d: data.duration,
                w: data.width,
                h: data.height,
                customData: (0, json_js_1.deepCopy)(data.customData),
            },
        };
    },
    deserialize(data) {
        return (0, obstacle_js_1.createObstacle)({
            time: data.object?.b,
            laneRotation: data.object?.r,
            posX: data.data?.x,
            posY: data.data?.y,
            duration: data.data?.d,
            width: data.data?.w,
            height: data.data?.h,
            customData: data.data?.customData,
        });
    },
};
