"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.rotationEvent = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const rotationEvent_js_1 = require("../../core/rotationEvent.js");
/**
 * Schema serialization for v4 `Rotation Event`.
 *
 * @deprecated removed as of 1.39, convert to `r` in object lane
 */
exports.rotationEvent = {
    serialize(data) {
        return {
            object: { b: data.time },
            data: {
                e: data.executionTime,
                r: data.rotation,
                customData: (0, json_js_1.deepCopy)(data.customData),
            },
        };
    },
    deserialize(data) {
        return (0, rotationEvent_js_1.createRotationEvent)({
            time: data.object?.b,
            executionTime: data.data?.e,
            rotation: data.data?.r,
            customData: data.data?.customData,
        });
    },
};
