"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.waypoint = void 0;
const json_js_1 = require("../../../utils/misc/json.js");
const waypoint_js_1 = require("../../core/waypoint.js");
/**
 * Schema serialization for v4 `Waypoint`.
 */
exports.waypoint = {
    serialize(data) {
        return {
            object: {
                b: data.time,
                i: 0,
                r: data.laneRotation,
                customData: {},
            },
            data: {
                x: data.posX,
                y: data.posY,
                d: data.direction,
                customData: (0, json_js_1.deepCopy)(data.customData),
            },
        };
    },
    deserialize(data) {
        return (0, waypoint_js_1.createWaypoint)({
            time: data.object?.b,
            laneRotation: data.object?.r,
            posX: data.data?.x,
            posY: data.data?.y,
            direction: data.data?.d,
            customData: data.data?.customData,
        });
    },
};
