import type { ColorSchemeName } from '../../types/beatmap/shared/colorScheme.js';
import type { EnvironmentAllName } from '../../types/beatmap/shared/environment.js';
import type { IColorScheme } from '../../types/beatmap/v2/custom/colorScheme.js';
import type { IWrapInfoColorScheme } from '../../types/beatmap/wrapper/info.js';
/** Record of Environment Color to Color Scheme. */
export declare const EnvironmentSchemeName: {
    readonly [key in EnvironmentAllName]: ColorSchemeName;
};
/** Custom Color property rename to human readable. */
export declare const CustomColorRename: {
    readonly [key in keyof Required<IColorScheme>]: string;
};
/** Color Scheme property rename to human readable. */
export declare const ColorSchemeRename: {
    readonly [key in keyof Required<Omit<IWrapInfoColorScheme, 'name' | 'overrideNotes' | 'overrideLights'>>]: string;
};
/** Color scheme definition. */
export declare const ColorScheme: {
    readonly [key in ColorSchemeName]: Readonly<Omit<IColorScheme, 'a'>>;
};
/**
 * Color scheme variants that overlays on top of the base color scheme.
 */
export declare const ColorSchemeVariant: {
    readonly [key in ColorSchemeName]?: {
        readonly [key: string]: Readonly<Omit<IColorScheme, 'a'>>;
    };
};
//# sourceMappingURL=colorScheme.d.ts.map