"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RotationValueEventValue = exports.EventLaneRotationValue = exports.NoteDirectionSpace = exports.NoteDirectionFlip = exports.NoteDirectionAngle = exports.NoteYOffset = exports.NOTE_SIZE = exports.LANE_SIZE = exports.LINE_COUNT = void 0;
const constants_js_1 = require("../../types/beatmap/shared/constants.js");
__exportStar(require("../../types/beatmap/shared/custom/constants.js"), exports);
__exportStar(require("../../types/beatmap/shared/constants.js"), exports);
/** Also known as lane count. */
exports.LINE_COUNT = 4;
/** Size of grid in unity unit */
exports.LANE_SIZE = 0.6;
/** Size of regular note in unity unit */
exports.NOTE_SIZE = [0.5, 0.5];
/** Y-offset of note on grid in unity unit */
exports.NoteYOffset = {
    0: 0,
    1: 0.05,
    2: 0.1,
};
/**
 * Cut angle corresponding to the `direction`.
 * ```ts
 * 0 (UP) -> 180
 * 1 (DOWN) -> 0
 * 2 (LEFT) -> 270
 * 3 (RIGHT) -> 90
 * 4 (UP_LEFT) -> 225
 * 5 (UP_RIGHT) -> 135
 * 6 (DOWN_LEFT) -> 315
 * 7 (DOWN_RIGHT) -> 45
 * 8 (ANY) -> 0
 * ```
 *
 * **NOTE:** Rotation in counter-clockwise.
 */
exports.NoteDirectionAngle = {
    [constants_js_1.NoteDirection.UP]: 180,
    [constants_js_1.NoteDirection.DOWN]: 0,
    [constants_js_1.NoteDirection.LEFT]: 270,
    [constants_js_1.NoteDirection.RIGHT]: 90,
    [constants_js_1.NoteDirection.UP_LEFT]: 225,
    [constants_js_1.NoteDirection.UP_RIGHT]: 135,
    [constants_js_1.NoteDirection.DOWN_LEFT]: 315,
    [constants_js_1.NoteDirection.DOWN_RIGHT]: 45,
    [constants_js_1.NoteDirection.ANY]: 0,
};
/**
 * Opposite direction corresponding to the `direction`.
 * ```ts
 * 0 (UP) -> 1 (DOWN)
 * 1 (DOWN) -> 0 (UP)
 * 2 (LEFT) -> 3 (RIGHT)
 * 3 (RIGHT) -> 2 (LEFT)
 * 4 (UP_LEFT) -> 7 (DOWN_RIGHT)
 * 5 (UP_RIGHT) -> 6 (DOWN_LEFT)
 * 6 (DOWN_LEFT) -> 5 (UP_RIGHT)
 * 7 (DOWN_RIGHT) -> 4 (UP_LEFT)
 * 8 (ANY) -> 8 (ANY)
 * ```
 */
exports.NoteDirectionFlip = {
    [constants_js_1.NoteDirection.UP]: constants_js_1.NoteDirection.DOWN,
    [constants_js_1.NoteDirection.DOWN]: constants_js_1.NoteDirection.UP,
    [constants_js_1.NoteDirection.LEFT]: constants_js_1.NoteDirection.RIGHT,
    [constants_js_1.NoteDirection.RIGHT]: constants_js_1.NoteDirection.LEFT,
    [constants_js_1.NoteDirection.UP_LEFT]: constants_js_1.NoteDirection.DOWN_RIGHT,
    [constants_js_1.NoteDirection.UP_RIGHT]: constants_js_1.NoteDirection.DOWN_LEFT,
    [constants_js_1.NoteDirection.DOWN_LEFT]: constants_js_1.NoteDirection.UP_RIGHT,
    [constants_js_1.NoteDirection.DOWN_RIGHT]: constants_js_1.NoteDirection.UP_LEFT,
    [constants_js_1.NoteDirection.ANY]: constants_js_1.NoteDirection.ANY,
};
/**
 * Array index mapped to tuple of `posX` and `posY` corresponding to the `direction`.
 * ```ts
 * 0 -> [0, 1]
 * 1 -> [0, -1]
 * 2 -> [-1, 0]
 * 3 -> [1, 0]
 * 4 -> [-1, 1]
 * 5 -> [1, 1]
 * 6 -> [-1, -1]
 * 7 -> [1, -1]
 * 8 -> [0, 0]
 * ```
 */
exports.NoteDirectionSpace = {
    [constants_js_1.NoteDirection.UP]: [0, 1],
    [constants_js_1.NoteDirection.DOWN]: [0, -1],
    [constants_js_1.NoteDirection.LEFT]: [-1, 0],
    [constants_js_1.NoteDirection.RIGHT]: [1, 0],
    [constants_js_1.NoteDirection.UP_LEFT]: [-1, 1],
    [constants_js_1.NoteDirection.UP_RIGHT]: [1, 1],
    [constants_js_1.NoteDirection.DOWN_LEFT]: [-1, -1],
    [constants_js_1.NoteDirection.DOWN_RIGHT]: [1, -1],
    [constants_js_1.NoteDirection.ANY]: [0, 0],
};
/** Unused as of beatmap v3, useful for conversion reason. */
exports.EventLaneRotationValue = {
    0: -60,
    1: -45,
    2: -30,
    3: -15,
    4: 15,
    5: 30,
    6: 45,
    7: 60,
};
/** Unused as of beatmap v3, useful for conversion reason. */
exports.RotationValueEventValue = {
    '-60': 0,
    '-45': 1,
    '-30': 2,
    '-15': 3,
    '15': 4,
    '30': 5,
    '45': 6,
    '60': 7,
};
