import type { StandardSchemaV1 } from '../../_deps.js';
import type { ISchemaCheckOptions } from '../../types/beatmap/options/schema.js';
import type { ISchemaDeclaration } from '../../types/beatmap/shared/schema.js';
import type { Version } from '../../types/beatmap/shared/version.js';
/**
 * Deeply check JSON schema given `Data Check` or `StandardSchemaV1` schema.
 *
 * Strict null policy. Return error logs as `StandardSchemaV1.Issue[]` for error inspection.
 */
export declare function schemaCheck<Schema extends {
    [key: string]: ISchemaDeclaration;
} | StandardSchemaV1>(data: unknown, schema: Schema, label: string, version?: Version | undefined, throwOn?: Partial<ISchemaCheckOptions['throwOn']>, _errors?: StandardSchemaV1.Issue[]): StandardSchemaV1.Issue[];
//# sourceMappingURL=schema.d.ts.map