"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EnvironmentGrab = void 0;
// deno-lint-ignore-file no-unused-vars
class EnvironmentGrabBase {
    constructor() {
        Object.defineProperty(this, "_regex", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: ''
        });
        Object.defineProperty(this, "_string", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: ''
        });
    }
    get regex() {
        return this._regex;
    }
    get string() {
        return this._string;
    }
}
class EnvironmentGrab extends EnvironmentGrabBase {
    constructor(value) {
        super();
        Object.defineProperty(this, "hasNested", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        if (value) {
            this._string = value;
            this._regex = value;
        }
    }
    static create(value) {
        if (value) {
            return new this(value);
        }
        return new this();
    }
    /** Grab game object name. */
    name(value) {
        this._string += value.trim();
        this._regex += value.trim();
        return this;
    }
    /** Take duplicate ID. */
    id(id, optional) {
        if (id !== null) {
            if (optional) {
                this._regex += `( \\(${id}\\))?`;
            }
            else {
                this._regex += ` \\(${id}\\)`;
            }
            this._string += ` (${id})`;
        }
        else {
            if (optional) {
                this._regex += `( \\(\\d+\\))?`;
            }
            else {
                this._regex += ` \\(\\d+\\)`;
            }
            this._string += ` (1)`;
        }
        return this;
    }
    /** Add spaces. */
    space(count = 1) {
        for (let i = 0; i < count; i++) {
            this._string += ' ';
            this._regex += ' ';
        }
        return this;
    }
    /** Grab cloned. */
    clone(count = 1) {
        for (let i = 0; i < count; i++) {
            this._string += ' (Clone)';
            this._regex += ' \\(Clone\\)';
        }
        return this;
    }
    /**  Final regex point, also endpoint. */
    end() {
        this._regex += '$';
        return this;
    }
    /** Move into child, ID is optional for regex. */
    child(id) {
        this._string += `.[${typeof id === 'number' ? id : 1}]`;
        this._regex += `\\.\\[${typeof id === 'number' ? id : '\\d+'}\\]`;
        return this;
    }
}
exports.EnvironmentGrab = EnvironmentGrab;
Object.defineProperty(EnvironmentGrab, "Preset", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: {
        ENVIRONMENT: new EnvironmentGrab().child().name('Environment').end(),
        CONSTRUCTION: new EnvironmentGrab('Environment')
            .child()
            .name('Construction')
            .end(),
        SMOKE: new EnvironmentGrab().child().name('BigSmokePS').end(),
    }
});
class EnvironmentGrabEnd extends EnvironmentGrabBase {
}
class EnvironmentGrabChild extends EnvironmentGrabBase {
    name(value) {
        return this;
    }
    space(count = 1) {
        return this;
    }
}
class EnvironmentGrabNamed extends EnvironmentGrabBase {
    id(id, optional) {
        return this;
    }
    clone(count = 1) {
        return this;
    }
    end() {
        return this;
    }
    child(id) {
        return this;
    }
    space(count = 1) {
        return this;
    }
}
class EnvironmentGrabNamedID extends EnvironmentGrabBase {
    clone(count = 1) {
        return this;
    }
    end() {
        return this;
    }
    child(id) {
        return this;
    }
    space(count = 1) {
        return this;
    }
}
