"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.randomFlip = randomFlip;
const random_js_1 = require("../../../../utils/math/random.js");
/**
 * Apply random flip to notes.
 * ```ts
 * ne.randomFlip(notes, [[-4, 4], [0, 2]]);
 * ```
 */
function randomFlip(notes, range) {
    const [xVec, yVec] = range.map((r) => r.sort((a, b) => a - b));
    notes.forEach((n) => {
        n.customData.flip = [(0, random_js_1.random)(xVec[0], xVec[1]), (0, random_js_1.random)(yVec[0], yVec[1])];
    });
}
