"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFloatPointDefinition = isFloatPointDefinition;
exports.isVec3PointDefinition = isVec3PointDefinition;
exports.isVec4PointDefinition = isVec4PointDefinition;
exports.isFloatPointDefinitionBase = isFloatPointDefinitionBase;
exports.isVec3PointDefinitionBase = isVec3PointDefinitionBase;
exports.isVec4PointDefinitionBase = isVec4PointDefinitionBase;
exports.isPointDefinitionOperand = isPointDefinitionOperand;
function isFloatPointDefinition(point) {
    return isFloatPointDefinitionBase(point);
}
function isVec3PointDefinition(point) {
    return isVec3PointDefinitionBase(point);
}
function isVec4PointDefinition(point) {
    return isVec4PointDefinitionBase(point);
}
function isFloatPointDefinitionBase(point) {
    return (Array.isArray(point) &&
        point.every((x) => Array.isArray(x) &&
            (x.length > 2
                ? typeof x[1] === 'number' && typeof x[2] === 'string'
                : x.length === 2 && typeof x[1] === 'number')));
}
function isVec3PointDefinitionBase(point) {
    return (Array.isArray(point) &&
        point.every((x) => Array.isArray(x) &&
            (x.length > 4
                ? typeof x[3] === 'number' && typeof x[4] === 'string'
                : x.length === 4 && typeof x[3] === 'number')));
}
function isVec4PointDefinitionBase(point) {
    return (Array.isArray(point) &&
        point.every((x) => Array.isArray(x) &&
            (x.length > 5
                ? typeof x[4] === 'number' && typeof x[5] === 'string'
                : x.length === 5 && typeof x[4] === 'number')));
}
function isPointDefinitionOperand(point) {
    return (Array.isArray(point) &&
        point.some((x) => typeof x === 'string' && x.startsWith('op')));
}
