import type { TimeProcessor } from '../../beatmap/helpers/timeProcessor.js';
import type { IWrapBaseNote } from '../../types/beatmap/wrapper/baseNote.js';
import type { IWrapBaseObject } from '../../types/beatmap/wrapper/baseObject.js';
import type { ISwingAnalysisBaseNote, ISwingContainer } from './types/swing.js';
/**
 * Generate swings from beatmap notes.
 */
export declare function generate<T extends ISwingAnalysisBaseNote>(notes: T[], timeProc: TimeProcessor): ISwingContainer<T>[];
/**
 * Check if next swing happen from `prevNote` to `currNote`.
 */
export declare function next<T extends Pick<IWrapBaseNote, 'time' | 'posX' | 'posY' | 'direction'>>(currNote: T, prevNote: T, timeProc: TimeProcessor, context?: T[]): boolean;
/** Calculate effective BPM between `currObj` and `prevObj`. */
export declare function calcEBPMBetweenObject<T extends Pick<IWrapBaseObject, 'time'>>(currObj: T, prevObj: T, timeProc: TimeProcessor): number;
//# sourceMappingURL=swing.d.ts.map