"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.globals = exports.logger = exports.Logger = void 0;
/**
 * Beat Saber general-purpose scripting module.
 *
 * This module provides beatmap schema, class object, and various toolings to handle Beat Saber map.
 *
 * `extensions` module is omitted from the main module as it is unstable and contain 3rd-party library.
 *
 * `patch` module is separated as it is non-essential and used to correct issues from existing beatmap.
 *
 * If you wish to only use schema, feel free to import from `types` module directly.
 *
 * @example Quickstart
 * ```ts
 * import { globals, readDifficultyFileSync, writeDifficultyFileSync } from "@kvl/bsmap";
 * globals.directory = '/path/to/map/folder/here'; // implicitly uses cwd if not written
 * const data = readDifficultyFileSync('ExpertStandard.dat', 3);
 * // ... do what you want here with `data`
 * writeDifficultyFileSync(data);
 * ```
 *
 * @module
 */
require("./_dnt.polyfills.js");
__exportStar(require("./beatmap/mod.js"), exports);
__exportStar(require("./read/mod.js"), exports);
__exportStar(require("./write/mod.js"), exports);
var logger_js_1 = require("./logger.js");
Object.defineProperty(exports, "Logger", { enumerable: true, get: function () { return logger_js_1.Logger; } });
Object.defineProperty(exports, "logger", { enumerable: true, get: function () { return logger_js_1.logger; } });
var globals_js_1 = require("./globals.js");
Object.defineProperty(exports, "globals", { enumerable: true, get: function () { return globals_js_1.globals; } });
