"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fixCustomDataEvent = fixCustomDataEvent;
const helpers_js_1 = require("./helpers.js");
/**
 * Fix custom data for beatmap basic event.
 */
function fixCustomDataEvent(cd) {
    if (!cd) {
        return;
    }
    if (cd._color != null)
        cd._color = (0, helpers_js_1.fixColor)(cd._color, [0, 0, 0, 1]);
    if (cd._lightID != null) {
        cd._lightID = Array.isArray(cd._lightID)
            ? cd._lightID
                .filter((id) => typeof id === 'number')
                .map((id) => (0, helpers_js_1.fixInt)(id))
                .filter(function (x, i, ary) {
                return !i || x !== ary[i - 1];
            })
                .sort((a, b) => a - b)
            : (0, helpers_js_1.fixInt)(cd._lightID, 1);
    }
    if (cd._propID != null)
        cd._propID = (0, helpers_js_1.fixInt)(cd._propID, 1);
    if (cd._easing != null)
        cd._easing = (0, helpers_js_1.fixString)(cd._easing, 'easeLinear');
    if (cd._lerpType != null)
        cd._lerpType = (0, helpers_js_1.fixString)(cd._lerpType, 'RGB');
    if (cd._nameFilter != null)
        cd._nameFilter = (0, helpers_js_1.fixString)(cd._nameFilter, '');
    if (cd._rotation != null)
        cd._rotation = (0, helpers_js_1.fixFloat)(cd._rotation, 0);
    if (cd._step != null)
        cd._step = (0, helpers_js_1.fixFloat)(cd._step, 0);
    if (cd._prop != null)
        cd._prop = (0, helpers_js_1.fixFloat)(cd._prop, 1);
    if (cd._speed != null)
        cd._speed = (0, helpers_js_1.fixFloat)(cd._speed, 1);
    if (cd._direction != null)
        cd._direction = (0, helpers_js_1.fixInt)(cd._direction, 0);
    if (cd._lockPosition != null) {
        cd._lockPosition = (0, helpers_js_1.fixBoolean)(cd._lockPosition, false);
    }
    if (cd._preciseSpeed != null) {
        cd._preciseSpeed = (0, helpers_js_1.fixFloat)(cd._preciseSpeed, 0);
    }
    if (cd._reset != null)
        cd._reset = (0, helpers_js_1.fixBoolean)(cd._reset, false);
    if (cd._counterSpin != null) {
        cd._counterSpin = (0, helpers_js_1.fixBoolean)(cd._counterSpin, false);
    }
    if (cd._stepMult != null)
        cd._stepMult = (0, helpers_js_1.fixFloat)(cd._stepMult, 1);
    if (cd._propMult != null)
        cd._propMult = (0, helpers_js_1.fixFloat)(cd._propMult, 1);
    if (cd._speedMult != null)
        cd._speedMult = (0, helpers_js_1.fixFloat)(cd._speedMult, 1);
    if (cd.color != null)
        cd.color = (0, helpers_js_1.fixColor)(cd.color, [0, 0, 0, 1]);
    if (cd.lightID != null) {
        cd.lightID = Array.isArray(cd.lightID)
            ? cd.lightID
                .filter((id) => id != null)
                .map((id) => (0, helpers_js_1.fixInt)(id, 1))
                .filter(function (x, i, ary) {
                return !i || x !== ary[i - 1];
            })
                .sort((a, b) => a - b)
            : (0, helpers_js_1.fixInt)(cd.lightID, 1);
    }
    if (cd.easing != null)
        cd.easing = (0, helpers_js_1.fixString)(cd.easing, 'easeLinear');
    if (cd.lerpType != null)
        cd.lerpType = (0, helpers_js_1.fixString)(cd.lerpType, 'RGB');
    if (cd.nameFilter != null)
        cd.nameFilter = (0, helpers_js_1.fixString)(cd.nameFilter, '');
    if (cd.rotation != null)
        cd.rotation = (0, helpers_js_1.fixInt)(cd.rotation, 0);
    if (cd.step != null)
        cd.step = (0, helpers_js_1.fixInt)(cd.step, 0);
    if (cd.prop != null)
        cd.prop = (0, helpers_js_1.fixInt)(cd.prop, 1);
    if (cd.speed != null)
        cd.speed = (0, helpers_js_1.fixInt)(cd.speed, 1);
    if (cd.direction != null)
        cd.direction = (0, helpers_js_1.fixInt)(cd.direction, 0);
    if (cd.lockRotation != null) {
        cd.lockRotation = (0, helpers_js_1.fixBoolean)(cd.lockRotation, false);
    }
}
