import type { PointDefinition1Base, PointDefinition3Base, PointDefinition4Base } from '../../types/beatmap/shared/custom/heck.js';
import type { ColorArray } from '../../types/colors.js';
import type { Vector2, Vector3, Vector4 } from '../../types/vector.js';
/**
 * Fix boolean value by interpreting unknown value as boolean or return default value.
 */
export declare function fixBoolean(value: unknown): boolean;
export declare function fixBoolean(value: unknown, defaultValue: boolean): boolean;
/**
 * Fix integer value by interpreting unknown value as integer or return default value.
 */
export declare function fixInt<T extends number>(value: unknown): T;
export declare function fixInt<T extends number>(value: unknown, defaultValue: T): T;
export declare function fixInt<T extends number>(value: unknown, defaultValue: T | [T, T], range: T[]): T;
/**
 * Fix float value by interpreting unknown value as float or return default value.
 */
export declare function fixFloat(value: unknown): number;
export declare function fixFloat(value: unknown, defaultValue: number): number;
export declare function fixFloat(value: unknown, defaultValue: number, min: number, max: number): number;
/**
 * Fix string value by interpreting unknown value as string or return default value.
 */
export declare function fixString<T extends string>(value: unknown): T;
export declare function fixString<T extends string>(value: unknown, defaultValue: T): T;
/**
 * Fix string array value by interpreting unknown value as string array or return default value.
 */
export declare function fixStringAry(value: unknown[], defaultValue: string): string[];
/**
 * Fix vector value by interpreting unknown value as vector or return default value.
 */
export declare function fixVector2(value: unknown, defaultValue: Vector2): Vector2;
/**
 * Fix vector value by interpreting unknown value as vector or return default value.
 */
export declare function fixVector3(value: unknown, defaultValue: Vector3): Vector3;
/**
 * Fix vector value by interpreting unknown value as vector or return default value.
 */
export declare function fixVector4(value: unknown, defaultValue: Vector4): Vector4;
/**
 * Fix color value by interpreting unknown value as color or return default value.
 */
export declare function fixColor(value: unknown, defaultValue: ColorArray): ColorArray;
/**
 * Fix float point definition value by interpreting unknown value as float point definition or return default value.
 */
export declare function fixPointDefinition1Base(value: unknown, defaultValue: number): PointDefinition1Base[];
/**
 * Fix vector point definition value by interpreting unknown value as vector point definition or return default value.
 */
export declare function fixPointDefinition3Base(value: unknown, defaultValue: Vector3): PointDefinition3Base[];
/**
 * Fix vector point definition value by interpreting unknown value as vector point definition or return default value.
 */
export declare function fixPointDefinition4Base(value: unknown, defaultValue: Vector4): PointDefinition4Base[];
//# sourceMappingURL=helpers.d.ts.map