"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.tag = tag;
exports.handleRead = handleRead;
exports.handleReadSync = handleReadSync;
// deno-lint-ignore-file no-explicit-any
const _main_js_1 = require("../beatmap/loader/_main.js");
const globals_js_1 = require("../globals.js");
const _json_js_1 = require("../shims/_json.js");
const path_js_1 = require("../shims/path.js");
const defaultOptions = {
    directory: '',
    load: {},
};
function tag(name) {
    return ['reader', name];
}
function handleRead(type, src, version, options = {}) {
    const ver = typeof version === 'number' ? version : null;
    const opt = (typeof version !== 'number' ? version : options) ?? {};
    const p = path_js_1.path.resolve(opt.directory ?? (defaultOptions.directory || globals_js_1.globals.directory), src);
    const [posttransformer, ...postprocesses] = [
        ...(opt.load?.postprocess ?? []),
    ].reverse();
    return (0, _json_js_1.readJSONFile)(p).then((data) => {
        return (0, _main_js_1.loadBeatmap)(type, data, ver, {
            ...opt.load,
            postprocess: [
                ...postprocesses,
                (x) => {
                    if (type === 'lightshow' && 'lightshowFilename' in x) {
                        x.lightshowFilename = path_js_1.path.basename(p);
                    }
                    else
                        x.filename = path_js_1.path.basename(p);
                    return posttransformer ? posttransformer(x) : x;
                },
            ],
        });
    });
}
function handleReadSync(type, src, version, options = {}) {
    const ver = typeof version === 'number' ? version : null;
    const opt = (typeof version !== 'number' ? version : options) ?? {};
    const p = path_js_1.path.resolve(opt.directory ?? (defaultOptions.directory || globals_js_1.globals.directory), src);
    const [posttransformer, ...postprocesses] = [
        ...(opt.load?.postprocess ?? []),
    ].reverse();
    const d = (0, _main_js_1.loadBeatmap)(type, (0, _json_js_1.readJSONFileSync)(p), ver, {
        ...opt.load,
        postprocess: [
            ...postprocesses,
            (x) => {
                if (type === 'lightshow' && 'lightshowFilename' in x) {
                    x.lightshowFilename = path_js_1.path.basename(p);
                }
                else
                    x.filename = path_js_1.path.basename(p);
                return posttransformer ? posttransformer(x) : x;
            },
        ],
    });
    return d;
}
