import type { Easings } from '../../../easings.js';
import type { LooseAutocomplete } from '../../../utils.js';
export type PointDefinition1Base = [
    base1: number | LooseAutocomplete<BaseModifier>,
    time?: number,
    ...options: PointOption[]
] | [
    base1: number | LooseAutocomplete<BaseModifier>,
    operand?: PointDefinitionAllOperand,
    time?: number,
    ...options: PointOption[]
];
export type PointDefinition2Base = [
    base1: number | LooseAutocomplete<BaseModifier>,
    base2: number | LooseAutocomplete<BaseModifier>,
    time?: number,
    ...options: PointOption[]
] | [
    base1: number | LooseAutocomplete<BaseModifier>,
    base2: number | LooseAutocomplete<BaseModifier>,
    operand?: PointDefinitionAllOperand,
    time?: number,
    ...options: PointOption[]
];
export type PointDefinition3Base = [
    base1: number | LooseAutocomplete<BaseModifier>,
    base2: number | LooseAutocomplete<BaseModifier>,
    base3: number | LooseAutocomplete<BaseModifier>,
    time?: number,
    ...options: PointOption[]
] | [
    base1: number | LooseAutocomplete<BaseModifier>,
    base2: number | LooseAutocomplete<BaseModifier>,
    base3: number | LooseAutocomplete<BaseModifier>,
    operand?: PointDefinitionAllOperand,
    time?: number,
    ...options: PointOption[]
];
export type PointDefinition4Base = [
    base1: number | LooseAutocomplete<BaseModifier>,
    base2: number | LooseAutocomplete<BaseModifier>,
    base3: number | LooseAutocomplete<BaseModifier>,
    base4: number | LooseAutocomplete<BaseModifier>,
    time?: number,
    ...options: PointOption[]
] | [
    base1: number | LooseAutocomplete<BaseModifier>,
    base2: number | LooseAutocomplete<BaseModifier>,
    base3: number | LooseAutocomplete<BaseModifier>,
    base4: number | LooseAutocomplete<BaseModifier>,
    operand?: PointDefinitionAllOperand,
    time?: number,
    ...options: PointOption[]
];
export type PointDefinition1Operand = [
    operand1: number | LooseAutocomplete<BaseModifier>,
    op: PointOperation,
    chain?: PointDefinitionAllOperand
];
export type PointDefinition2Operand = [
    operand1: number | LooseAutocomplete<BaseModifier>,
    operand2: number | LooseAutocomplete<BaseModifier>,
    op: PointOperation,
    chain?: PointDefinitionAllOperand
];
export type PointDefinition3Operand = [
    operand1: number | LooseAutocomplete<BaseModifier>,
    operand2: number | LooseAutocomplete<BaseModifier>,
    operand3: number | LooseAutocomplete<BaseModifier>,
    op: PointOperation,
    chain?: PointDefinitionAllOperand
];
export type PointDefinition4Operand = [
    operand1: number | LooseAutocomplete<BaseModifier>,
    operand2: number | LooseAutocomplete<BaseModifier>,
    operand3: number | LooseAutocomplete<BaseModifier>,
    operand4: number | LooseAutocomplete<BaseModifier>,
    op: PointOperation,
    chain?: PointDefinitionAllOperand
];
export type PointDefinitionAllOperand = PointDefinition1Operand | PointDefinition2Operand | PointDefinition3Operand | PointDefinition4Operand;
export type PointDefinition1Modifier = [
    base1: number | LooseAutocomplete<BaseModifier>,
    ...PointDefinitionAllOperand[]
];
export type PointDefinition2Modifier = [
    base1: number | LooseAutocomplete<BaseModifier>,
    base2: number | LooseAutocomplete<BaseModifier>,
    ...PointDefinitionAllOperand[]
];
export type PointDefinition3Modifier = [
    base1: number | LooseAutocomplete<BaseModifier>,
    base2: number | LooseAutocomplete<BaseModifier>,
    base3: number | LooseAutocomplete<BaseModifier>,
    ...PointDefinitionAllOperand[]
];
export type PointDefinition4Modifier = [
    base1: number | LooseAutocomplete<BaseModifier>,
    base2: number | LooseAutocomplete<BaseModifier>,
    base3: number | LooseAutocomplete<BaseModifier>,
    base4: number | LooseAutocomplete<BaseModifier>,
    ...PointDefinitionAllOperand[]
];
export type FloatPointDefinition = PointDefinition1Base[] | PointDefinition1Modifier;
export type Vector3PointDefinition = (PointDefinition1Base | PointDefinition2Base | PointDefinition3Base)[] | PointDefinition1Modifier | PointDefinition2Modifier | PointDefinition3Modifier;
export type Vector4PointDefinition = (PointDefinition1Base | PointDefinition2Base | PointDefinition3Base | PointDefinition4Base)[] | PointDefinition1Modifier | PointDefinition2Modifier | PointDefinition3Modifier | PointDefinition4Modifier;
export type PointOperation = `op${'None' | 'Add' | 'Sub' | 'Mul' | 'Div'}`;
export type PointFlag = 'splineCatmullRom';
export type PointOption = 'lerpHSV' | Easings | PointFlag;
export type BaseModifierTransform = 'baseHeadPosition' | 'baseHeadLocalPosition' | 'baseHeadRotation' | 'baseHeadLocalRotation' | 'baseHeadLocalScale' | 'baseLeftHandPosition' | 'baseLeftHandLocalPosition' | 'baseLeftHandRotation' | 'baseLeftHandLocalRotation' | 'baseLeftHandLocalScale' | 'baseRightHandPosition' | 'baseRightHandLocalPosition' | 'baseRightHandRotation' | 'baseRightHandLocalRotation' | 'baseRightHandLocalScale';
export type BaseModifierColor = 'baseNote0Color' | 'baseNote1Color' | 'baseObstaclesColor' | 'baseSaberAColor' | 'baseSaberBColor' | 'baseEnvironmentColor0' | 'baseEnvironmentColor1' | 'baseEnvironmentColorW' | 'baseEnvironmentColor0Boost' | 'baseEnvironmentColor1Boost' | 'baseEnvironmentColorWBoost';
export type BaseModifierScoring = 'baseCombo' | 'baseMultipliedScore' | 'baseImmediateMaxPossibleMultipliedScore' | 'baseModifiedScore' | 'baseImmediateMaxPossibleModifiedScore' | 'baseRelativeScore' | 'baseMultiplier' | 'baseEnergy' | 'baseSongTime' | 'baseSongLength';
export type BaseModifier = BaseModifierTransform | BaseModifierColor | BaseModifierScoring;
//# sourceMappingURL=heck.d.ts.map