import type { LooseAutocomplete } from '../../utils.js';
import type { EnvironmentV3Name } from '../shared/environment.js';
import type { CharacteristicName } from '../shared/characteristic.js';
import type { DifficultyName, DifficultyRank } from '../shared/difficulty.js';
import type { EnvironmentName } from '../shared/environment.js';
import type { ICustomInfo, ICustomInfoDifficulty } from './custom/info.js';
export type GenericJSONFilename = `${DifficultyName}${CharacteristicName | ''}.json`;
/**
 * Schema for v1 `Info`.
 */
export interface IInfo extends ICustomInfo {
    songName: string;
    songSubName: string;
    authorName: string;
    beatsPerMinute: number;
    previewStartTime: number;
    previewDuration: number;
    coverImagePath: string;
    environmentName: EnvironmentName | EnvironmentV3Name;
    difficultyLevels: IInfoDifficulty[];
    oneSaber: boolean;
}
type DifficultyRankOld = 2 | 4 | 6 | 8 | 10;
/**
 * Schema for v1 `Info Difficulty`.
 */
export interface IInfoDifficulty extends ICustomInfoDifficulty {
    difficulty: DifficultyName;
    difficultyRank: DifficultyRankOld | DifficultyRank;
    audioPath: string;
    jsonPath: LooseAutocomplete<GenericJSONFilename>;
    characteristic: CharacteristicName;
}
export {};
//# sourceMappingURL=info.d.ts.map