import type { IChromaCustomEventDataAnimateTrack, IChromaCustomEventDataAssignFogTrack, IChromaCustomEventDataAssignPathAnimation } from './chroma.js';
import type { IHeckCustomEventDataAnimateTrack, IHeckCustomEventDataAssignPathAnimation } from './heck.js';
import type { INECustomEventDataAnimateTrack, INECustomEventDataAssignPathAnimation, INECustomEventDataAssignPlayerToTrack, INECustomEventDataAssignTrackParent } from './noodleExtensions.js';
export type ICustomEventDataAnimateTrack = IHeckCustomEventDataAnimateTrack & IChromaCustomEventDataAnimateTrack & INECustomEventDataAnimateTrack;
export type ICustomEventDataAssignPathAnimation = IHeckCustomEventDataAssignPathAnimation & IChromaCustomEventDataAssignPathAnimation & INECustomEventDataAssignPathAnimation;
/** Custom Event interface for AnimateTrack. */
export interface ICustomEventAnimateTrack {
    /**
     * **Type:** `f32`
     */
    _time: number;
    _type: 'AnimateTrack';
    _data: ICustomEventDataAnimateTrack;
}
/** Custom Event interface for AssignPathAnimation. */
export interface ICustomEventAssignPathAnimation {
    /**
     * **Type:** `f32`
     */
    _time: number;
    _type: 'AssignPathAnimation';
    _data: ICustomEventDataAssignPathAnimation;
}
/** Custom Event interface for InvokeEvent. */
/** Custom Event interface for AssignFogTrack. */
export interface ICustomEventAssignFogTrack {
    /**
     * **Type:** `f32`
     */
    _time: number;
    _type: 'AssignFogTrack';
    _data: IChromaCustomEventDataAssignFogTrack;
}
/** Custom Event interface for AssignTrackParent. */
export interface ICustomEventAssignTrackParent {
    /**
     * **Type:** `f32`
     */
    _time: number;
    _type: 'AssignTrackParent';
    _data: INECustomEventDataAssignTrackParent;
}
/** Custom Event interface for AssignPlayerToTrack. */
export interface ICustomEventAssignPlayerToTrack {
    /**
     * **Type:** `f32`
     */
    _time: number;
    _type: 'AssignPlayerToTrack';
    _data: INECustomEventDataAssignPlayerToTrack;
}
export type ICustomEvent = ICustomEventAnimateTrack | ICustomEventAssignPathAnimation | ICustomEventAssignFogTrack | ICustomEventAssignTrackParent | ICustomEventAssignPlayerToTrack;
//# sourceMappingURL=customEvent.d.ts.map