import type { IBookmark } from './bookmark.js';
import type { IBPMChange, IBPMChangeOld } from './bpmChange.js';
import type { IChromaCustomData } from './chroma.js';
import type { ICustomDataBase } from '../../shared/custom/customData.js';
import type { IPointDefinition } from './pointDefinition.js';
import type { ICustomEvent } from './customEvent.js';
/**
 * Custom data interface for difficulty file.
 */
export interface ICustomDataDifficulty extends ICustomDataBase, IChromaCustomData {
    /**
     * Time spent in editor.
     *
     * **Type:** `f32`
     */
    _time?: number;
    _customEvents?: ICustomEvent[];
    _pointDefinitions?: IPointDefinition[];
    _bpmChanges?: IBPMChangeOld[];
    _BPMChanges?: IBPMChange[];
    _bookmarks?: IBookmark[];
}
//# sourceMappingURL=difficulty.d.ts.map