import type { IEventBoxGroup } from './eventBoxGroup.js';
import type { IFxEventBox } from './fxEventBox.js';
/**
 * Schema for v3 `FX Event Box Group`.
 */
export interface IFxEventBoxGroup extends IEventBoxGroup<IFxEventBox> {
    /**
     * Type of FX event.
     * ```ts
     * 0 -> Int
     * 1 -> Float
     * 2 -> Bool
     * ```
     *
     * **Type:** `i32`
     */
    t?: 0 | 1 | 2;
}
//# sourceMappingURL=fxEventBoxGroup.d.ts.map