import type { SliderMidAnchorMode } from '../shared/constants.js';
import type { ICustomDataSlider } from '../v3/custom/slider.js';
import type { IItem } from './item.js';
/**
 * Schema for v4 `Arc`.
 */
export interface IArc extends IItem {
    /**
     * Head control point length multiplier of arc.
     *
     * Offset curve point from origin to the head direction of arc.
     *
     * **Type:** `f32`
     */
    m?: number;
    /**
     * Tail control point length multiplier of arc.
     *
     * Offset curve point to origin from the tail direction of arc.
     *
     * **Type:** `f32`
     */
    tm?: number;
    /**
     * Mid anchor mode of arc.
     * ```ts
     * 0 -> Straight
     * 1 -> Clockwise
     * 2 -> Counter-Clockwise
     * ```
     *
     * **NOTE:** The visual will only be applied under specific condition.
     *
     * **Type:** {@linkcode SliderMidAnchorMode}
     */
    a?: SliderMidAnchorMode;
    customData?: ICustomDataSlider;
}
//# sourceMappingURL=arc.d.ts.map