import type { EaseType } from '../shared/constants.js';
import type { IItem } from './item.js';
/**
 * Schema for v4 `Light Translation Event`.
 */
export interface ILightTranslationEvent extends IItem {
    /**
     * Use previous event translation value in light translation.
     *
     * **Type:** `i32`
     */
    p?: 0 | 1;
    /**
     * Ease type of light translation.
     *
     * **Type:** {@linkcode EaseType}
     */
    e?: EaseType;
    /**
     * Translation value of light translation.
     *
     * **Type:** `i32`
     */
    t?: number;
}
//# sourceMappingURL=lightTranslationEvent.d.ts.map