import type { IBasicEventTypesWithKeywords } from '../v3/basicEventTypesWithKeywords.js';
import type { IBasicEvent } from './basicEvent.js';
import type { IColorBoostEvent } from './colorBoostEvent.js';
import type { IEventBoxGroup } from './eventBoxGroup.js';
import type { IFxEventBox } from './fxEventBox.js';
import type { IFxEventFloat } from './fxEventFloat.js';
import type { IIndexFilter } from './indexFilter.js';
import type { IItem } from './item.js';
import type { ILightColorEvent } from './lightColorEvent.js';
import type { ILightColorEventBox } from './lightColorEventBox.js';
import type { ILightRotationEvent } from './lightRotationEvent.js';
import type { ILightRotationEventBox } from './lightRotationEventBox.js';
import type { ILightTranslationEvent } from './lightTranslationEvent.js';
import type { ILightTranslationEventBox } from './lightTranslationEventBox.js';
import type { IObject, IObjectLane } from './object.js';
import type { IWaypoint } from './waypoint.js';
/**
 * Schema for v4 `Lightshow`.
 */
export interface ILightshow extends IItem {
    version: '4.0.0';
    waypoints?: IObjectLane[];
    waypointsData?: IWaypoint[];
    basicEvents?: IObject[];
    basicEventsData?: IBasicEvent[];
    colorBoostEvents?: IObject[];
    colorBoostEventsData?: IColorBoostEvent[];
    eventBoxGroups?: IEventBoxGroup[];
    indexFilters?: IIndexFilter[];
    lightColorEventBoxes?: ILightColorEventBox[];
    lightColorEvents?: ILightColorEvent[];
    lightRotationEventBoxes?: ILightRotationEventBox[];
    lightRotationEvents?: ILightRotationEvent[];
    lightTranslationEventBoxes?: ILightTranslationEventBox[];
    lightTranslationEvents?: ILightTranslationEvent[];
    fxEventBoxes?: IFxEventBox[];
    floatFxEvents?: IFxEventFloat[];
    basicEventTypesWithKeywords?: IBasicEventTypesWithKeywords;
    useNormalEventsAsCompatibleEvents?: boolean;
}
//# sourceMappingURL=lightshow.d.ts.map