import type { ExecutionTime } from '../shared/constants.js';
import type { IWrapBaseObject } from './baseObject.js';
/**
 * Wrapper attribute for beatmap rotation event.
 */
export interface IWrapRotationEvent extends IWrapBaseObject {
    /**
     * Execution time of rotation event.
     * ```ts
     * 0 -> Early
     * 1 -> Late
     * ```
     *
     * **Type:** {@linkcode ExecutionTime}
     */
    executionTime: ExecutionTime;
    /**
     * Clockwise rotation value of rotation event.
     *
     * **Type:** `f32`
     */
    rotation: number;
}
//# sourceMappingURL=rotationEvent.d.ts.map