import type { ColorArray, ColorInput, ColorType } from '../../types/colors.js';
/**
 * Interpolate between colors and returns RGBA array.
 * ```ts
 * const rgba = lerpColor([90, 1, 1], [180, 1, 1], 0.5, 'hsva');
 * ```
 */
export declare function lerpColor(start: ColorInput, end: ColorInput, alpha: number, type?: ColorType): ColorArray;
/**
 * Calculate the delta E00 color difference between two colors.
 *
 * @see https://en.wikipedia.org/wiki/Color_difference
 */
export declare function deltaE00(rgbaAry1: ColorArray, rgbaAry2: ColorArray): number;
//# sourceMappingURL=helpers.d.ts.map