"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatNumber = formatNumber;
exports.isHex = isHex;
exports.hexToDec = hexToDec;
exports.decToHex = decToHex;
exports.hasFlag = hasFlag;
/**
 * Return number in formatted number string.
 *
 * ```ts
 * console.log(formatNumber(12345678)); // 12,345,678
 * ```
 */
function formatNumber(num) {
    return num
        .toString()
        .split('.')
        .map((str, i) => (i ? str : str.replace(/\B(?=(\d{3})+(?!\d))/g, ',')))
        .join('.');
}
/** Check if string is valid hexadecimal. */
function isHex(hex) {
    return /^[a-fA-F0-9]+$/g.test(hex);
}
/** Convert hexadecimal to decimal. */
function hexToDec(hex) {
    return parseInt(hex, 16);
}
/** Convert decimal to hexadecimal.*/
function decToHex(val) {
    const hex = val.toString(16);
    return hex;
}
/** Bitmask boolean helper. */
function hasFlag(val, flag) {
    return (val & flag) === flag;
}
