"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.tag = tag;
exports.handleWrite = handleWrite;
exports.handleWriteSync = handleWriteSync;
// deno-lint-ignore-file no-explicit-any
const _main_js_1 = require("../beatmap/saver/_main.js");
const globals_js_1 = require("../globals.js");
const _json_js_1 = require("../shims/_json.js");
const path_js_1 = require("../shims/path.js");
const defaultOptions = {
    directory: '',
    filename: '',
    format: 0,
    save: {},
};
function tag(name) {
    return ['writer', name];
}
function getFileName(type, data) {
    switch (type) {
        case 'lightshow':
            return data.lightshowFilename;
        default:
            return data.filename;
    }
}
function handleWrite(type, data, version, options = {}) {
    const ver = typeof version === 'number' ? version : null;
    const opt = (typeof version !== 'number' ? version : options) ?? {};
    const json = (0, _main_js_1.saveBeatmap)(type, data, ver, opt.save);
    return (0, _json_js_1.writeJSONFile)(path_js_1.path.resolve(opt.directory ?? (globals_js_1.globals.directory || defaultOptions.directory), opt.filename ?? (getFileName(type, data) || defaultOptions.filename)), json, opt.format).then(() => json);
}
function handleWriteSync(type, data, version, options = {}) {
    const ver = typeof version === 'number' ? version : null;
    const opt = (typeof version !== 'number' ? version : options) ?? {};
    const json = (0, _main_js_1.saveBeatmap)(type, data, ver, opt.save);
    (0, _json_js_1.writeJSONFileSync)(path_js_1.path.resolve(opt.directory ?? (globals_js_1.globals.directory || defaultOptions.directory), opt.filename ?? (getFileName(type, data) || defaultOptions.filename)), json, opt.format);
    return json;
}
