import type { InferBeatmap, InferBeatmapSerial, InferBeatmapVersion } from '../types/beatmap/shared/infer.js';
import type { IWriteOptions } from '../types/mod.js';
/**
 * Asynchronously write beatmap lightshow file.
 * ```ts
 * await writeLightshowFile(beatmap, 4);
 * ```
 */
export declare function writeLightshowFile<TVersion extends InferBeatmapVersion<'lightshow'>, TWrapper extends Record<string, any> = InferBeatmap<'lightshow'>, TSerial extends Record<string, any> = InferBeatmapSerial<'lightshow', TVersion>>(data: TWrapper, version?: TVersion | null, options?: IWriteOptions<'lightshow', TVersion, TWrapper, TSerial>): Promise<TSerial>;
export declare function writeLightshowFile<TVersion extends InferBeatmapVersion<'lightshow'>, TWrapper extends Record<string, any> = InferBeatmap<'lightshow'>, TSerial extends Record<string, any> = InferBeatmapSerial<'lightshow', TVersion>>(data: TWrapper, options?: IWriteOptions<'lightshow', TVersion, TWrapper, TSerial>): Promise<TSerial>;
/**
 * Synchronously write beatmap lightshow file.
 * ```ts
 * writeLightshowFileSync(beatmap, 4);
 * ```
 */
export declare function writeLightshowFileSync<TVersion extends InferBeatmapVersion<'lightshow'>, TWrapper extends Record<string, any> = InferBeatmap<'lightshow'>, TSerial extends Record<string, any> = InferBeatmapSerial<'lightshow', TVersion>>(data: TWrapper, version?: TVersion | null, options?: IWriteOptions<'lightshow', TVersion, TWrapper, TSerial>): TSerial;
export declare function writeLightshowFileSync<TVersion extends InferBeatmapVersion<'lightshow'>, TWrapper extends Record<string, any> = InferBeatmap<'lightshow'>, TSerial extends Record<string, any> = InferBeatmapSerial<'lightshow', TVersion>>(data: TWrapper, options?: IWriteOptions<'lightshow', TVersion, TWrapper, TSerial>): TSerial;
//# sourceMappingURL=lightshow.d.ts.map